c     Copyright (C) 2000, 2001, 2002, 2003, 2004, 2005
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      double precision function Planck(cpb,T,lambda1,lambda2)

      implicit none

      double precision in,c1,c2,T,lambda_c,lambda1,lambda2,B
      double precision intB,w1,w2
      integer Nb,Nq,band,quad,cpb
      real PLKAVG

c     Cette function calcule la luminance de Planck  une valeur de
c     la temprature et de la longueur d'onde
c
c     Entres :
c       + cpb=1 -> calcul au centre de la bande ; cpb=2 -> intgr sur la bande
c       + T : temprature en Kelvin
c       + lambda1 : longueur d'onde infrieure en micromtres
c       + lambda2 : longueur d'onde suprieure en micromtres
c
c     Sorties :
c       + Planck : valeur de la luminance du corps noir en W/m2/sr/m
c                  moyenne sur l'intervalle [lambda1,lambda2]
c

      lambda_c=(lambda1+lambda2)/2.0D+0
c     Si on demande de prendre la valeur de Planck au centre
c     de la bande troite
      if (cpb.eq.1) then
         Planck=B(T,lambda_c)
c     Sinon on demande d'intgrer Planck sur la bande troite
      else
         w1=1.0D+4/lambda2
         w2=1.0D+4/lambda1
         Planck=dble(PLKAVG(sngl(w1),sngl(w2),sngl(T)))
      endif


      return
      end




      function B(T,lambda)
      implicit none
c     
c     Luminance de Planck en une valeur de la longueur d'onde
c     et de la temprature
c
      double precision B,T,lambda
      double precision c1,c2,in
      include 'param_mc.inc'

      c1=2*pi*hPl*c0**2 ! W.m2
      c2=hPl*c0/kBz*1.D+6 ! m.K
      in=lambda*T
      if (T.eq.0) then
         B=0.0D+0
      else
         B=c1/(in**5*(dexp(c2/in)-1))*T**5*1.D+24/pi ! W/m2/sr/m
      endif

      return
      end
