      subroutine Tb(lambda,F,Tblack)
      implicit none
      include './param_mc.inc'
c
c     Purpose: to compute the blackbody temperature that emits
c     flux "B".
c
c     Inputs:
c       + lambda: wavelength (m)
c       + F: flux (W/m/m)
c     
c     Ouput:
c       + Tblack: temperature (K)
c
      double precision lambda,F,Tblack
      double precision c1,c2
      integer res

      c1=2*pi*hPl*c0**2*1.0D+24 ! W.m2
      c2=hPl*c0/kBz*1.D+6 ! m.K

      Tblack=c2/(lambda*dlog(c1/(lambda**5.0D+0*F)+1.0D+0))

c     Debug
      call test_nan(Tblack,res)
      if ((Tblack.le.0.0D+0).or.(res.eq.1)) then
         write(*,*) 'Error from routine Tb:'
         write(*,*) 'Tblack=',Tblack
         write(*,*) 'lambda=',lambda
         write(*,*) 'F=',F
         write(*,*) 'c1/(lambda^5*F)+1=',c1/(lambda**5.0D+0*F)+1.0D+0
         write(*,*) 'log=',dlog(c1/(lambda**5.0D+0*F)+1.0D+0)
         stop
      endif
c     Debug

      return
      end
