      program continue
      implicit none
c
c     Purpose: to compute the time difference between:
c     1 - the date at which a compilation command was issued
c     2 - the date at which the corresponding executable file was compiled
c
c     and return some code depending on this time difference
c      
      integer strlen
      integer*8 epoch_start,epoch_end,epoch_local,epoch_remote
      integer diff,i,max_diff,out,desync
      character*100 file_exec,file_test,command

c     --------------------------------------------------------------------------------------------------------------------------------------
c     Estimation of the time difference between the machine that hosts the hard drive
c     and the local machine (that executes commands). If the drive is a local hard drive,
c     this difference will be null.

      file_test='./time_test'
c     get the present date from the local host
      command='date +%s > epoch'
      call system(command(1:strlen(command)))
      open(10,file='./epoch')
      read(10,*) epoch_local
      close(10)
c     immediately after, modify a file on the remote disk
      command='touch ./'//file_test(1:strlen(file_test))
      call system(command(1:strlen(command)))
c     and get the modification date of this file
      call get_modification_date(file_test,epoch_remote)
c     compute time difference
      call diff_date(epoch_local,epoch_remote,desync)
c     Debug
      if (desync.lt.0) then
         write(*,*) 'epoch_local=',epoch_local
         write(*,*) 'epoch_remote=',epoch_remote
         write(*,*) 'desync=',desync,' s'
         stop
      endif
c     Debug
c     --------------------------------------------------------------------------------------------------------------------------------------
      
      max_diff=desync+10 ! maximum time difference authorized


c     --------------------------------------------------------------------------------------------------------------------------------------
c     Estimation of the time difference between the moment the compilation command
c     was issued at, and the moment the executable file was compiled at

c     the date the compilation command was issued at is stored in the "epoch0" file
      open(11,file='./epoch0')
      read(11,*) epoch_start
      close(11)

c     the date the executable file was compiled at has to be determined by the system
      open(12,file='./exec')
      read(12,*) file_exec
      close(12)

      call get_modification_date(file_exec,epoch_end)

      call diff_date(epoch_start,epoch_end,diff)
c     Debug
      write(*,*) 'epoch_start=',epoch_start
      write(*,*) 'epoch_end=',epoch_end
      write(*,*) 'diff=',diff
c     Debug
c     --------------------------------------------------------------------------------------------------------------------------------------

      if (diff.gt.max_diff) then
c     There was a problem: either the code was not compiled, or the clocks are not synchronized
c     between the machine that hosts the hard drive and the machine that compiles the executable file.
         out=0
      else
c     There was no problem: the executable file was compiled
         out=1
      endif
      open(15,file='./continue_out')
      write(15,*) out
      close(15)
      
      end
