      program convert_lambda
      implicit none
      include '../includes/param.inc'
      include '../includes/max.inc'

      integer i,band,m,Nb,Nq
      integer band_min,band_max,bf
      double precision e(0:Nmax)
      double precision dens(0:Nmax),capa(0:Nmax)
      double precision lambda_lo(1:Nbmx),no_lo(1:Nbmx)
      double precision lambda_hi(1:Nbmx),no_hi(1:Nbmx)
      double precision T(0:Nmax+1)
      double precision grav(0:Nmax)
      double precision temp(0:Nmax),Tsol,Tesp
      double precision alt(0:Nmax),pres(0:Nmax)
      double precision nbw(1:Nbmx)
      double precision lambda_min,lambda_max
      
c     Reading basic properties
      call read_atmos_data(m,Nb,Nq,e,lambda_lo,lambda_hi,dens,capa,
     &     grav,T,alt,temp,pres,Tsol,Tesp)
      do band=1,Nb
         no_lo(band)=1.0D+4/lambda_hi(band) ! cm
         no_hi(band)=1.0D+4/lambda_lo(band) ! cm
         nbw(band)=no_hi(band)-no_lo(band)  ! cm
      enddo

      open(11,file='lambda_min')
      read(11,*) lambda_min
      close(11)
      open(12,file='lambda_max')
      read(12,*) lambda_max
      close(12)

c     Some basic tests
      if (lambda_min.gt.lambda_max) then
         write(*,*) 'Error:'
         write(*,*) 'lambda_min=',lambda_min,
     &        ' < lambda_max=',lambda_max
         stop
      endif
      if (lambda_min.lt.lambda_lo(1)) then
         write(*,*) 'Error:'
         write(*,*) 'lambda_min=',lambda_min,
     &        ' < lambda_lo(1)=',lambda_lo(1)
         stop
      endif
      if (lambda_min.gt.lambda_hi(Nb)) then
         write(*,*) 'Error:'
         write(*,*) 'lambda_min=',lambda_min,
     &        ' > lambda_hi(',Nb,')=',lambda_hi(Nb)
         stop
      endif
      if (lambda_max.lt.lambda_lo(1)) then
         write(*,*) 'Error:'
         write(*,*) 'lambda_max=',lambda_max,
     &        ' < lambda_lo(1)=',lambda_lo(1)
         stop
      endif
      if (lambda_max.gt.lambda_hi(Nb)) then
         write(*,*) 'Error:'
         write(*,*) 'lambda_max=',lambda_max,
     &        ' > lambda_hi(',Nb,')=',lambda_hi(Nb)
         stop
      endif

c     Identification of band_min and band_max
      bf=0
      do band=1,Nb-1
         if ((lambda_min.ge.lambda_lo(band)).and.
     &        (lambda_min.le.lambda_hi(band))) then
            band_min=band
            write(*,*) 'band_min=',band_min
            bf=1
            goto 234
         endif
      enddo ! band
 234  continue
      if (bf.eq.0) then
         write(*,*) 'lambda_min=',lambda_min,' pas trouv'
         stop
      endif
      bf=0
      do band=1,Nb-1
         if ((lambda_max.ge.lambda_lo(band)).and.
     &        (lambda_max.le.lambda_hi(band))) then
            band_max=band
            write(*,*) 'band_max=',band_max
            bf=1
            goto 235
         endif
      enddo ! band
 235  continue
      if (bf.eq.0) then
         write(*,*) 'lambda_max=',lambda_max,' pas trouv'
         stop
      endif

      open(11,file='band_min')
      write(11,*) band_min
      close(11)
      open(12,file='band_max')
      write(12,*) band_max
      close(12)
      
      end
