#!/bin/bash

narg=$#

while read line
do
  bw=$line
done < "bw"

while read line
do
  path=$line
done < "tmp_dir"

if [ $1 = 'ka' -o $1 = 'phi' -o $1 = 'ks' -o $1 = 'albedo' -o $1 = 'g' -o $1 = 'tau' ] ; then

if [ -z $2 ] ; then
echo 'You must specify a second argument'
echo 'type "plot help" for more information'
echo 0 > out
exit
fi

# Gestion des incohrences
if [ $2 = 'total' -a $1 != 'albedo' -a $1 != 'g' ] ; then
echo 'No total for "' $1 '" data'
exit
fi
if [ $2 = 'co2' -o $2 = 'h2o' ] ; then
if [ $1 != 'ka' ] ; then
echo 'Only continuum absorption for' $2
exit
fi
fi

if  [ $narg -eq 2 ]
then

go=1

ctl='open '$path
draw='d '


# Suivant l'argument numro 1, on doit indiquer quelle est la
# chane de caractres 'tmp1', et copier le bon fichier dans 'rgb'
# et dans 'cl'
if [ $1 = 'ka' ] ; then
tmp1='ka_'
if [ $bw -eq 1 ] ; then
if [ $2 = 'gas' ] ; then
cp rgb_kag_bw rgb
cp cl_kag_bw cl
elif [ $2 = 'aerosol' ] ; then
cp rgb_kaa_bw rgb
cp cl_kaa_bw cl
elif [ $2 = 'cloud' ] ; then
cp rgb_kac_bw rgb
cp cl_kac_bw cl
fi
else
if [ $2 = 'gas' ] ; then
cp rgb_kag rgb
cp cl_kag cl
elif [ $2 = 'aerosol' ] ; then
cp rgb_kaa rgb
cp cl_kaa cl
elif [ $2 = 'cloud' ] ; then
cp rgb_kac rgb
cp cl_kac cl
fi
fi
title='abs. coeff.'
elif [ $1 = 'phi' ] ; then
tmp1='phi_eq_'
if [ $bw -eq 1 ] ; then
cp rgb_phi_eq_bw rgb
cp cl_phi_eq_bw cl
else
cp rgb_phi_eq rgb
cp cl_phi_eq cl
fi
title='overlap parameter'
elif [ $1 = 'ks' ] ; then
tmp1='kd_'
if [ $bw -eq 1 ] ; then
cp rgb_kdg_bw rgb
cp cl_kdg_bw cl
else
cp rgb_kdg rgb
cp cl_kdg cl
fi
title='scattering coeff.'
elif [ $1 = 'albedo' ] ; then
tmp1='omega_'
if [ $bw -eq 1 ] ; then
cp rgb_wg_bw rgb
cp cl_wg_bw cl
else
cp rgb_wg rgb
cp cl_wg cl
fi
title='albedo'
elif [ $1 = 'g' ] ; then
tmp1='g_'
if [ $bw -eq 1 ] ; then
cp rgb_gg_bw rgb
cp cl_gg_bw cl
else
cp rgb_gg rgb
cp cl_gg cl
fi
title='asym. param.'
elif [ $1 = 'tau' ] ; then
tmp1='tau_'
if [ $bw -eq 1 ] ; then
cp rgb_tauc_bw rgb
cp cl_tauc_bw cl
else
cp rgb_tauc rgb
cp cl_tauc cl
fi
title='opt. thichness'
else
echo 'No data relative to' $1
go=0
fi

if [ $go -eq 0 ] ; then
if [ $1 = 'kd' ] ; then
echo 'You probably mean "ks" for a scattering coefficient'
fi
if [ $1 = 'ksca' ] ; then
echo 'You probably mean "ks" for a scattering coefficient'
fi
if [ $1 = 'kabs' ] ; then
echo 'You probably mean "ka" for a absorption coefficient'
fi
if [ $1 = 'w' ] ; then
echo 'You probably mean "albedo" instead of "w"'
fi
if [ $1 = 'omega' ] ; then
echo 'You probably mean "albedo" instead of "omega"'
fi
if [ $1 = 'asym' ] ; then
echo 'You probably mean "g" instead of "asym"'
fi
echo $go > out
exit
fi
ctl=$ctl$tmp1
draw=$draw$tmp1


# Suivant l'argument numro 2, on doit spcifier la valeur de la
# chane de caractres 'tmp2'
if [ $2 = 'gas' ] ; then
tmp2='gaz'
title='draw title Gas '$title
elif [ $2 = 'aerosol' ] ; then
tmp2='aero'
title='draw title Aerosol '$title
elif [ $2 = 'cloud' ] ; then
tmp2='cloud'
title='draw title Cloud '$title
elif [ $2 = 'total' ] ; then
tmp2='tot'
title='draw title Total '$title
elif [ $2 = 'co2' ] ; then
tmp2='cont_co2'
title='draw title CO2 cont. '$title
elif [ $2 = 'h2o' ] ; then
tmp2='cont_h2o'
title='draw title H2O cont. '$title
else
echo 'No data relative to' $2
go=0
fi

if [ $go -eq 0 ] ; then
if [ $2 = 'gaz' ] ; then
echo 'You probably mean "gas" instead of "gaz"'
fi
if [ $2 = 'aero' ] ; then
echo 'You probably mean "aerosol" instead of "aero"'
fi
if [ $2 = 'tot' ] ; then
echo 'You probably mean "total" instead of "tot"'
fi
echo $go > out
exit
fi
ctl=$ctl$tmp2
ctl=$ctl'.ctl'

draw=$draw$tmp2

file=$tmp1$tmp2
t1='gxeps -c -i out.gx -o '$file'.ps'
t2='gzip -f '$file'.ps'
t3='gv --orientation=LANDSCAPE '$file'.ps.gz'
cp levNb lev
cp linesNb lines


#echo $ctl
#echo $draw
echo $ctl > ctl
echo $draw > d
echo $title > title
echo $t1 > t1
echo $t2 > t2
echo $t3 > t3
cat d title > dr
cat t0 t1 t2 t3 > t
cp c2 c
go=1

elif [ $narg -eq 3 ] 
then

if [ $1 = 'phi' -a $2 = 'band' -o $1 = 'phi' -a $2 = 'lambda' ] ; then
if [ $2 = 'band' ] ; then
echo $3 > 'band_min'
elif [ $2 = 'lambda' ] ; then
echo $3 > 'lambda_min'
echo $3 > 'lambda_max'
f8
convert_lambda.exe
read band_min < 'band_min'
read band_max < 'band_max'
fi
f5
extract_phi_eq.exe
title=''
if [ $2 = 'band' ] ; then
title=$title'set xlabel "Eq. overlap parameter band '$3'"'
elif [ $2 = 'lambda' ] ; then
title=$title'set xlabel "Eq. overlap parameter {/Symbol l}= '$3' {/Symbol m}m"'
fi
echo $title > gra_phibz1
cat gra_phibz1 gra_phibz2 > gra_phibz
cp gnu_phib graphe
go=2
fi

if [ $1 = 'ka' -a $2 = 'band' -o $1 = 'ka' -a $2 = 'lambda' ] ; then
if [ $2 = 'band' ] ; then
echo $3 > 'band_min'
elif [ $2 = 'lambda' ] ; then
echo $3 > 'lambda_min'
echo $3 > 'lambda_max'
f8
convert_lambda.exe
read band_min < 'band_min'
read band_max < 'band_max'
fi
f6
extract_ka.exe
title=''
if [ $2 = 'band' ] ; then
title=$title'set xlabel "average ka [m^{-1}] band '$3'"'
elif [ $2 = 'lambda' ] ; then
title=$title'set xlabel "average k_{a} [m^{-1}] at {/Symbol l}= '$3' {/Symbol m}m"'
fi
echo $title > gra_kabz1
cat gra_kabz1 gra_kabz2 > gra_kabz
title=''
if [ $2 = 'band' ] ; then
title=$title'set xlabel "average {/Symbol s} [m^{2}/kg] band '$3'"'
elif [ $2 = 'lambda' ] ; then
title=$title'set xlabel "average {/Symbol s} [m^{2}/kg] at {/Symbol l}= '$3' {/Symbol m}m"'
fi
echo $title > gra_sigmaz1
cat gra_sigmaz1 gra_sigmaz2 > gra_sigmaz

cp gnu_kab graphe
go=2
fi

fi

else

if [ $1 = 'temperature' ] ; then
cp gnu_temperature graphe
go=2
elif [ $1 = 'pressure' ] ; then
cp gnu_pressure graphe
go=2
fi


fi

echo $go > out
