      program extract_aero
      implicit none

      include '../includes/max.inc'
      include '../includes/param.inc'
      include '../includes/formats.inc'

      integer m,i,j,p,q,p1,band,quad,res,ok

      double precision e(0:Nmax),alt(0:Nmax),pres(0:Nmax),adia(0:Nmax)
      double precision temp(0:Nmax),Tsol,Tesp,dens(0:Nmax),grav(0:Nmax)
      double precision zeta(0:Nmax),capa(0:Nmax)
      double precision rho(1:Nmax)
      
      double precision ka_gaz(1:Nbmx,1:Nmax,1:Nqmx)
      double precision kd_gaz(1:Nbmx,1:Nmax,1:Nqmx)
      double precision k_gaz(1:Nbmx,1:Nmax,1:Nqmx)
      double precision w_gaz(1:Nbmx,1:Nmax,1:Nqmx)
      double precision g_gaz(1:Nbmx,1:Nmax,1:Nqmx)

      double precision ka_aero(1:Nbmx,1:Nmax,1:Nqmx)
      double precision kd_aero(1:Nbmx,1:Nmax,1:Nqmx)
      double precision k_aero(1:Nbmx,1:Nmax,1:Nqmx)
      double precision w_aero(1:Nbmx,1:Nmax,1:Nqmx)
      double precision g_aero(1:Nbmx,1:Nmax,1:Nqmx)

      double precision ka_cloud(1:Nbmx,1:Nmax,1:Nqmx)
      double precision kd_cloud(1:Nbmx,1:Nmax,1:Nqmx)
      double precision k_cloud(1:Nbmx,1:Nmax,1:Nqmx)
      double precision w_cloud(1:Nbmx,1:Nmax,1:Nqmx)
      double precision g_cloud(1:Nbmx,1:Nmax,1:Nqmx)

      double precision lambda_lo(1:Nbmx),lambda_hi(1:Nbmx)
      double precision w_moy(1:Nbmx,1:Nqmx)
      double precision em_sol(1:Nbmx),em_esp(1:Nbmx)

      double precision sum(1:Nbmx),tmp0(0:Nmax)
      double precision sigma_moy(1:Nbmx,1:Nmax)
      double precision ka_gaz_moy(1:Nbmx,1:Nmax)
      double precision kd_gaz_moy(1:Nbmx,1:Nmax)
      double precision phi_eq(1:Nbmx,1:Nmax)
      double precision denom,tmp1
      double precision w_tot(1:Nbmx,1:Nmax),g_tot(1:Nbmx,1:Nmax)
      character*100 file_ray_in,file_ray
      character*100 string_in
      integer lstin,strlen,Nb,Nq,ios
 22   format(a)
      
      file_ray_in='atmos_data.txt'

      open(10,file='data_dir')
      read(10,22) string_in
      close(10)
      call add_slash_if_absent(string_in)

      lstin=strlen(string_in)
      file_ray=string_in(1:lstin)//file_ray_in

c     Rcupration des donnes pour l'atmopshre
      open(10,file=file_ray(1:strlen(file_ray)),status='old',iostat=ios)
      if (ios.ne.0) then
         write(*,*) 'Error from program extract_data:'
         write(*,*) 'File not found:'
         write(*,*) file_ray(1:strlen(file_ray))
         stop
      endif
      read(10,*) m,Nb,Nq ! Lecture du nombre d'altitudes donnes dans le fichier, puis Nb et Nq
c     Test
c      close(10)
c      goto 333
c     Test
      read(10,50) (alt(i),i=0,m-1)
      read(10,50) (e(i),i=0,m)
      read(10,50) (pres(i),i=0,m-1)
      read(10,50) (temp(i),i=0,m-1),Tsol,Tesp
      read(10,50) (dens(i),i=0,m-1)
      read(10,50) (adia(i),i=0,m-1)
      read(10,50) (grav(i),i=0,m-1)
      read(10,50) (zeta(i),i=0,m-1)
      read(10,50) (capa(i),i=0,m-1)
c     Debug
c      write(*,*) 'ok1'
c     Debug
      do band=1,Nb
c     Debug
c         write(*,*) 'band=',band
c     Debug
         read(10,50) lambda_lo(band),lambda_hi(band),
     &        em_sol(band),em_esp(band),
     &        (w_moy(band,quad),quad=1,Nq)
c     Debug
c         write(*,*) 'band=',band,lambda_lo(band),lambda_hi(band),
c     &        em_sol(band),em_esp(band),
c     &        (w_moy(band,quad),quad=1,Nq)
c     Debug
         do quad=1,Nq           ! Lecture des paisseurs optiques de chaque couche
c     Debug
c         write(*,*) 'quad=',quad
c     Debug
            read(10,50) (k_gaz(band,i,quad),i=1,m)
            read(10,50) (ka_gaz(band,i,quad),i=1,m)
            read(10,50) (kd_gaz(band,i,quad),i=1,m)
            read(10,50) (w_gaz(band,i,quad),i=1,m)
            read(10,50) (g_gaz(band,i,quad),i=1,m)
            read(10,50) (k_aero(band,i,quad),i=1,m)
            read(10,50) (ka_aero(band,i,quad),i=1,m)
            read(10,50) (kd_aero(band,i,quad),i=1,m)
            read(10,50) (w_aero(band,i,quad),i=1,m)
            read(10,50) (g_aero(band,i,quad),i=1,m)
            read(10,50) (k_cloud(band,i,quad),i=1,m)
            read(10,50) (ka_cloud(band,i,quad),i=1,m)
            read(10,50) (kd_cloud(band,i,quad),i=1,m)
            read(10,50) (w_cloud(band,i,quad),i=1,m)
            read(10,50) (g_cloud(band,i,quad),i=1,m)
         enddo
      enddo
      close(10)

 333  continue

      do i=1,m
         do band=1,Nb
            ka_gaz_moy(band,i)=0.0D+0
            kd_gaz_moy(band,i)=0.0D+0
            tmp1=0.0D+0
            do quad=1,Nq
               ka_gaz_moy(band,i)=ka_gaz_moy(band,i)+
     &              w_moy(band,quad)*ka_gaz(band,i,quad)
               kd_gaz_moy(band,i)=kd_gaz_moy(band,i)+
     &              w_moy(band,quad)*kd_gaz(band,i,quad)
               tmp1=tmp1+ka_gaz(band,i,quad)**2*w_moy(band,quad)
            enddo ! sur quad
            phi_eq(band,i)=1.0D+0/(tmp1/ka_gaz_moy(band,i)**2-1.0D+0)
         enddo ! sur band
      enddo ! sur i

c     ---------------------
c     Sorties fichiers
c     ---------------------

c     Les coefficients d'absorption
      open(10,file='./ka_gaz_moy.txt') ! ka du gaz moyen sur une bande
      do band=1,Nb
         write(10,'(1p(100e11.3))') (ka_gaz_moy(band,i),i=1,m)
      enddo
      close(10)
      open(10,file='./ka_aero.txt') ! ka des arosols par bande
      quad=1
      do band=1,Nb
         write(10,'(1p(100e11.3))') (ka_aero(band,i,quad),i=1,m)
      enddo
      close(10)
      open(10,file='./ka_cloud.txt') ! ka des nuages par bande
      quad=1
      do band=1,Nb
         write(10,'(1p(100e11.3))') (ka_cloud(band,i,quad),i=1,m)
      enddo
      close(10)

c     Le paramtre de forme quivalent
      ok=1
      do band=1,Nb
         do i=1,m
            call test_nan(phi_eq(band,i),res)
            if (res.eq.1) then
               ok=0
            endif
            if (phi_eq(band,i).gt.1.0D+30) then
               ok=0
            endif
         enddo ! i
      enddo ! band

      open(10,file='./phi_eq.txt')
      do band=1,Nb
         if (ok.eq.1) then
            write(10,'(1p(100e11.3))') (phi_eq(band,i),i=1,m)
         else
            write(10,'(1p(100e11.3))') (0.0D+0,i=1,m)
         endif
      enddo
      close(10)

c     Les coefficients de diffusion
      open(10,file='./kd_gaz_moy.txt') ! kd du gaz par bande
      quad=1
      do band=1,Nb
         write(10,'(1p(100e11.3))') (kd_gaz_moy(band,i),i=1,m)
      enddo
      close(10)
      open(10,file='./kd_aero.txt') ! kd des arosols par bande
      quad=1
      do band=1,Nb
         write(10,'(1p(100e11.3))') (kd_aero(band,i,quad),i=1,m)
      enddo
      close(10)
      open(10,file='./kd_cloud.txt') ! kd des nuages par bande
      quad=1
      do band=1,Nb
         write(10,'(1p(100e11.3))') (kd_cloud(band,i,quad),i=1,m)
      enddo
      close(10)

      open(10,file='./k_cloud.txt') ! ka des nuages par bande
      quad=1
      do band=1,Nb
         write(10,'(1p(100e11.3))') (ka_cloud(band,i,quad)+
     &        kd_cloud(band,i,quad),i=1,m)
      enddo
      close(10)

c     Les albdos de diffusion simple
      open(11,file='./albedo_gaz.txt') ! Albedo du gaz, par bande
      quad=1
      do band=1,Nb
         write(11,'(1p(100e11.3))') (w_gaz(band,i,quad),i=1,m)
      enddo
      close(11)
      open(11,file='./albedo_aero.txt') ! Albedo des arosols, par bande
      quad=1
      do band=1,Nb
         write(11,'(1p(100e11.3))') (w_aero(band,i,quad),i=1,m)
      enddo
      close(11)
      open(11,file='./albedo_cloud.txt') ! Albedo des nuages, par bande
      quad=1
      do band=1,Nb
         write(11,'(1p(100e11.3))') (w_cloud(band,i,quad),i=1,m)
      enddo
      close(11)
      open(11,file='./albedo_total.txt') ! Albedo total (nuages+arosols), par bande
      quad=1
      do band=1,Nb
         do i=1,m
            denom=k_gaz(band,i,quad)+k_aero(band,i,quad)+
     &        k_cloud(band,i,quad)
            if (denom.ne.0.0D+0) then
               w_tot(band,i)=(kd_gaz(band,i,quad)+kd_aero(band,i,quad)+
     &        kd_cloud(band,i,quad))/denom
            else
               w_tot(band,i)=0.0D+0
            endif
         enddo
         write(11,'(1p(100e11.3))') (w_tot(band,i),i=1,m)            
      enddo
      close(11)

c     Les coefficients d'asymtrie
      open(11,file='./g_gaz.txt') ! g du gaz, par bande
      quad=1
      do band=1,Nb
         write(11,'(1p(100e11.3))') (g_gaz(band,i,quad),i=1,m)
      enddo
      close(11)
      open(11,file='./g_aero.txt') ! g des arosols, par bande
      quad=1
      do band=1,Nb
         write(11,'(1p(100e11.3))') (g_aero(band,i,quad),i=1,m)
      enddo
      close(11)
      open(11,file='./g_cloud.txt') ! g des nuages, par bande
      quad=1
      do band=1,Nb
         write(11,'(1p(100e11.3))') (g_cloud(band,i,quad),i=1,m)
      enddo
      close(11)
      open(11,file='./g_total.txt') ! g total (nuages+arosols), par bande
      quad=1
      do band=1,Nb
         do i=1,m
            denom=kd_gaz(band,i,quad)+kd_aero(band,i,quad)+
     &           kd_cloud(band,i,quad)
            if (denom.ne.0.0D+0) then
               g_tot(band,i)=(kd_gaz(band,i,quad)*g_gaz(band,i,quad)+
     &              kd_aero(band,i,quad)*g_aero(band,i,quad)+
     &              kd_cloud(band,i,quad)*g_cloud(band,i,quad))
     &              /denom
            else
               g_tot(band,i)=0.0D+0
            endif
         enddo
         write(11,'(1p(100e11.3))') (g_tot(band,i),i=1,m)
      enddo
      close(11)
      

      end
