      program extract_dflux_band
      implicit none

      include '../includes/param.inc'
      include '../includes/max.inc'

c     This program extracts the relevant data in "Flux_nets_mono-nu_theo.txt"
c     files, and creates ner differences files that will be used
c     by Grads scripts.

      integer i,j,irec,band,quad,k,m,Nb,Nq,out
      integer strlen
      integer band_min,band_max
      real*4 tmp
      double precision e(0:Nmax),raf
      double precision grav(0:Nmax)
      double precision dens(0:Nmax),capa(0:Nmax)
      double precision lambda_c(1:Nbmx),no_c(1:Nbmx)
      double precision lambda_lo(1:Nbmx),no_lo(1:Nbmx)
      double precision lambda_hi(1:Nbmx),no_hi(1:Nbmx)
      double precision nbw(1:Nbmx)
      double precision sum_bFnet(0:Nmax)
      double precision sum_bFnet2(0:Nmax)
      double precision dsum_bFnet(0:Nmax)
      double precision bFnet(0:Nmax),bFnet2(0:Nmax)
      double precision T(0:Nmax+1)
      character*100 string_res,string_res2,st
      character*100 file_res,file_res2,file
      double precision temp(0:Nmax),Tsol,Tesp
      double precision alt(0:Nmax),pres(0:Nmax)
 22   format(a)
      
      out=0 ! no problem at execution
c     Reading basic properties
      call read_atmos_data(m,Nb,Nq,e,lambda_lo,lambda_hi,dens,capa,
     &     grav,T,alt,temp,pres,Tsol,Tesp)
      do band=1,Nb
         no_lo(band)=1.0D+4/lambda_hi(band) ! cm
         no_hi(band)=1.0D+4/lambda_lo(band) ! cm
         nbw(band)=no_hi(band)-no_lo(band)  ! cm
      enddo

      open(10,file='band_min')
      read(10,*) band_min
      close(10)
      open(11,file='band_max')
      read(11,*) band_max
      close(11)


      if (band_max.lt.band_min) then
         write(*,*) 'Warning: band_max=',band_max
         write(*,*) 'is lower than band_min=',band_min
         out=1 ! problem detected
      else if (band_min.lt.1) then
         write(*,*) 'Warning: band_min=',band_min
         write(*,*) 'is lower than 1'
         out=1
      else if (band_max.gt.Nb) then
         write(*,*) 'Warning: band_max=',band_max
         write(*,*) 'is greater than Nb=',Nb
         out=1
      endif
      if (out.eq.1) then
         goto 123
      endif

      open(11,file='results_dir')
      read(11,22) string_res
      close(11)
      open(12,file='results_dir2')
      read(12,22) string_res2
      close(12)
      open(13,file='file_flux')
      read(13,*) file
      close(13)


c     Reading the appropriate flux file in results folder 1
c      file_res=string_res(1:strlen(string_res))
c     &     //'/Flux_nets_mono-nu.txt'
      file_res=string_res(1:strlen(string_res))//'/'//
     &     file(1:strlen(file))
      open(12,file=file_res)
      read(12,*) ! m,Nb
      do band=1,band_min-1
         read(12,*) ! lambda_lo(band),lambda_hi(band)
         read(12,*) ! (bFnet(i),i=0,m)
         read(12,*) ! (-bFnet_pne(i),i=0,m)
      enddo ! band
      do i=0,m
         sum_bFnet(i)=0.0D+0
      enddo ! i
      do band=band_min,band_max
         read(12,*) ! lambda_lo(band),lambda_hi(band)
         read(12,*) (bFnet(i),i=0,m) ! W/m/cm
         read(12,*) ! (-bFnet_pne(i),i=0,m)
         do i=0,m
            sum_bFnet(i)=sum_bFnet(i)+bFnet(i)*nbw(band) ! W/m
         enddo ! i
      enddo ! band
         
      close(12)


c     Reading the appropriate flux file in results folder 2
c      file_res=string_res2(1:strlen(string_res2))
c     &     //'/Flux_nets_mono-nu.txt'
      file_res=string_res2(1:strlen(string_res2))//'/'//
     &     file(1:strlen(file))
      open(12,file=file_res)
      read(12,*) ! m,Nb
      do band=1,band_min-1
         read(12,*) ! lambda_lo(band),lambda_hi(band)
         read(12,*) ! (bFnet(i),i=0,m)
         read(12,*) ! (-bFnet_pne(i),i=0,m)
      enddo ! band
      do i=0,m
         sum_bFnet2(i)=0.0D+0
      enddo ! i
      do band=band_min,band_max
         read(12,*) ! lambda_lo(band),lambda_hi(band)
         read(12,*) (bFnet2(i),i=0,m) ! W/m/cm
         read(12,*) ! (-bFnet_pne(i),i=0,m)
         do i=0,m
            sum_bFnet2(i)=sum_bFnet2(i)+bFnet2(i)*nbw(band) ! W/m
         enddo ! i
      enddo ! band
         
      close(12)

c     Debug
c      do i=0,m
c         write(*,*) e(i),bFnet(i),bFnet2(i)
c      enddo
c     Debug

      
c     Computing difference
      do i=0,m
         dsum_bFnet(i)=sum_bFnet2(i)-sum_bFnet(i)
      enddo ! i

c     Record files

      open(13,file='flux_netb.txt')
      do i=0,m
         write(13,*) e(i)/1.0D+3,bFnet(i)
      enddo
      close(13)
      
      open(14,file='diff_flux_netb.txt')
      do i=0,m
         write(14,*) e(i)/1.0D+3,dsum_bFnet(i)
      enddo
      close(14)

 123  continue
      open(10,file='out')
      write(10,*) out
      close(10)

      end
