      program extract_dflux_band
      implicit none

      include '../includes/param.inc'
      include '../includes/max.inc'

c     This program extracts the relevant data in "Flux_nets_mono-nu_theo.txt"
c     files, and creates ner differences files that will be used
c     by Grads scripts.

      integer i,j,irec,band,quad,k,m,Nb,Nq,out
      integer strlen,i1
      real*4 tmp
      double precision e(0:Nmax),raf,zflux,z1,z2
      double precision dens(0:Nmax),capa(0:Nmax)
      double precision lambda_c(1:Nbmx),no_c(1:Nbmx)
      double precision lambda_lo(1:Nbmx),no_lo(1:Nbmx)
      double precision lambda_hi(1:Nbmx),no_hi(1:Nbmx)
      double precision nbw(1:Nbmx)
      double precision grav(0:Nmax)
      double precision bFnet(0:Nmax),bFnet2(0:Nmax)
      double precision Fnet_z1(1:Nbmx)
      double precision Fnet_z2(1:Nbmx)
      double precision Fnet2_z1(1:Nbmx)
      double precision Fnet2_z2(1:Nbmx)
      double precision Fnet(1:Nbmx)
      double precision Fnet2(1:Nbmx)
      double precision dFnet(1:Nbmx)
      double precision T(0:Nmax+1)
      character*100 string_res,string_res2,st
      character*100 file_res,file_res2,file
      double precision temp(0:Nmax),Tsol,Tesp
      double precision alt(0:Nmax),pres(0:Nmax)
 22   format(a)
      
      out=0 ! no problem at execution
c     Reading basic properties
      call read_atmos_data(m,Nb,Nq,e,lambda_lo,lambda_hi,dens,capa,
     &     grav,T,alt,temp,pres,Tsol,Tesp)
      do band=1,Nb
         no_lo(band)=1.0D+4/lambda_hi(band) ! cm
         no_hi(band)=1.0D+4/lambda_lo(band) ! cm
         nbw(band)=no_hi(band)-no_lo(band)  ! cm
      enddo

      open(10,file='zflux')
      read(10,*) zflux
c     'zflux' should be given in km
c     it has therefore to be converted in meters
      close(10)
      zflux=zflux*1.0D+3

      if (zflux.lt.e(0)) then
         write(*,*) 'Warning: z=',zflux
         out=1
      endif
      if (zflux.gt.e(m)) then
         write(*,*) 'Warning: z=',zflux
         out=1
      endif
      if (out.eq.1) then
         goto 123
      endif

      open(11,file='results_dir')
      read(11,22) string_res
      close(11)
      open(12,file='results_dir2')
      read(12,22) string_res2
      close(12)
      open(13,file='file_flux')
      read(13,*) file
      close(13)

c     Identification of the layer where 'z' is included
      do i=1,m
         if ((zflux.ge.e(i-1)).and.(zflux.le.e(i))) then
            i1=i
            z1=e(i-1)
            z2=e(i)
            goto 321
         endif
      enddo
 321  continue
c     'i1' is the index of the atmospheric layer where altitude 'zlfux' lies
c     z1 and z2 are the altitudes of layer 'i1' interfaces

c     Reading the appropriate flux file in results folder 1
      file_res=string_res(1:strlen(string_res))
     &     //'/'//file(1:strlen(file))
      open(12,file=file_res)
      read(12,*) ! m,Nb
      do band=1,Nb
         read(12,*) ! lambda_lo(band),lambda_hi(band)
         read(12,*) (bFnet(i),i=0,m) ! W/m/cm
         read(12,*) ! (-bFnet_pne(i),i=0,m)
         Fnet_z1(band)=bFnet(i1-1)
         Fnet_z2(band)=bFnet(i1)
      enddo ! band
      close(12)

c     Reading the appropriate flux file in results folder 2
      file_res=string_res2(1:strlen(string_res2))
     &     //'/'//file(1:strlen(file))
      open(12,file=file_res)
      read(12,*) ! m,Nb
      do band=1,Nb
         read(12,*) ! lambda_lo(band),lambda_hi(band)
         read(12,*) (bFnet2(i),i=0,m) ! W/m/cm
         read(12,*) ! (-bFnet_pne(i),i=0,m)
         Fnet2_z1(band)=bFnet2(i1-1)
         Fnet2_z2(band)=bFnet2(i1)
      enddo ! band
      close(12)

c     Interpolation of fluxes at altitude 'zflux'
      do band=1,Nb
         Fnet(band)=Fnet_z1(band)+(Fnet_z2(band)-Fnet_z1(band))/
     &        (z2-z1)*(zflux-z1) ! W/m/cm
         Fnet2(band)=Fnet2_z1(band)+(Fnet2_z2(band)-Fnet2_z1(band))/
     &        (z2-z1)*(zflux-z1) ! W/m/cm
      enddo ! band

      
c     Computing difference
      do band=1,Nb
         dFnet(band)=Fnet2(band)-Fnet(band) ! W/m/cm
      enddo ! band

c     Record files

      open(13,file='flux_netz.txt')
c     col. 1: lambda infrieure de la bande (m)
c     col. 2: nombre d'onde sup. de la bande (cm)
c     col. 3: flux net dans la bande en W/m/m
c     col. 4: incertitude en W/m/m
c     col. 5: flux net dans la bande en mW/m/cm
c     col. 6: incertitude en mW/m/cm
      write(13,*) lambda_lo(1),no_hi(1),
     &     0.0D+0,0.0D+0,
     &     0.0D+0,0.0D+0
      do band=1,Nb
         write(13,*) lambda_lo(band),no_hi(band),
     &        Fnet(band)*(no_hi(band)-no_lo(band))
     &        /(lambda_hi(band)-lambda_lo(band)),0.0D+0,
     &        Fnet(band)*1.0D+3,0.0D+0
         write(13,*) lambda_hi(band),no_lo(band),
     &        Fnet(band)*(no_hi(band)-no_lo(band))
     &        /(lambda_hi(band)-lambda_lo(band)),0.0D+0,
     &        Fnet(band)*1.0D+3,0.0D+0
      enddo
      close(13)
      
      open(14,file='diff_flux_netz.txt')
c     col. 1: lambda infrieure de la bande (m)
c     col. 2: nombre d'onde sup. de la bande (cm)
c     col. 3: flux net dans la bande en W/m/m
c     col. 4: incertitude en W/m/m
c     col. 5: flux net dans la bande en mW/m/cm
c     col. 6: incertitude en mW/m/cm
      write(14,*) lambda_lo(1),no_hi(1),
     &     0.0D+0,0.0D+0,
     &     0.0D+0,0.0D+0
      do band=1,Nb
         write(14,*) lambda_lo(band),no_hi(band),
     &        dFnet(band)*(no_hi(band)-no_lo(band))
     &        /(lambda_hi(band)-lambda_lo(band)),0.0D+0,
     &        dFnet(band)*1.0D+3,0.0D+0
         write(14,*) lambda_hi(band),no_lo(band),
     &        dFnet(band)*(no_hi(band)-no_lo(band))
     &        /(lambda_hi(band)-lambda_lo(band)),0.0D+0,
     &        dFnet(band)*1.0D+3,0.0D+0
      enddo
      close(14)

 123  continue
      open(10,file='out')
      write(10,*) out
      close(10)

      end
