      program extract_dner_band
      implicit none

      include '../includes/param.inc'
      include '../includes/max.inc'

c     This program extracts the relevant data in "PNE_mono-nu_theo.txt"
c     files, and creates ner differences files that will be used
c     by Grads scripts.

      integer i,j,irec,band,quad,k,m,Nb,Nq,out
      integer strlen,res
      integer band_min,band_max,sign,sign_default
      real*4 tmp
      double precision e(0:Nmax),raf,Ti,Tj,Planck
      double precision dens(0:Nmax),capa(0:Nmax)
      double precision lambda_c(1:Nbmx),no_c(1:Nbmx)
      double precision lambda_lo(1:Nbmx),no_lo(1:Nbmx)
      double precision lambda_hi(1:Nbmx),no_hi(1:Nbmx)
      double precision nbw(1:Nbmx)
      double precision grav(0:Nmax)
      double precision sum_pneb(0:Nmax+1,0:Nmax+1)
      double precision sum_pneb2(0:Nmax+1,0:Nmax+1)
      double precision dsum_pneb(0:Nmax+1,0:Nmax+1)
      double precision sum_ksib(0:Nmax+1,0:Nmax+1)
      double precision sum_ksib2(0:Nmax+1,0:Nmax+1)
      double precision dsum_ksib(0:Nmax+1,0:Nmax+1)
      double precision Bi,Bj
      double precision pneb(0:Nmax+1,0:Nmax+1)
      double precision pneb2(0:Nmax+1,0:Nmax+1)
      double precision T(0:Nmax+1)
      character*100 string_res,string_res2,st
      character*100 file_res,file_res2
      double precision temp(0:Nmax),Tsol,Tesp
      double precision alt(0:Nmax),pres(0:Nmax)
      double precision max,min
      parameter(min=1.0D-8)
      parameter(max=1.0D+30)
      double precision pne_min,pne_max
      integer nlevels_pne,shift_ner_levels,bw,ncolors_ner
      integer ncolors_ner_min,ncolors_ner_max,ncolors_ner_default
      character*100 file_out
      integer recombine,recombine_default
 22   format(a)

      ncolors_ner_min=3
      ncolors_ner_max=7
      ncolors_ner_default=4
      recombine_default=0
      sign_default=1

      open(10,file='./ncolors_ner')
      read(10,*) ncolors_ner
      close(10)
      if (ncolors_ner.lt.ncolors_ner_min) then
         ncolors_ner=ncolors_ner_min
      else if (ncolors_ner.gt.ncolors_ner_max) then
         ncolors_ner=ncolors_ner_max
      endif
      if (ncolors_ner.lt.0) then
         ncolors_ner=ncolors_ner_default
      endif

      open(14,file='./ner_levels_increase')
      read(14,*) shift_ner_levels
      close(14)

      open(15,file='./recombine')
      read(15,*) recombine
      close(15)
      if ((recombine.ne.0).and.(recombine.ne.1)) then
         recombine=recombine_default
      endif

      open(16,file='./sign')
      read(16,*) sign
      close(16)
      if ((sign.ne.-1).and.(sign.ne.1)) then
         sign=sign_default
      endif

c     Dfinition des nombres de niveaux (de couleurs) dans les matrices
c     Matrice des PNE intgre:
      nlevels_pne=ncolors_ner
      
      open(11,file='./bw')
      read(11,*) bw
      close(11)

      out=0 ! no problem at execution
c     Reading basic properties
      call read_atmos_data(m,Nb,Nq,e,lambda_lo,lambda_hi,dens,capa,
     &     grav,T,alt,temp,pres,Tsol,Tesp)
      do band=1,Nb
         no_lo(band)=1.0D+4/lambda_hi(band) ! cm
         no_hi(band)=1.0D+4/lambda_lo(band) ! cm
         nbw(band)=no_hi(band)-no_lo(band)  ! cm
      enddo

      open(10,file='band_min')
      read(10,*) band_min
      close(10)
      open(11,file='band_max')
      read(11,*) band_max
      close(11)
c     Debug
c      write(*,*) 'band_min=',band_min
c      write(*,*) 'band_max=',band_max
c     Debug

      if (band_max.lt.band_min) then
         write(*,*) 'Warning: band_max=',band_max
         write(*,*) 'is lower than band_min=',band_min
         out=1 ! problem detected
      else if (band_min.lt.1) then
         write(*,*) 'Warning: band_min=',band_min
         write(*,*) 'is lower than 1'
         out=1
      else if (band_max.gt.Nb) then
         write(*,*) 'Warning: band_max=',band_max
         write(*,*) 'is greater than Nb=',Nb
         out=1
      endif
      if (out.eq.1) then
         goto 123
      endif

      open(11,file='results_dir')
      read(11,22) string_res
      close(11)
      open(12,file='results_dir2')
      read(12,22) string_res2
      close(12)

c     Reading the appropriate ner matrixes in results folder 1
      if (recombine.eq.0) then
         file_res=string_res(1:strlen(string_res))
     &        //'PNE_mono-nu_theo.txt'
      else
         file_res=string_res(1:strlen(string_res))
     &        //'rPNE_mono-nu_theo.txt'
      endif
      open(12,file=file_res)
      read(12,*) ! m,Nb
      do band=1,band_min-1
         read(12,*) ! lambda_lo(band),lambda_hi(band)
         do i=0,m+1
            read(12,*) ! (pneb(i,j),j=0,m+1)
         enddo ! i
      enddo ! band
      do i=0,m+1
         do j=0,m+1
            sum_pneb(i,j)=0.0D+0
            sum_ksib(i,j)=0.0D+0
         enddo ! j
      enddo ! i
      do band=band_min,band_max
c     Debug
c         do i=0,m+1
c            write(*,*) 'T(',i,')=',T(i)
c         enddo
c     Debug
         read(12,*) ! lambda_lo(band),lambda_hi(band)
         do i=0,m+1
            Bi=pi*Planck(1,T(i),lambda_lo(band),lambda_hi(band)) ! W/m/m
            read(12,*) (pneb(i,j),j=0,m+1) ! W/m/cm
            do j=0,m+1
               Bj=pi*Planck(1,T(j),lambda_lo(band),lambda_hi(band)) ! W/m/m
               sum_pneb(i,j)=sum_pneb(i,j)+pneb(i,j)*nbw(band) ! W/m
               if (i.ne.j) then
                  sum_ksib(i,j)=sum_ksib(i,j)+pneb(i,j)*nbw(band)/
     &                 ((Bi-Bj)*(lambda_hi(band)-lambda_lo(band))) ! unitless
c     Debug
c                  write(*,*) 'pneb(',i,',',j,')=',pneb(i,j)
c                  write(*,*) 'sum_ksib(',i,',',j,')=',sum_ksib(i,j)
c     Debug
               endif
            enddo ! j
         enddo ! i
      enddo ! band
         
      close(12)


c     Reading the appropriate ner matrixes in results folder 2
      if (recombine.eq.0) then
         file_res=string_res2(1:strlen(string_res2))
     &        //'PNE_mono-nu_theo.txt'
      else
         file_res=string_res2(1:strlen(string_res2))
     &        //'rPNE_mono-nu_theo.txt'
      endif
      open(12,file=file_res)
      read(12,*) ! m,Nb
      do band=1,band_min-1
         read(12,*) ! lambda_lo(band),lambda_hi(band)
         do i=0,m+1
            read(12,*) ! (pneb(i,j),j=0,m+1)
         enddo ! i
      enddo ! band
      do i=0,m+1
         do j=0,m+1
            sum_pneb2(i,j)=0.0D+0
            sum_ksib2(i,j)=0.0D+0
         enddo ! j
      enddo ! i
      do band=band_min,band_max
         read(12,*) ! lambda_lo(band),lambda_hi(band)
         do i=0,m+1
            Bi=pi*Planck(1,T(i),lambda_lo(band),lambda_hi(band)) ! W/m/m
            read(12,*) (pneb2(i,j),j=0,m+1) ! W/m/cm
            do j=0,m+1
               Bj=pi*Planck(1,T(j),lambda_lo(band),lambda_hi(band)) ! W/m/m
               sum_pneb2(i,j)=sum_pneb2(i,j)+pneb2(i,j)*nbw(band) ! W/m
               if (i.ne.j) then
                  sum_ksib2(i,j)=sum_ksib2(i,j)+pneb2(i,j)*nbw(band)/
     &                 ((Bi-Bj)*(lambda_hi(band)-lambda_lo(band))) ! unitless
               endif
            enddo ! j
         enddo ! i
      enddo ! band
      
      close(12)


c     NaN or INF test
      do i=0,m+1
         do j=0,m+1
            call test_nan(sum_ksib(i,j),res)
            if (res.eq.1) then
               sum_ksib(i,j)=0.0D+0
            endif
            call test_nan(sum_ksib2(i,j),res)
            if (res.eq.1) then
               sum_ksib2(i,j)=0.0D+0
            endif
            if (dabs(sum_ksib(i,j)).gt.max) then
               sum_ksib(i,j)=0.0D+0
            endif
            if (dabs(sum_ksib2(i,j)).gt.max) then
               sum_ksib2(i,j)=0.0D+0
            endif
         enddo ! j
      enddo ! i

c     Symetry test
      do i=0,m+1
         do j=i+1,m+1
            if (dabs(sum_ksib(i,j)/sum_ksib(j,i)-1.0D+0).gt.min) then
               write(*,*) 'sum_ksib(',i,',',j,')=',sum_ksib(i,j)
               write(*,*) 'sum_ksib(',j,',',i,')=',sum_ksib(j,i)
               stop
            endif
            if (dabs(sum_ksib2(i,j)/sum_ksib2(j,i)-1.0D+0).gt.min) then
               write(*,*) 'sum_ksib2(',i,',',j,')=',sum_ksib2(i,j)
               write(*,*) 'sum_ksib2(',j,',',i,')=',sum_ksib2(j,i)
               stop
            endif
         enddo ! j
      enddo ! j

c     Computing differences
      do i=0,m+1
         do j=0,m+1
            dsum_pneb(i,j)=sum_pneb2(i,j)-sum_pneb(i,j) ! W/m
            if (i.eq.j) then
               dsum_ksib(i,j)=0.0D+0
            else
               dsum_ksib(i,j)=sum_ksib2(i,j)-sum_ksib(i,j) ! unitless
            endif
         enddo ! j
      enddo ! i

c     Symetry test
      do i=0,m+1
         do j=i+1,m+1
            if (dabs(dsum_ksib(i,j)/dsum_ksib(j,i)-1.0D+0).gt.min) then
               write(*,*) 'dsum_ksib(',i,',',j,')=',dsum_ksib(i,j)
               write(*,*) 'dsum_ksib(',j,',',i,')=',dsum_ksib(j,i)
               stop
            endif
         enddo ! j
      enddo ! j

c     creating levels and rgb files
c     for NERs
      call pne_extrems(m,sum_pneb,pne_min,pne_max)
      if (bw.eq.0) then
         file_out='cl_pne_band'
         call make_levels(pne_min,pne_max,nlevels_pne,
     &        shift_ner_levels,1,file_out)
         file_out='rgb_pne_band'
         call make_rgb_ner(nlevels_pne,file_out)
      else
         file_out='cl_pne_band_bw'
         call make_levels(pne_min,pne_max,nlevels_pne,
     &        shift_ner_levels,1,file_out)
         file_out='rgb_pne_band_bw'
         call make_rgb_ner_bw(nlevels_pne,file_out)
      endif
c     for ksi
      call pne_extrems(m,sum_ksib,pne_min,pne_max)
      if (bw.eq.0) then
         file_out='cl_ksi_band'
         call make_levels(pne_min,pne_max,nlevels_pne,
     &        shift_ner_levels,1,file_out)
         file_out='rgb_ksi_band'
         call make_rgb_ner(nlevels_pne,file_out)
      else
         file_out='cl_ksi_band_bw'
         call make_levels(pne_min,pne_max,nlevels_pne,
     &        shift_ner_levels,1,file_out)
         file_out='rgb_ksi_band_bw'
         call make_rgb_ner_bw(nlevels_pne,file_out)
      endif
c     for NERs differences
      call pne_extrems(m,dsum_pneb,pne_min,pne_max)
      if (bw.eq.0) then
         file_out='cl_dpne_band'
         call make_levels(pne_min,pne_max,nlevels_pne,
     &        shift_ner_levels,1,file_out)
         file_out='rgb_dpne_band'
         call make_rgb_ner(nlevels_pne,file_out)
      else
         file_out='cl_dpne_band_bw'
         call make_levels(pne_min,pne_max,nlevels_pne,
     &        shift_ner_levels,1,file_out)
         file_out='rgb_dpne_band_bw'
         call make_rgb_ner_bw(nlevels_pne,file_out)
      endif
c     for ksi differences
      call pne_extrems(m,dsum_ksib,pne_min,pne_max)
      if (bw.eq.0) then
         file_out='cl_dksi_band'
         call make_levels(pne_min,pne_max,nlevels_pne,
     &        shift_ner_levels,1,file_out)
         file_out='rgb_dksi_band'
         call make_rgb_ner(nlevels_pne,file_out)
      else
         file_out='cl_dksi_band_bw'
         call make_levels(pne_min,pne_max,nlevels_pne,
     &        shift_ner_levels,1,file_out)
         file_out='rgb_dksi_band_bw'
         call make_rgb_ner_bw(nlevels_pne,file_out)
      endif
c     Creating .dat and .ctl files: 'pneb.dat', 'pneb.ctl'
      st='pneb'
      call write_dat_m(m,sum_pneb,sign,st)

c     Creating .dat and .ctl files: 'ksi.dat', 'ksi.ctl'
      st='ksi'
      call write_dat_m(m,sum_ksib,sign,st)
c     Creating .dat and .ctl files:'dpneb.dat', 'dpneb.ctl'
      st='dpneb'
      call write_dat_m(m,dsum_pneb,sign,st)
c     Creating .dat and .ctl files:'dksi.dat', 'dksi.ctl'
      st='dksi'
      call write_dat_m(m,dsum_ksib,sign,st)      

 123  continue
      open(10,file='out')
      write(10,*) out
      close(10)

      end
