      subroutine read_atmos_data(nlay,Nb,Nq,e,lambda_lo,
     &     lambda_hi,dens,capa,grav,T,alt,temp,pres,Tsol,Tesp)
      implicit none

      include '../includes/param.inc'
      include '../includes/max.inc'
      include '../includes/formats.inc'

      integer i,m,Nb,Nq,band,quad,recombine,mr,recombine_default
      integer lstin,strlen,nlay
      double precision e(0:Nmax),alt(0:Nmax)
      double precision er(0:Nmax)
      double precision pres(0:Nmax),adia(0:Nmax)
      double precision temp(0:Nmax),Tsol,Tesp,dens(0:Nmax)
      double precision grav(0:Nmax)
      double precision zeta(0:Nmax),capa(0:Nmax)
      double precision lambda_lo(1:Nbmx)
      double precision lambda_hi(1:Nbmx)
      double precision T(0:Nmax+1)
      character*100 string_res,string_in
      character*100 file_ray_in,file_ray
 22   format(a)
      recombine_default=0

      open(15,file='./recombine')
      read(15,*) recombine
      close(15)
      if ((recombine.ne.0).and.(recombine.ne.1)) then
         recombine=recombine_default
      endif

      file_ray_in='atmos_data.txt'

      open(10,file='data_dir')
      read(10,22) string_in
      close(10)
      call add_slash_if_absent(string_in)
      open(11,file='results_dir')
      read(11,22) string_res
      close(11)
      call add_slash_if_absent(string_res)

      lstin=strlen(string_in)
      file_ray=string_in(1:lstin)//file_ray_in
      open(11,file=file_ray)
      read(11,*) m,Nb,Nq
      read(11,50) (alt(i),i=0,m-1)
      read(11,50) (e(i),i=0,m)
      read(11,50) (pres(i),i=0,m-1)
      read(11,50) (temp(i),i=0,m-1),Tsol,Tesp
      read(11,50) (dens(i),i=0,m-1)
      read(11,50) (adia(i),i=0,m-1)
      read(11,50) (grav(i),i=0,m-1)
      read(11,50) (zeta(i),i=0,m-1)
      read(11,50) (capa(i),i=0,m-1) ! J/kg/K
c     Test
c      close(10)
c      goto 333
c     Test
      do band=1,Nb
         read(11,50) lambda_lo(band),lambda_hi(band)
c     Debug
c         write(*,*) 'band=',band,lambda_lo(band),lambda_hi(band)
c     Debug
         do quad=1,Nq
            do i=1,15
               read(11,*)
            enddo ! i
         enddo ! quad
      enddo ! band
      close(11)

 333  continue

c     Computing temperatures T(i) for each layer i=0,m+1
      T(0)=Tsol
      if (recombine.eq.0) then
         T(1)=temp(0)+(temp(1)-temp(0))/(alt(1)-alt(0))*
     &        ((e(1)+e(0))/2.0D+0-alt(0))
         do i=2,m-1
            T(i)=temp(i-1)
         enddo
         T(m)=temp(m-2)+(temp(m-1)-temp(m-2))/(alt(m-1)-alt(m-2))*
     &        ((e(m)+e(m-1))/2.0D+0-alt(m-2))
         T(m+1)=Tesp
         nlay=m
      else
         mr=m-2
         er(0)=e(0)
         do i=1,mr-1
            er(i)=e(i+1)
         enddo
         er(mr)=e(m)
         if (alt(1).gt.(er(0)+er(1))/2.0D+0) then
            T(1)=temp(0)+(temp(1)-temp(0))/(alt(1)-alt(0))*
     &           ((er(0)+er(1))/2.0D+0-alt(0))
         else
            T(1)=temp(1)+(temp(2)-temp(1))/(alt(2)-alt(1))*
     &           ((er(0)+er(1))/2.0D+0-alt(1))
         endif
         do i=2,m-1
            T(i)=temp(i)
         enddo
         if (alt(m-2).gt.(er(mr)+er(mr-1))/2.0D+0) then
            T(mr)=temp(m-3)+(temp(m-2)-temp(m-3))/(alt(m-2)-alt(m-3))*
     &           ((er(mr)+er(mr-1))/2.0D+0-alt(m-3))
         else
            T(mr)=temp(m-2)+(temp(m-1)-temp(m-2))/(alt(m-1)-alt(m-2))*
     &           (alt(m-2)-(er(mr)+er(mr-1))/2.0D+0)
         endif
         T(mr+1)=Tesp          ! temperature of space
         nlay=mr
         do i=0,mr
            e(i)=er(i)
         enddo
      endif

      return
      end
