#!/bin/bash

narg=$#
go=0

while read line
do
  bw=$line
done < "bw"

while read line
do
  path=$line
done < "tmp_dir"

ctl='open '$path
draw='d '
title='draw title '

if [ $narg -eq 1 ] ; then
if [ $1 = 'ner' ] ; then
tmp1='pne'
tmp2='-pne'
if [ $bw -eq 1 ] ; then
cp rgb_pne_bw rgb
cp cl_pne_bw cl
else
cp rgb_pne rgb
cp cl_pne cl
fi
title=$title'NER (W/m\`a2\`n)'
go=1
elif [ $1 = 'cooling-rates' ] ; then
tmp1='CR'
tmp2='CR'
if [ $bw -eq 1 ] ; then
cp rgb_cr_bw rgb
cp cl_cr_bw cl
else
cp rgb_cr rgb
cp cl_cr cl
fi
title=$title'Cooling rates (K/day)'
go=1
fi

elif [ $narg -eq 2 ] ; then
if [ $1 = 'ner' -a $2 = 'analytic' ] ; then
tmp1='pne_theo'
tmp2='-pne_theo'
if [ $bw -eq 1 ] ; then
cp rgb_pnea_bw rgb
cp cl_pnea_bw cl
else
cp rgb_pnea rgb
cp cl_pnea cl
fi
title=$title'Analytic NER (W/m\`a2\`n)'
go=1
elif [ $1 = 'cooling-rates' -a $2 = 'analytic' ] ; then
tmp1='CR_theo'
tmp2='CR_theo'
if [ $bw -eq 1 ] ; then
cp rgb_cra_bw rgb
cp cl_cra_bw cl
else
cp rgb_cra rgb
cp cl_cra cl
fi
title=$title'Analytic cooling rates (K/day)'
go=1
fi

fi





if [ $narg -ge 3 -a $2 = 'band' -o $2 = 'lambda' ] ; then
if [ $2 = 'band' ] ; then
echo $3 > 'band_min'
band_min=$3
if [ $narg -eq 4 ] ; then
echo $4 > 'band_max'
band_max=$4
else
echo $3 > 'band_max'
band_max=$3
fi
elif [ $2 = 'lambda' ] ; then
echo $3 > 'lambda_min'
if [ $narg -eq 4 ] ; then
echo $4 > 'lambda_max'
else
echo $3 > 'lambda_max'
fi
f8
convert_lambda.exe
read band_min < 'band_min'
read band_max < 'band_max'
fi

if [ $1 = 'ner' -o $1 = 'ksi' ] ; then
f3
extract_dner_band.exe
read res < out
if [ $res -eq 1 ] ; then
echo 'Problem during excution of "extract_dner_band.exe"'
exit
fi
fi


if [ $1 = 'ner' ] ; then

tmp1='pneb'
tmp2='pneb'
if [ $bw -eq 1 ] ; then
cp rgb_pne_band_bw rgb
cp cl_pne_band_bw cl
else
cp rgb_pne_band rgb
cp cl_pne_band cl
fi
if [ $band_min -eq $band_max ] ; then
title=$title'Analytic NER band '$band_min' (W/m\`a2\`n)'
#title=$title'NER band '$band_min' (W/m\`a2\`n)'
else
title=$title'Analytic NER bands '$band_min'-'$band_max' (W/m\`a2\`n)'
fi
go=1

elif [ $1 = 'ksi' ] ; then

tmp1='ksi'
tmp2='ksi'
if [ $bw -eq 1 ] ; then
cp rgb_ksi_band_bw rgb
cp cl_ksi_band_bw cl
else
cp rgb_ksi_band rgb
cp cl_ksi_band cl
fi
if [ $band_min -eq $band_max ] ; then
title=$title'Analytic ksi band '$band_min' (W/m\`a2\`n)'
else
title=$title'Analytic ksi bands '$band_min'-'$band_max' (W/m\`a2\`n)'
fi
go=1

fi

fi




ctl=$ctl$tmp1'.ctl'
draw=$draw$tmp2

file=$tmp1
t1='gxeps -c -i out.gx -o '$file'.ps'
t2='gzip -f '$file'.ps'
t3='gv --orientation=LANDSCAPE '$file'.ps.gz'
cp levm lev
cp linesm lines

echo $ctl > ctl
echo $draw > d
echo $title > title
echo $t1 > t1
echo $t2 > t2
echo $t3 > t3
cat d title > dr
cat t0 t1 t2 t3 > t
echo $go > out
