#!/bin/bash

narg=$#

go=0

while read line
do
  bw=$line
done < "bw"

while read line
do
  path=$line
done < "tmp_dir"

ctl='open '$path
draw='d '
title='draw title '

if [ $narg -eq 2 ] ; then

if [ $2 = 'ner' ] ; then
tmp1='inc_pne'
tmp2='inc_pne'
cp rgb_pne rgb
cp cl_ipne cl
title=$title'sigma NER (W/m\`a2\`n)'
cp c1 c
go=1
elif [ $2 = 'cooling-rates' ] ; then
tmp1='inc_CR'
tmp2='inc_CR'
cp rgb_pne rgb
cp cl_icr cl
title=$title'sigma cooling rates (K/day)'
cp c1 c
go=1
fi
cp levm lev
cp linesm lines

elif [ $narg -eq 3 ] ; then

if [ $3 = 'total' ] ; then
tmp1='inc_bilan_tot'
if [ $bw -eq 1 ] ; then
cp rgb_ibilf_bw rgb
cp cl_ibf cl
else
cp rgb_ibilf rgb
cp cl_ibf cl
fi
title=$title'sigma Tot. bud. (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
elif [ $3 = 'gas-ground' ] ; then
tmp1='inc_bilan_gs'
if [ $bw -eq 1 ] ; then
cp rgb_ibilfgs_bw rgb
cp cl_ibfgs_bw cl
else
cp rgb_ibilfgs rgb
cp cl_ibfgs cl
fi
title=$title'sigma gas-gr bud. (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
elif [ $3 = 'gas-space' ] ; then
tmp1='inc_bilan_ge'
if [ $bw -eq 1 ] ; then
cp rgb_ibilfge_bw rgb
cp cl_ibfge_bw cl
else
cp rgb_ibilfge rgb
cp cl_ibfge cl
fi
title=$title'sigma gas-sp bud. (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
elif [ $3 = 'gas-gas' ] ; then
tmp1='inc_bilan_gg'
if [ $bw -eq 1 ] ; then
cp rgb_ibilfgg_bw rgb
cp cl_ibfgg_bw cl
else
cp rgb_ibilfgg rgb
cp cl_ibfgg cl
fi
title=$title'sigma gas-gas bud. (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
fi
tmp2=$tmp1
cp levNb lev
cp linesNb lines
cp c2 c

fi


if  [ $narg -eq 4 ] ; then
if [ $2 = 'flux' -a $3 = 'net' -a $4 = 'band' ] ; then
tmp1='inc_flux_netb'
tmp2=$tmp1
cp rgb_fnetb rgb
cp cl_ifnetb cl
cp lines_fb lines
cp lev_fb lev
title=$title'sigma Net flux (W/m\`a2\`n/cm\`a-1\`n)'
go=1
fi
fi


ctl=$ctl$tmp1'.ctl'
draw=$draw$tmp2

file=$tmp1
t1='gxeps -c -i out.gx -o '$file'.ps'
t2='gzip -f '$file'.ps'
t3='gv --orientation=LANDSCAPE '$file'.ps.gz'

echo $ctl > ctl
echo $draw > d
echo $title > title
echo $t1 > t1
echo $t2 > t2
echo $t3 > t3
cat d title > dr
cat t0 t1 t2 t3 > t
echo $go > out
