#!/bin/bash

# Traitement des flux et bilans
# Graphes 2D

narg=$#
go=0

while read line
do
  bw=$line
done < "bw"


while read line
do
  path=$line
done < "tmp_dir"

ctl='open '$path
draw='d '
title='draw title '


if [ $narg -eq 2 ] ; then
if [ $2 = 'up' ] ; then
cp gnu_flux_up graphe
go=2
elif [ $2 = 'down' ] ; then
cp gnu_flux_dn graphe
go=2
elif [ $2 = 'net' ] ; then
cp gnu_flux_net graphe
go=2
fi
fi

if [ $narg -eq 3 ] ; then
if [ $2 = 'up' -a $3 = 'analytic' ] ; then
cp gnu_flux_up_analytic graphe
go=2
elif [ $2 = 'down' -a $3 = 'analytic' ] ; then
cp gnu_flux_dn_analytic graphe
go=2
elif [ $2 = 'net' -a $3 = 'analytic' ] ; then
cp gnu_flux_net_analytic graphe
go=2
fi
fi

if [ $narg -eq 3 ] ; then
if [ $2 = 'net' -a $3 = 'toa' ] ; then
cp gnu_flux_toa graphe
go=2
elif [ $2 = 'net' -a $3 = 'bands' ] ; then
tmp1='flux_netb'
if [ $bw -eq 1 ] ; then
cp rgb_fnetb_bw rgb
cp cl_fnetb_bw cl
else
cp rgb_fnetb rgb
cp cl_fnetb cl
fi
cp lines_fb lines
cp lev_fb lev
title=$title'Net flux (W/m\`a2\`n/cm\`a-1\`n)'
go=1
fi
fi

if  [ $narg -eq 4 ] ; then
if [ $2 = 'net' -a $3 = 'bands' -a $4 = 'analytic' ] ; then
tmp1='flux_netb_theo'
if [ $bw -eq 1 ] ; then
cp rgb_fnetba_bw rgb
cp cl_fnetba_bw cl
else
cp rgb_fnetba rgb
cp cl_fnetba cl
fi
cp lines_fb lines
cp lev_fb lev
title=$title'Analytic Net flux (W/m\`a2\`n/cm\`a-1\`n)'
go=1
fi
fi



if [ $narg -ge 4 ] ; then


if [ $narg -ge 4 -a $1 = 'flux' -a $2 = 'net' -a $3 = 'band' -o $3 = 'lambda' ] ; then
if [ $3 = 'band' ] ; then
echo $4 > 'band_min'
band_min=$4
if [ $narg -eq 5 ] ; then
echo $5 > 'band_max'
band_max=$5
else
echo $4 > 'band_max'
band_max=$4
fi
elif [ $3 = 'lambda' ] ; then
echo $4 > 'lambda_min'
if [ $narg -eq 5 ] ; then
echo $5 > 'lambda_max'
else
echo $4 > 'lambda_max'
fi
f8
convert_lambda.exe
read band_min < 'band_min'
read band_max < 'band_max'
fi
echo 'Flux_nets_mono-nu.txt' > 'file_flux'

f4
extract_dflux_band.exe
read res < out
if [ $res -eq 1 ] ; then
echo 'Problem during excution of "extract_dflux_band.exe"'
exit
fi

if [ $3 = 'band' ] ; then
title=''
if [ $band_min -eq $band_max ] ; then
title=$title'set xlabel "Net flux band '$band_min'(W/m^{2})"'
else
title=$title'set xlabel "Net flux bands '$band_min'-'$band_max'(W/m^{2})"'
fi
elif [ $3 = 'lambda' ] ; then
title=''
if [ $band_min -eq $band_max ] ; then
title=$title'set xlabel "Net flux {/Symbol l}= '$4'(W/m^{2})"'
else
title=$title'set xlabel "Net flux {/Symbol l}= '$4'-'$5'{/Symbol m}m (W/m^{2})"'
fi
fi
echo $title > gra_flux_netb1
cat gra_flux_netb1 gra_flux_netb2 > gra_flux_netb
cp gnu_flux_net_band graphe
go=2
fi





if [ $narg -ge 4 -a $1 = 'flux' -a $2 = 'net' -a $3 = 'analytic' -a $4 = 'band'  -o $4 = 'lambda' ] ; then
if [ $4 = 'band' ] ; then
echo $5 > 'band_min'
band_min=$5
if [ $narg -eq 6 ] ; then
echo $6 > 'band_max'
band_max=$6
else
echo $5 > 'band_max'
band_max=$5
fi
elif [ $4 = 'lambda' ] ; then
echo $5 > 'lambda_min'
if [ $narg -eq 6 ] ; then
echo $6 > 'lambda_max'
else
echo $5 > 'lambda_max'
fi
f8
convert_lambda.exe
read band_min < 'band_min'
read band_max < 'band_max'
fi
echo 'Flux_nets_mono-nu_theo.txt' > 'file_flux'

f4
extract_dflux_band.exe
read res < out
if [ $res -eq 1 ] ; then
echo 'Problem during excution of "extract_dflux_band.exe"'
exit
fi

if [ $4 = 'band' ] ; then
title=''
if [ $band_min -eq $band_max ] ; then
title=$title'set xlabel "Analytic net flux band '$band_min'(W/m^{2})"'
else
title=$title'set xlabel "Analytic net flux bands '$band_min'-'$band_max'(W/m^{2})"'
fi
elif [ $4 = 'lambda' ] ; then
title=''
if [ $band_min -eq $band_max ] ; then
title=$title'set xlabel "Analytic net flux {/Symbol l}= '$5'(W/m^{2})"'
else
title=$title'set xlabel "Analytic net flux {/Symbol l}= '$5'-'$6'{/Symbol m}m (W/m^{2})"'
fi
fi
echo $title > gra_flux_netb1
cat gra_flux_netb1 gra_flux_netb2 > gra_flux_netb
cp gnu_flux_net_band graphe
go=2
fi





if [ $narg -ge 4 -a $1 = 'flux' -a $2 = 'net' -a $3 = 'z' ] ; then
echo $4 > 'zflux'
zflux=$4
echo 'Flux_nets_mono-nu.txt' > 'file_flux'
f7
extract_dflux_z.exe
read res < out
if [ $res -eq 1 ] ; then
echo 'Problem during excution of "extract_dflux_z.exe"'
exit
fi

title=''
title=$title'set ylabel "Net flux at z='$zflux'km (W/m^{2}/{/Symbol m}m)"'
echo $title > gra_flux_netz1_l
cat gra_flux_netz1_l gra_flux_netz2_l > gra_flux_netz_l
title=''
title=$title'set ylabel "Net flux at z='$zflux'km (mW/m^{2}/cm^{-1})"'
echo $title > gra_flux_netz1_n
cat gra_flux_netz1_n gra_flux_netz2_n > gra_flux_netz_n
cp gnu_flux_net_z graphe
go=2
fi





if [ $narg -ge 4 -a $1 = 'flux' -a $2 = 'net' -a $3 = 'analytic' -a $4 = 'z' ] ; then
echo $5 > 'zflux'
zflux=$5
echo 'Flux_nets_mono-nu_theo.txt' > 'file_flux'
f7
extract_dflux_z.exe
read res < out
if [ $res -eq 1 ] ; then
echo 'Problem during excution of "extract_dflux_z.exe"'
exit
fi

title=''
title=$title'set ylabel "Analytic net flux at z='$zflux'km (W/m^{2}/{/Symbol m}m)"'
echo $title > gra_flux_netz1_l
cat gra_flux_netz1_l gra_flux_netz2_l > gra_flux_netz_l
title=''
title=$title'set ylabel "Analytic net flux at z='$zflux'km (mW/m^{2}/cm^{-1})"'
echo $title > gra_flux_netz1_n
cat gra_flux_netz1_n gra_flux_netz2_n > gra_flux_netz_n
cp gnu_flux_net_z graphe
go=2
fi





fi




if [ $narg -eq 1 -a $1 = 'budget' ] ; then
cp gnu_budget graphe
go=2
fi

if [ $narg -eq 1 -a $1 = 'cooling-rate' ] ; then
cp gnu_cooling-rate graphe
go=2
fi

if [ $narg -eq 2 ] ; then
if [ $1 = 'budget' -a $2 = 'analytic' ] ; then
cp gnu_budget_analytic graphe
go=2
fi
fi



if [ $go -eq 1 ] ; then

ctl=$ctl$tmp1'.ctl'
draw=$draw$tmp1

file=$tmp1
t1='gxeps -c -i out.gx -o '$file'.ps'
t2='gzip -f '$file'.ps'
t3='gv --orientation=LANDSCAPE '$file'.ps.gz'

echo $ctl > ctl
echo $draw > d
echo $title > title
echo $t1 > t1
echo $t2 > t2
echo $t3 > t3
cat d title > dr
cat t0 t1 t2 t3 > t
cp c2 c

fi




echo $go > out
