#!/bin/bash

narg=$#
go=0


while read line
do
  bw=$line
done < "bw"

while read line
do
  path=$line
done < "tmp_dir"

ctl='open '$path
draw='d '
title='draw title '

if [ $narg -eq 2 ] ; then

if [ $2 = 'ner' ] ; then
tmp1='dpne'
tmp2='- dpne'
if [ $bw -eq 1 ] ; then
cp rgb_dpne_bw rgb
cp cl_dpne_bw cl
else
cp rgb_dpne rgb
cp cl_dpne cl
fi
cp linesm lines
cp levm lev
cp c1 c
title=$title'NER differences (W/m\`a2\`n)'
go=1
fi

elif [ $narg -eq 3 ] ; then

if [ $2 = 'ner' -a $3 = 'analytic'  ] ; then
tmp1='dpne_theo'
tmp2='- dpne_theo'
if [ $bw -eq 1 ] ; then
cp rgb_dpnea_bw rgb
cp cl_dpnea_bw cl
else
cp rgb_dpnea rgb
cp cl_dpnea cl
fi
cp linesm lines
cp levm lev
cp c1 c
title=$title'Analytic NER differences (W/m\`a2\`n)'
go=1
fi

if [ $2 = 'budget' -a  $3 = 'total' ] ; then
tmp1='dbilan_tot'
tmp2='dbilan_tot'
if [ $bw -eq 1 ] ; then
cp rgb_dbilf_bw rgb
cp cl_dbf_bw cl
else
cp rgb_dbilf rgb
cp cl_dbf cl
fi
cp linesNb lines
cp levNb lev
cp c2 c
title=$title'Total budget difference (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
fi

if [ $2 = 'budget' -a  $3 = 'gas-ground' ] ; then
tmp1='dbilan_gs'
tmp2='dbilan_gs'
if [ $bw -eq 1 ] ; then
cp rgb_dbilfgs_bw rgb
cp cl_dbfgs_bw cl
else
cp rgb_dbilfgs rgb
cp cl_dbfgs cl
fi
cp linesNb lines
cp levNb lev
cp c2 c
title=$title'Gas-ground budget difference (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
fi

if [ $2 = 'budget' -a  $3 = 'gas-space' ] ; then
tmp1='dbilan_ge'
tmp2='dbilan_ge'
if [ $bw -eq 1 ] ; then
cp rgb_dbilfge_bw rgb
cp cl_dbfge_bw cl
else
cp rgb_dbilfge rgb
cp cl_dbfge cl
fi
cp linesNb lines
cp levNb lev
cp c2 c
title=$title'Gas-space budget difference (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
fi

if [ $2 = 'budget' -a  $3 = 'gas-gas' ] ; then
tmp1='dbilan_gg'
tmp2='dbilan_gg'
if [ $bw -eq 1 ] ; then
cp rgb_dbilfgg_bw rgb
cp cl_dbfgg_bw cl
else
cp rgb_dbilfgg rgb
cp cl_dbfgg cl
fi
cp linesNb lines
cp levNb lev
cp c2 c
title=$title'Gas-gas budget difference (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
fi


if [ $2 = 'heating-rate' -a  $3 = 'total' ] ; then
tmp1='dbilankj_tot'
tmp2='dbilankj_tot'
cp rgb_bilf rgb
cp cl_dhr cl
cp linesNb lines
cp levNb lev
cp c2 c
title=$title'Total heating-rate difference (K/s\`n)'
go=1
fi

if [ $2 = 'heating-rate' -a  $3 = 'gas-ground' ] ; then
tmp1='dbilankj_gs'
tmp2='dbilankj_gs'
cp rgb_bilf rgb
cp cl_dhr cl
cp linesNb lines
cp levNb lev
cp c2 c
title=$title'Gas-ground heating-rate difference (K/s\`n)'
go=1
fi

if [ $2 = 'heating-rate' -a  $3 = 'gas-space' ] ; then
tmp1='dbilankj_ge'
tmp2='dbilankj_ge'
cp rgb_bilf rgb
cp cl_dhr cl
cp linesNb lines
cp levNb lev
cp c2 c
title=$title'Gas-space heating-rate difference (K/s\`n)'
go=1
fi

if [ $2 = 'heating-rate' -a  $3 = 'gas-gas' ] ; then
tmp1='dbilankj_gg'
tmp2='dbilankj_gg'
cp rgb_bilf rgb
cp cl_dhr cl
cp linesNb lines
cp levNb lev
cp c2 c
title=$title'Gas-gas heating-rate difference (K/s\`n)'
go=1
fi



elif [ $narg -eq 4 ] ; then

if [ $2 = 'budget' -a  $3 = 'total' -a $4 = 'analytic' ] ; then
tmp1='dbilan_tot_theo'
tmp2='dbilan_tot_theo'
if [ $bw -eq 1 ] ; then
cp rgb_dbilfa_bw rgb
cp cl_dbfa_bw cl
else
cp rgb_dbilfa rgb
cp cl_dbfa cl
fi
cp c2 c
title=$title'Analytic total budget diff. (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
elif [ $2 = 'budget' -a  $3 = 'gas-ground' -a $4 = 'analytic' ] ; then
tmp1='dbilan_gs_theo'
tmp2='dbilan_gs_theo'
if [ $bw -eq 1 ] ; then
cp rgb_dbilfags_bw rgb
cp cl_dbfags_bw cl
else
cp rgb_dbilfags rgb
cp cl_dbfags cl
fi
cp c2 c
title=$title'Analytic gas-ground budget diff. (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
elif [ $2 = 'budget' -a  $3 = 'gas-space' -a $4 = 'analytic' ] ; then
tmp1='dbilan_ge_theo'
tmp2='dbilan_ge_theo'
if [ $bw -eq 1 ] ; then
cp rgb_dbilfage_bw rgb
cp cl_dbfage_bw cl
else
cp rgb_dbilfage rgb
cp cl_dbfage cl
fi
cp c2 c
title=$title'Analytic gas-space budget diff. (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
elif [ $2 = 'budget' -a  $3 = 'gas-gas' -a $4 = 'analytic' ] ; then
tmp1='dbilan_gg_theo'
tmp2='dbilan_gg_theo'
if [ $bw -eq 1 ] ; then
cp rgb_dbilfagg_bw rgb
cp cl_dbfagg cl
else
cp rgb_dbilfagg rgb
cp cl_dbfagg cl
fi
cp c2 c
title=$title'Analytic gas-gas budget diff. (mW/m\`a3\`n/cm\`a-1\`n)'
go=1
fi




if [ $2 = 'heating-rate' -a  $3 = 'total' -a $4 = 'analytic' ] ; then
tmp1='dbilkj_tot_theo'
tmp2='dbilkj_tot_theo'
cp rgb_bilf rgb
cp cl_dhr cl
cp c2 c
title=$title'Analytic total heating-rate diff. (K/s\`n)'
go=1
elif [ $2 = 'heating-rate' -a  $3 = 'gas-ground' -a $4 = 'analytic' ] ; then
tmp1='dbilkj_gs_theo'
tmp2='dbilkj_gs_theo'
cp rgb_bilf rgb
cp cl_dhr cl
cp c2 c
title=$title'Analytic gas-ground heating-rate diff. (K/s\`n)'
go=1
elif [ $2 = 'heating-rate' -a  $3 = 'gas-space' -a $4 = 'analytic' ] ; then
tmp1='dbilkj_ge_theo'
tmp2='dbilkj_ge_theo'
cp rgb_bilf rgb
cp cl_dhr cl
cp c2 c
title=$title'Analytic gas-space heating-rate diff. (K/s\`n)'
go=1
elif [ $2 = 'heating-rate' -a  $3 = 'gas-gas' -a $4 = 'analytic' ] ; then
tmp1='dbilkj_gg_theo'
tmp2='dbilkj_gg_theo'
cp rgb_bilf rgb
cp cl_dhr cl
cp c2 c
title=$title'Analytic gas-gas heating-rate diff. (K/s\`n)'
go=1
fi



cp linesNb lines
cp levNb lev

fi





if [ $narg -ge 4 -a $2 = 'ner'  -a $3 = 'band' -o $2 = 'ner' -a $3 = 'lambda' ] ; then

if [ $3 = 'band' ] ; then
echo $4 > 'band_min'
band_min=$4
if [ $narg -eq 5 ] ; then
echo $5 > 'band_max'
band_max=$5
else
echo $4 > 'band_max'
band_max=$4
fi
elif [ $3 = 'lambda' ] ; then
echo $4 > 'lambda_min'
if [ $narg -eq 5 ] ; then
echo $5 > 'lambda_max'
else
echo $4 > 'lambda_max'
fi
f8
convert_lambda.exe
read band_min < 'band_min'
read band_max < 'band_max'
fi

f3
extract_dner_band.exe
read res < out
if [ $res -eq 1 ] ; then
echo 'Problem during excution of "extract_dner_band.exe"'
exit
fi

tmp1='dpneb'
tmp2='- dpneb'
if [ $bw -eq 1 ] ; then
cp rgb_dpne_band_bw rgb
cp cl_dpne_band_bw cl
else
cp rgb_dpne_band rgb
cp cl_dpne_band cl
fi
cp linesm lines
cp levm lev
cp c1 c
if [ $band_min -eq $band_max ] ; then
title=$title'NER differences band '$band_min' (W/m\`a2\`n)'
else
title=$title'NER differences bands '$band_min'-'$band_max' (W/m\`a2\`n)'
fi
go=1
fi





if [ $narg -ge 4 -a $2 = 'ksi'  -a $3 = 'band' -o $2 = 'ksi' -a $3 = 'lambda' ] ; then
if [ $3 = 'band' ] ; then
echo $4 > 'band_min'
band_min=$4
if [ $narg -eq 5 ] ; then
echo $5 > 'band_max'
band_max=$5
else
echo $4 > 'band_max'
band_max=$4
fi
elif [ $3 = 'lambda' ] ; then
echo $4 > 'lambda_min'
if [ $narg -eq 5 ] ; then
echo $5 > 'lambda_max'
else
echo $4 > 'lambda_max'
fi
f8
convert_lambda.exe
read band_min < 'band_min'
read band_max < 'band_max'
fi

f3
extract_dner_band.exe
read res < out
if [ $res -eq 1 ] ; then
echo 'Problem during excution of "extract_dner_band.exe"'
exit
fi

tmp1='dksi'
tmp2='- dksi'
if [ $bw -eq 1 ] ; then
cp rgb_dksi_band_bw rgb
cp cl_dksi_band_bw cl
else
cp rgb_dksi_band rgb
cp cl_dksi_band cl
fi
cp linesm lines
cp levm lev
cp c1 c
if [ $band_min -eq $band_max ] ; then
title=$title'ksi differences band '$band_min' (unitless)'
else
title=$title'ksi differences bands '$band_min'-'$band_max' (unitless)'
fi
go=1
fi




if [ $narg -ge 5 -a $2 = 'flux' -a $3 = 'net' -a $4 = 'band' -o $4 = 'lambda' ] ; then
if [ $4 = 'band' ] ; then
echo $5 > 'band_min'
band_min=$5
if [ $narg -eq 6 ] ; then
echo $6 > 'band_max'
band_max=$6
else
echo $5 > 'band_max'
band_max=$5
fi
elif [ $4 = 'lambda' ] ; then
echo $5 > 'lambda_min'
if [ $narg -eq 6 ] ; then
echo $6 > 'lambda_max'
else
echo $5 > 'lambda_max'
fi
f8
convert_lambda.exe
read band_min < 'band_min'
read band_max < 'band_max'
fi
echo 'Flux_nets_mono-nu.txt' > 'file_flux'

f4
extract_dflux_band.exe
read res < out
if [ $res -eq 1 ] ; then
echo 'Problem during excution of "extract_dflux_band.exe"'
exit
fi

if [ $4 = 'band' ] ; then
title=''
if [ $band_min -eq $band_max ] ; then
title=$title'set xlabel "Net flux difference band '$band_min'(W/m^{2})"'
else
title=$title'set xlabel "Net flux difference bands '$band_min'-'$band_max'(W/m^{2})"'
fi
elif [ $4 = 'lambda' ] ; then
title=''
if [ $band_min -eq $band_max ] ; then
title=$title'set xlabel "Net flux difference {/Symbol l}= '$5'(W/m^{2})"'
else
title=$title'set xlabel "Net flux difference {/Symbol l}= '$5'-'$6'{/Symbol m}m (W/m^{2})"'
fi
fi
echo $title > gra_dflux_netb1
cat gra_dflux_netb1 gra_dflux_netb2 > gra_dflux_netb
cp gnu_dflux_net_band graphe
go=2
fi





if [ $narg -ge 5 -a $2 = 'flux' -a $3 = 'net' -a $4 = 'analytic' -a $5 = 'band' -o $5 = 'lambda' ] ; then
if [ $5 = 'band' ] ; then
echo $6 > 'band_min'
band_min=$6
if [ $narg -eq 7 ] ; then
echo $7 > 'band_max'
band_max=$7
else
echo $6 > 'band_max'
band_max=$6
fi
elif [ $5 = 'lambda' ] ; then
echo $6 > 'lambda_min'
if [ $narg -eq 7 ] ; then
echo $7 > 'lambda_max'
else
echo $6 > 'lambda_max'
fi
f8
convert_lambda.exe
read band_min < 'band_min'
read band_max < 'band_max'
fi
echo 'Flux_nets_mono-nu_theo.txt' > 'file_flux'

f4
extract_dflux_band.exe
read res < out
if [ $res -eq 1 ] ; then
echo 'Problem during excution of "extract_dflux_band.exe"'
exit
fi

if [ $5 = 'band' ] ; then
title=''
if [ $band_min -eq $band_max ] ; then
title=$title'set xlabel "Analytic net flux difference band '$band_min'(W/m^{2})"'
else
title=$title'set xlabel "Analytic net flux difference bands '$band_min'-'$band_max'(W/m^{2})"'
fi
elif [ $5 = 'lambda' ] ; then
title=''
if [ $band_min -eq $band_max ] ; then
title=$title'set xlabel "Analytic net flux difference {/Symbol l}= '$6'(W/m^{2})"'
else
title=$title'set xlabel "Analytic net flux difference {/Symbol l}= '$6'-'$7'{/Symbol m}m (W/m^{2})"'
fi
fi
echo $title > gra_dflux_netb1
cat gra_dflux_netb1 gra_dflux_netb2 > gra_dflux_netb
cp gnu_dflux_net_band graphe
go=2
fi






if [ $narg -ge 5 -a $2 = 'flux' -a $3 = 'net' -a $4 = 'z' ] ; then
echo $5 > 'zflux'
zflux=$5
echo 'Flux_nets_mono-nu.txt' > 'file_flux'
f7
extract_dflux_z.exe
read res < out
if [ $res -eq 1 ] ; then
echo 'Problem during excution of "extract_dflxu_z.exe"'
exit
fi

title=''
title=$title'set ylabel "Net flux difference at z='$zflux'km (W/m^{2}/{/Symbol m}m)"'
echo $title > gra_dflux_netz1_l
cat gra_dflux_netz1_l gra_dflux_netz2_l > gra_dflux_netz_l
title=''
title=$title'set ylabel "Net flux difference at z='$zflux'km (mW/m^{2}/cm^{-1})"'
echo $title > gra_dflux_netz1_n
cat gra_dflux_netz1_n gra_dflux_netz2_n > gra_dflux_netz_n
cp gnu_dflux_net_z graphe
go=2
fi



if [ $narg -ge 5 -a $2 = 'flux' -a $3 = 'net' -a $4 = 'analytic' -a $5 = 'z' ] ; then
echo $6 > 'zflux'
zflux=$6
echo 'Flux_nets_mono-nu_theo.txt' > 'file_flux'
f7
extract_dflux_z.exe
read res < out
if [ $res -eq 1 ] ; then
echo 'Problem during excution of "extract_dflux_z.exe"'
exit
fi

title=''
title=$title'set ylabel "Analytic net flux difference at z='$zflux'km (W/m^{2}/{/Symbol m}m)"'
echo $title > gra_dflux_netz1_l
cat gra_dflux_netz1_l gra_dflux_netz2_l > gra_dflux_netz_l
title=''
title=$title'set ylabel "Analytic net flux difference at z='$zflux'km (mW/m^{2}/cm^{-1})"'
echo $title > gra_dflux_netz1_n
cat gra_dflux_netz1_n gra_dflux_netz2_n > gra_dflux_netz_n
cp gnu_dflux_net_z graphe
go=2
fi







ctl=$ctl$tmp1'.ctl'
draw=$draw$tmp2

file=$tmp1
t1='gxeps -c -i out.gx -o '$file'.ps'
t2='gzip -f '$file'.ps'
t3='gv --orientation=LANDSCAPE '$file'.ps.gz'

echo $ctl > ctl
echo $draw > d
echo $title > title
echo $t1 > t1
echo $t2 > t2
echo $t3 > t3
cat d title > dr
cat t0 t1 t2 t3 > t
echo $go > out
