      subroutine pne_extrems(m,pne,pne_min,pne_max)
      implicit none
      include '../includes/max.inc'
      
      integer i,j,m,minf
      double precision pne(0:Nmax+1,0:Nmax+1)
      double precision pne_min,pne_max

      pne_max=0.0D+0
      minf=0
      do i=0,m+1
         do j=0,m+1
            if ((pne(i,j).ne.0.0D+0).and.(minf.eq.0)) then
               pne_min=dabs(pne(i,j))
               minf=1
            endif
            if (dabs(pne(i,j)).gt.pne_max) then
               pne_max=dabs(pne(i,j))
            endif
            if ((dabs(pne(i,j)).lt.pne_min).and.(pne(i,j).ne.0.0D+0))
     &           then
               pne_min=dabs(pne(i,j))
            endif
         enddo ! j
      enddo ! i

      return
      end







      subroutine k_extrems(m,Nb,k,k_min,k_max)
      implicit none
      include '../includes/max.inc'
      
      integer i,band,m,Nb,minf
      double precision k(1:Nbmx,1:Nmax)
      double precision k_min,k_max

      k_max=0.0D+0
      minf=0
      do band=1,Nb
         do i=1,m
            if ((k(band,i).ne.0.0D+0).and.(minf.eq.0)) then
               k_min=dabs(k(band,i))
               minf=1
            endif
            if (dabs(k(band,i)).gt.k_max) then
               k_max=dabs(k(band,i))
            endif
            if ((dabs(k(band,i)).lt.k_min).and.(k(band,i).ne.0.0D+0))
     &           then
               k_min=dabs(k(band,i))
            endif
         enddo ! j
      enddo ! i

      return
      end



      
      subroutine make_levels(min,max,nlevels,shift,sym,file_out)
      implicit none
      
      integer nlevels,strlen,i,shift,sym
      integer n_min,n_max
      double precision min,max,exp
      double precision levels(1:100)
      character*100 file_out
      character*60 string
      character*500 st
c     sym=0: pas d'chelle ngative
c     sym=1: double chelle (+ et -)

c     Calcul des exposants min en max rencontrs
      call expo(min,n_min)
      call expo(max,n_max)
c     Debug
c      write(*,*) 'min=',min,' n_min=',n_min
c      write(*,*) 'max=',max,' n_max=',n_max
c     Debug
c     Protection dans le cas o n_min=n_max
      if (n_min.eq.n_max) then
         n_min=n_max-1
      endif
c     Ajustement utilisateur
c     Debug
c      write(*,*) 'avant: n_max=',n_max,' n_min=',n_min
c     Debug
      n_max=n_max+shift
      n_min=n_min+shift
c     Debug
c      write(*,*) 'apres: n_max=',n_max,' n_min=',n_min
c     Debug
c     Scurit pour ne pas avoir trop de niveaux
      if ((n_max-n_min).gt.nlevels) then
         n_min=n_max-nlevels+1
      endif

c     Calcul des niveaux
      do i=1,nlevels
         exp=dble(n_min)+dble(n_max-n_min)/dble(nlevels-1)*dble(i-1)
         levels(i)=(1.0D+1)**exp
      enddo ! lev
c     Conversion des niveaux en chanes de caractres
c     et concatnation de la chane de caractre finale  crire
      st='set clevs'
      if (sym.eq.1) then
         do i=nlevels,1,-1
            call double2string(-levels(i),string)
            st=st(1:strlen(st))//' '//string(1:strlen(string))
         enddo
      endif
      do i=1,nlevels
         call double2string(levels(i),string)
         st=st(1:strlen(st))//' '//string(1:strlen(string))
      enddo

c     criture du fichier de niveaux
      open(13,file=file_out(1:strlen(file_out)))
      write(13,'(A)') st(1:strlen(st))
      close(13)

      
      return
      end


      

      subroutine expo(a,n)
      implicit none
      double precision a
      integer n
      n=int(dlog10(a))
      if (dlog10(a).le.0) then
         n=n-1
      endif
      return
      end




      subroutine double2string(a,string)
      implicit none
      double precision a
      character*60 string,st
      integer strlen,len,n1,n2,i,nzap,nfibp,np,nfiap,nzm
      integer ibpf,iapf
      character*1 blank,zero,point,moins
 60   format(F60.30)
      blank=' '
      zero='0'
      point='.'
      moins='-'
      nzm=4

      write(st,60) a
      len=strlen(st)
      i=1
      do while (st(i:i).eq.blank)
         if (i.eq.len+1) then
            write(*,*) 'error on string:',st
            stop
         endif
         i=i+1
      enddo
      n1=i
c     n1 repre la position du premier caractre non blanc dans la ligne
      do while (st(i:i).ne.blank)
         if (st(i:i).eq.point) then
            np=i
            goto 111
         endif
         i=i+1
      enddo
 111  continue
c     np repre la position du point

c     on cherche un entier non nul entre le premier caractre non
c     blanc et le point
      ibpf=0
      do i=n1,np-1
         if ((st(i:i).ne.zero).and.
     &        (st(i:i).ne.blank).and.
     &        (st(i:i).ne.moins)) then
            ibpf=1
            nfibp=i
            goto 222
         endif
      enddo
 222  continue
c     ibpf=1 s'il y a un entier non nul avant le point
c     nfibp repre sa position

c     on cherche maintenant le premier entier non nul aprs le point
      iapf=0
      do i=np+1,60
         if ((st(i:i).ne.zero).and.
     &        (st(i:i).ne.blank).and.
     &        (st(i:i).ne.moins)) then
            iapf=1
            nfiap=i
            goto 333
         endif
      enddo
 333  continue
c     iapf=1 s'il y a un entier non nul aprs le point
c     nfiap repre sa position

      if (iapf.eq.1) then
         nzap=nfiap-np
      endif
c     nzap est le nombre de zros entre le point et le premier
c     entier non nul localis aprs le point

c     Si un entier non nul a t trouv avant le point, alors on ne garde que 3 chiffres
c     aprs le point
      if (ibpf.eq.1) then
         n2=np+2
c     S'il n'y a pas d'entier non nul avant le point, deux possibilits
      else
c     S'il n'y a pas non plus d'entier non nul aprs le point, on est mal
         if (iapf.eq.0) then
            n2=np+3
         else
c     S'il y a un entier non nul aprs le point, tant mieux
c     Il faut quand mme vrifier que le nombre de zros entre le point
c     et le premier entier non nul n'est pas trop grand
            if (nzap.gt.nzm) then
               n2=np+2
            endif
c     Si le premier entier non nul aprs le point est trop prs
c     de la fin de la ligne, on impose le dernier caractre  la fin
            if (nfiap.ge.57) then
               n2=60
            else
               n2=nfiap+3
            endif
         endif
      endif

      string=st(n1:n2)
c     Debug
c      write(*,*) 'st=',st,' string=',string(1:strlen(string)),
c     &     ' ibpf=',ibpf
c     Debug

      return
      end



      subroutine make_rgb_ner(nlevels,file_out)
      implicit none
      integer strlen,nlevels
      character*100 file_out,command,st

      if (nlevels.eq.3) then
         st='set rbcols 23 24 27 30 34 36 37'
      else if (nlevels.eq.4) then
         st='set rbcols 23 24 27 29 30 32 34 36 37'
      else if (nlevels.eq.5) then
         st='set rbcols 23 24 25 27 29 30 31 32 34 36 37'
      else if (nlevels.eq.6) then
         st='set rbcols 23 24 25 26 27 29 30 31 32 33 34 36 37'
      else if (nlevels.eq.7) then
         st='set rbcols 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37'
      endif
c     Debug
c      write(*,*) 'nlevels=',nlevels
c      write(*,*) 'st=',st
c     Debug
      open(14,file='./rgb_tmp')
      write(14,'(A)') st(1:strlen(st))
      close(14)
      command='cat rgb_ner_def rgb_tmp post_rgb > '//
     &     file_out(1:strlen(file_out))
      call system(command(1:strlen(command)))
      
      return
      end



      subroutine make_rgb_ner_bw(nlevels,file_out)
      implicit none
      integer strlen,nlevels
      character*100 file_out,command,st

      if (nlevels.eq.3) then
         st='set rbcols 23 24 27 30 34 36 37'
      else if (nlevels.eq.4) then
         st='set rbcols 23 24 27 29 30 32 34 36 37'
      else if (nlevels.eq.5) then
         st='set rbcols 23 24 25 27 29 30 31 32 34 36 37'
      else if (nlevels.eq.6) then
         st='set rbcols 23 24 25 26 27 29 30 31 32 33 34 36 37'
      else if (nlevels.eq.7) then
         st='set rbcols 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37'
      endif

      open(14,file='./rgb_tmp')
      write(14,'(A)') st(1:strlen(st))
      close(14)
      command='cat rgb_ner_bw_def rgb_tmp post_rgb > '//
     &     file_out(1:strlen(file_out))
      call system(command(1:strlen(command)))
      
      return
      end



      subroutine make_rgb_k(nlevels,file_out)
      implicit none
      integer strlen,nlevels
      character*100 file_out,command,st

      if (nlevels.eq.3) then
         st='set rbcols 20 23 24 27'
      else if (nlevels.eq.4) then
         st='set rbcols 20 22 24 26 27'
      else if (nlevels.eq.5) then
         st='set rbcols 20 22 23 25 26 27'
      else if (nlevels.eq.6) then
         st='set rbcols 20 22 23 24 25 26 27'
      else if (nlevels.eq.7) then
         st='set rbcols 20 21 22 23 24 25 26 27'
      endif

      open(14,file='./rgb_tmp')
      write(14,'(A)') st(1:strlen(st))
      close(14)
      command='cat rgb_k_def rgb_tmp post_rgb > '//
     &     file_out(1:strlen(file_out))
      call system(command(1:strlen(command)))
      
      return
      end




      subroutine make_rgb_k_bw(nlevels,file_out)
      implicit none
      integer strlen,nlevels
      character*100 file_out,command,st

      if (nlevels.eq.3) then
         st='set rbcols 20 22 25 27'
      else if (nlevels.eq.4) then
         st='set rbcols 20 21 23 25 27'
      else if (nlevels.eq.5) then
         st='set rbcols 20 21 22 23 25 27'
      else if (nlevels.eq.6) then
         st='set rbcols 20 21 22 23 24 25 27'
      else if (nlevels.eq.7) then
         st='set rbcols 20 21 22 23 24 25 26 27'
      endif

      open(14,file='./rgb_tmp')
      write(14,'(A)') st(1:strlen(st))
      close(14)
      command='cat rgb_k_bw_def rgb_tmp post_rgb > '//
     &     file_out(1:strlen(file_out))
      call system(command(1:strlen(command)))
      
      return
      end
