c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c     
      subroutine analytic_NER(band,quad,ner)
      implicit none
      
      include 'max.inc'
      include 'data.inc'
      include 'options.inc'
      include 'param.inc'
      
      integer i,j,band,quad,md
      double precision z1,z2,z3,z4,B1,B2,B3,B4
      double precision B_sol,B_esp,Bd,B_i,B_j
      double precision lambda,Planck,expint
      double precision kai,kaj,tau_B,tau_inf
      double precision tau_atmos

      double precision B1_ref,B2_ref,B3_ref,B4_ref
      double precision taui,tauj
      double precision taui_ref,tauj_ref,tau_B_ref
      double precision tau_below,tau_above
      double precision nerd_is_direct,nerd_is_ref
      double precision nerd_ij_direct,nerd_ij_ref,nerd_ji_direct

      double precision PNEd(0:2*(Nmax+1),0:2*(Nmax+1))
      double precision ner(0:Nmax+1,0:Nmax+1)

c     rflexion diffuse
      double precision tau_B1,tau_B2
      double precision nerd_ij_refd
c     rflexion diffuse

      lambda=(lambda_lo(band)+lambda_hi(band))/2.0D+0
      if (udif.eq.1) then
         B_sol=Planck(Tsol,lambda_lo(band),lambda_hi(band))
         B_esp=Planck(Tesp,lambda_lo(band),lambda_hi(band))
      else
         B_sol=udif_sol(band)
         B_esp=udif_esp(band)
      endif
      md=2*(m-1)

      Bd=B_sol
      do i=1,md
         z1=alti(i-1)
         z2=alti(i)
         call find_B(band,quad,(z1+z2)/2.0D+0,B_i)
         call find_B(band,quad,z1,B1)
         call find_B(band,quad,z2,B2)
         call find_ka(band,quad,int(i/2)+1,
     &        (z2+z1)/2.0D+0,kai) ! on rcupre le ka de la maille i
         taui=kai*(z2-z1)
c     Calcul de la PNEd sol-i
         call calc_tau_abs_mlay(band,quad,1,i-1,1,tau_B)
         tau_inf=tau_B
         call NERd_gi(em_sol(band),B_sol,B1,B2,taui,
     &        tau_B,PNEd(i,0))  ! [PNEd(i,0)]=W/m/m
         
c     Calcul de la PNEd esp-i
         call calc_tau_abs_mlay(band,quad,i+1,md
     &        ,1,tau_B)
         call NERd_is(B_esp,B1,B2,taui,
     &        tau_B,nerd_is_direct) ! [nerd_is_direct]=W/m/m

         call calc_tau_abs_mlay(band,quad,1,i-1,1,tau_below)
         call calc_tau_abs_mlay(band,quad,i+1,md,1,tau_above)
         if (ref.eq.1) then
c            call NERd_is_specular_reflection_virtual(em_sol(band),
c     &           B_esp,B1,B2,taui,tau_below,tau_above,nerd_is_ref) ! [nerd_is_ref]=W/m/m
            call NERd_is_specular_reflection_real(em_sol(band),
     &           B_esp,B1,B2,taui,tau_below,tau_above,nerd_is_ref) ! [nerd_is_ref]=W/m/m
         else if (ref.eq.2) then
            call NERd_is_diffuse_reflection(em_sol(band),
     &           B_esp,B1,B2,taui,tau_below,tau_above,nerd_is_ref) ! [nerd_is_ref]=W/m/m
         endif
         PNEd(i,md+1)=nerd_is_direct+nerd_is_ref ! [PNEd(i,md+1)]=W/m/m

c     Calcul des PNEd(i,j), j=i+1,md
         do j=i+1,md
            z3=alti(j-1)
            z4=alti(j)
            call find_B(band,quad,(z3+z4)/2.0D+0,B_j)
            call find_B(band,quad,z3,B3)
            call find_B(band,quad,z4,B4)
            call find_ka(band,quad,int(j/2)+1,
     &           (z3+z4)/2.0D+0,kaj)
            tauj=kaj*(z4-z3)
            call calc_tau_abs_mlay(band,quad,i+1,j-1,1,
     &           tau_B)
c     Computation of direct NER(i,j)
            call NERd_ij(B1,B2,B3,B4,taui,tauj,
     &           tau_B,nerd_ij_direct) ! [nerd_ij_direct]=W/m/m
c     Computation of NER(i,j) by reflexion at ground level:

c     In the case of a specular reflection:
            if (ref.eq.1) then
c     Both "NERd_ij_specular_reflection_virtual" and "NERd_ij_specular_reflection_real"
c     can be used for the computation of 'nerd_ij_ref'. They take the same
c     arguments, and the result will be the same. See comments in those
c     two routines.
c               call NERd_ij_specular_reflection_virtual(em_sol(band),
c     &              kai,kaj,z1,z2,z3,z4,
c     &              B1,B2,B3,B4,taui,tauj,tau_B,tau_inf,
c     &              nerd_ij_ref) ! nerd_ji_ref=W/m/m
               call NERd_ij_specular_reflection_real(em_sol(band),
     &              kai,kaj,z1,z2,z3,z4,
     &              B1,B2,B3,B4,taui,tauj,tau_B,tau_inf,
     &              nerd_ij_ref) ! nerd_ji_ref=W/m/m
c     In the case of a diffuse reflection
            else if (ref.eq.2) then
               call NERd_ij_diffuse_reflection(em_sol(band),
     &              kai,kaj,z1,z2,z3,z4,
     &              B1,B2,B3,B4,taui,tauj,tau_B,tau_inf,
     &              nerd_ij_ref) ! nerd_ij_ref=W/m/m
            endif ! over ref

c     PNEd(i,j) is the sum of nerd_ij_direct and nerd_ij_ref
            PNEd(i,j)=nerd_ij_direct+nerd_ij_ref ! W/m/m

         enddo                  ! Boucle sur les j
      enddo                     ! Boucle sur les i
c     On complte la matrice des PNEd (symtrique)
      do i=1,md
         do j=1,i-1
            PNEd(i,j)=-PNEd(j,i)
         enddo
         PNEd(i,i)=0.0D+0
         PNEd(0,i)=-PNEd(i,0)
         PNEd(md+1,i)=-PNEd(i,md+1)
      enddo
c     Calcul de la PNEd(sol-espace)
      call calc_tau_abs_mlay(band,quad,1,md,1,tau_atmos)
      call NERd_gs(em_sol(band),B_sol,B_esp,tau_atmos,PNEd(0,md+1)) ! PNEd(0,md+1)=W/m/m
      PNEd(md+1,0)=-PNEd(0,md+1) ! W/m/m
      
c     Recombinaison des PNE 22 pour obtenir la matrice des PNE
c     correspondant au maillage de calcul MC
      
c     Pour les PNE sol-gaz
      ner(1,0)=PNEd(1,0)
      do i=2,m-1
         ner(i,0)=PNEd(2*(i-1),0)+PNEd(2*i-1,0)
      enddo
      ner(m,0)=PNEd(md,0)
c     Pour les PNE gaz-espace
      ner(1,m+1)=PNEd(1,md+1)
      do i=2,m-1
         ner(i,m+1)=PNEd(2*(i-1),md+1)+PNEd(2*i-1,md+1)
      enddo
      ner(m,m+1)=PNEd(md,md+1)
c     Pour les PNE gaz-gaz
      do j=2,m-1
         ner(1,j)=PNEd(1,2*(j-1))+PNEd(1,2*j-1)
      enddo
      ner(1,m)=PNEd(1,md)
      do i=2,m-1
         do j=i+1,m-1
            ner(i,j)=PNEd(2*(i-1),2*(j-1))+
     &           PNEd(2*(i-1),2*j-1)+
     &           PNEd(2*i-1,2*(j-1))+
     &           PNEd(2*i-1,2*j-1)
         enddo
      enddo
      do i=2,m-1
         ner(i,m)=PNEd(2*(i-1),md)+PNEd(2*i-1,md)
      enddo
c     PNE sol-espace
      ner(0,m+1)=PNEd(0,md+1)
c     Symetrization
      do i=1,m
         do j=1,i-1
            ner(i,j)=-ner(j,i)
         enddo
         ner(i,i)=0.0D+0
         ner(0,i)=-ner(i,0)
         ner(m+1,i)=-ner(i,m+1)
      enddo
      ner(0,0)=0.0D+0
      ner(m+1,m+1)=0.0D+0
      ner(m+1,0)=-ner(0,m+1)
      
      return
      end



      


      subroutine NERd_gs(em_g,B_sol,B_esp,tau_atmos,NER_gs)
      implicit none
      include 'param.inc'
      double precision em_g,B_sol,B_esp,tau_atmos
      double precision expint
      double precision NER_gs

      NER_gs=-2.0D+0*pi*em_g*(B_sol-B_esp)
     &     *expint(3,tau_atmos)

      return
      end
      


      subroutine NERd_gi(em_g,B_sol,B1,B2,taui,tau_B,NER_gi)
      implicit none
      include 'param.inc'
      double precision em_g,B_sol,B1,B2,taui,tau_B
      double precision expint
      double precision NER_gi
      NER_gi=2.0D+0*pi*em_g*(
     &     (B_sol-B1)*expint(3,tau_B)
     &     -(B_sol-B2)*expint(3,tau_B+taui)
     &     -(B2-B1)/taui*(expint(4,tau_B)
     &     -expint(4,tau_B+taui))
     &     )

      return
      end
      


      subroutine NERd_is(B_esp,B1,B2,taui,tau_B,NER_is)
      implicit none
      include 'param.inc'
c     NER directe entre une maille de gaz i et l'espace
c     tau_B est l'paisseur optique entre le haut de la maille de gaz et l'espace
      double precision B_esp,B1,B2,taui,tau_B
      double precision expint
      double precision NER_is

      NER_is=2.0D+0*pi*(
     &     (B_esp-B2)*expint(3,tau_B)
     &     -(B_esp-B1)*expint(3,tau_B+taui)
     &     +(B2-B1)/taui*
     &     (expint(4,tau_B)-expint(4,tau_B+taui)
     &     ))

      return
      end
      


      subroutine NERd_is_specular_reflection_virtual(epsilon,B_esp,
     &     B1,B2,taui,tau_below,tau_above,NER_is_ref)
      implicit none
      include 'param.inc'
c     NER par rflexion spculaire entre une maille de gaz i et l'espace
c     tau_below est l'paisseur optique entre le sol et le bas de la maille de gaz
c     tau_above est l'paisseur optique entre le haut de la maille de gaz et l'espace
      double precision epsilon,B_esp,B1,B2,taui,tau_below,tau_above
      double precision expint
      double precision NER_is_ref
      double precision B1_ref,B2_ref,tau_B_ref
      double precision nerd_is_direct

      B1_ref=B2
      B2_ref=B1
      tau_B_ref=tau_above+taui+2.0D+0*tau_below
      call NERd_is(B_esp,B1_ref,B2_ref,taui,tau_B_ref,nerd_is_direct)
      NER_is_ref=(1.0D+0-epsilon)*nerd_is_direct

      return
      end
      


      subroutine NERd_is_specular_reflection_real(epsilon,B_esp,B1,B2,
     &     taui,tau_below,tau_above,NER_is_ref)
      implicit none
      include 'param.inc'
c     NER par rflexion spculaire entre une maille de gaz i et l'espace
c     tau_below est l'paisseur optique entre le sol et le bas de la maille de gaz
c     tau_above est l'paisseur optique entre le haut de la maille de gaz et l'espace
      double precision epsilon,B_esp,B1,B2,taui,tau_below,tau_above,tauH
      double precision expint
      double precision NER_is_ref

      tauH=tau_below+taui+tau_above
      NER_is_ref=2.0D+0*pi*(1.0D+0-epsilon)*
     &     (
     &     (B_esp-B1)*expint(3,tauH+tau_below)
     &     -(B_esp-B2)*expint(3,tauH+tau_below+taui)
     &     -(B2-B1)/taui*(expint(4,tauH+tau_below)-
     &     expint(4,tauH+tau_below+taui))
     &     )


      return
      end
      


      subroutine NERd_is_diffuse_reflection(epsilon,B_esp,B1,B2,
     &     taui,tau_below,tau_above,NER_is_ref)
      implicit none
      include 'param.inc'
c     NER par rflexion diffuse entre une maille de gaz i et l'espace
c     tau_below est l'paisseur optique entre le sol et le bas de la maille de gaz
c     tau_above est l'paisseur optique entre le haut de la maille de gaz et l'espace
      double precision epsilon,B_esp,B1,B2,taui,tau_below,tau_above,tauH
      double precision expint
      double precision NER_is_ref

      tauH=tau_below+taui+tau_above
      NER_is_ref=4.0D+0*pi*(1.0D+0-epsilon)*
     &     (
     &     (B_esp-B1)*expint(3,tau_below)
     &     -(B_esp-B2)*expint(3,tau_below+taui)
     &     -(B2-B1)/taui*(expint(4,tau_below)-
     &     expint(4,tau_below+taui))
     &     )*expint(3,tauH)


      return
      end
      


      subroutine NERd_ij(B1,B2,B3,B4,taui,tauj,tau_B,NER_ij)
      implicit none
      include 'param.inc'
c     NER directe entre deux mailles i et j
      double precision B1,B2,B3,B4,taui,tauj,tau_B
      double precision expint
      double precision NER_ij

      NER_ij=-2.0D+0*pi*(
     &     (B2-B3)*expint(3,tau_B)
     &     -(B1-B3)*expint(3,tau_B+taui)
     &     -(B2-B4)*expint(3,tau_B+tauj)
     &     +(B1-B4)*expint(3,tau_B+taui+tauj)
     &     +((B2-B1)/taui+(B4-B3)/tauj)*(
     &     expint(4,tau_B+taui)
     &     +expint(4,tau_B+tauj)
     &     -expint(4,tau_B)
     &     -expint(4,tau_B+taui+tauj))
     &     )

      return
      end


      subroutine NERd_ij_specular_reflection_virtual(epsilon,kai,kaj,
     &     z1,z2,z3,z4,
     &     B1,B2,B3,B4,taui,tauj,tau_B,tau_inf,
     &     NER_ij_ref)
      implicit none
      include 'param.inc'
c     NER par rflexion spculaire entre deux mailles i et j
c     La partie change par rflexion au sol est calcule comme la partie
c     change directement entre une maille (-j) imaginaire, symtrique de (j)
c     par-rapport au sol, et la maille (i).
      double precision expint
      double precision epsilon,kai,kaj,z1,z2,z3,z4
      double precision B1,B2,B3,B4
      double precision taui,tauj,tau_B,tau_inf
      double precision B1_ref,B2_ref,B3_ref,B4_ref
      double precision taui_ref,tauj_ref,tau_B_ref
      double precision nerd_ji_direct,NER_ij_ref

c     layer '-j' becomes layer 'i'
      B1_ref=B4
      B2_ref=B3
      taui_ref=kaj*(z4-z3)
c     layer 'i' becomes layer 'j'
      B3_ref=B1
      B4_ref=B2
      tauj_ref=kai*(z2-z1)
c     optical thickness between the two layers
      tau_B_ref=2.0D+0*tau_inf+taui+tau_B
      
      call NERd_ij(B1_ref,B2_ref,B3_ref,B4_ref,
     &     taui_ref,tauj_ref,tau_B_ref,
     &     nerd_ji_direct)      ! [nerd_ji_direct]=W/m/m
      
      NER_ij_ref=-(1.0D+0-epsilon)*
     &     nerd_ji_direct       ! W/m/m
      
      return
      end




      subroutine NERd_ij_specular_reflection_real(epsilon,kai,kaj,
     &     z1,z2,z3,z4,
     &     B1,B2,B3,B4,taui,tauj,tau_B,tau_inf,
     &     NER_ij_ref)
      implicit none
      include 'param.inc'
c     NER par rflexion spculaire entre deux mailles i et j
c     La partie change par rflexion au sol est obtenue  partir de l'expression intgrale.
c     Le rsultat est identique  celui donn par la routine "NERd_ij_specular_reflection_virtual"
      double precision expint
      double precision epsilon,kai,kaj,z1,z2,z3,z4
      double precision B1,B2,B3,B4
      double precision taui,tauj,tau_B,tau_inf
      double precision tau_B1,tau_B2
      double precision a(1:6)
      double precision NER_ij_ref
      double precision val1,val2

      tau_B1=tau_inf
      tau_B2=tau_B1+taui+tau_B
      call a_coeffs(B1,B2,B3,B4,taui,tauj,a)

      NER_ij_ref=2.0D+0*pi*
     &     (1.0D+0-epsilon)*
     &     (
     &     a(1)*expint(3,tau_B1+tau_B2)
     &     +(a(2)+a(4))*expint(4,tau_B1+tau_B2)
     &     +a(3)*expint(3,tau_B1+tau_B2+taui)
     &     -(a(2)+a(4))*expint(4,tau_B1+tau_B2+taui)
     &     +a(5)*expint(3,tau_B1+tau_B2+tauj)
     &     -(a(2)+a(4))*expint(4,tau_B1+tau_B2+tauj)
     &     +a(6)*expint(3,tau_B1+tau_B2+taui+tauj)
     &     +(a(2)+a(4))*expint(4,tau_B1+tau_B2+taui+tauj)
     &     )                    ! W/m/m


      return
      end





      subroutine NERd_ij_diffuse_reflection(epsilon,kai,kaj,
     &     z1,z2,z3,z4,
     &     B1,B2,B3,B4,taui,tauj,tau_B,tau_inf,
     &     NER_ij_ref)
      implicit none
      include 'param.inc'
c     NER par rflexion diffuse entre deux mailles i et j
      double precision expint
      double precision epsilon,kai,kaj,z1,z2,z3,z4
      double precision B1,B2,B3,B4,taui,tauj,tau_B1,tau_B2
      double precision tau_inf,tau_B
      double precision NER_ij_ref
      double precision alpha3,beta3,gamma3,delta3
      double precision a(1:6)

      tau_B1=tau_inf
      tau_B2=tau_B1+taui+tau_B

      call  coeffs3(B1,B2,B3,B4,taui,tauj,tau_B1,tau_B2,
     &     alpha3,beta3,gamma3,delta3)

      NER_ij_ref=4.0D+0*pi*
     &     (1.0D+0-epsilon)*(
     &     alpha3*expint(3,tau_B1)
     &     +beta3*expint(4,tau_B1)
     &     +gamma3*expint(3,tau_B1+taui)
     &     +delta3*expint(4,tau_B1+taui)
     &     )                    ! W/m/m
      
      return
      end


      subroutine coeffs3(B1,B2,B3,B4,taui,tauj,tau_B1,tau_B2,
     &     alpha3,beta3,gamma3,delta3)
      implicit none
      double precision expint
      double precision B1,B2,B3,B4,taui,tauj,tau_B1,tau_B2
      double precision a(1:6)
      double precision alpha3,beta3,gamma3,delta3

      call a_coeffs(B1,B2,B3,B4,taui,tauj,a)

      alpha3=a(1)*expint(3,tau_B2)+a(4)*expint(4,tau_B2)
     &     +a(5)*expint(3,tau_B2+tauj)-a(4)*expint(4,tau_B2+tauj)
      beta3=a(2)*(expint(3,tau_B2)-expint(3,tau_B2+tauj))
      gamma3=a(3)*expint(3,tau_B2)-a(4)*expint(4,tau_B2)
     &     +a(6)*expint(3,tau_B2+tauj)+a(4)*expint(4,tau_B2+tauj)
      delta3=-a(2)*(expint(3,tau_B2)-expint(3,tau_B2+tauj))

      return
      end


      subroutine a_coeffs(B1,B2,B3,B4,taui,tauj,a)
      implicit none
      double precision B1,B2,B3,B4
      double precision taui,tauj
      double precision a(1:6)

      a(1)=B3-B1
      a(2)=(B1-B2)/taui
      a(3)=B2-B3
      a(4)=(B4-B3)/tauj
      a(5)=B1-B4
      a(6)=B4-B2

      return
      end
