c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c     
      subroutine analytic_fluxes(band,quad,B1f,B2f,Fh,Fb,Feh,Feb)
      implicit none
      
      include 'max.inc'
      include 'data.inc'
      include 'options.inc'
      include 'param.inc'

      integer i,md,band,quad
      double precision B1f(0:2*Nmax-1)
      double precision B2f(0:2*Nmax-1)
      double precision Fh(0:2*Nmax-2,1:Nbmx,1:Nqmx)
      double precision Fb(0:2*Nmax-2,1:Nbmx,1:Nqmx)     ! flux monochromatiques
c     Flux mis uniquement
      double precision Feh(0:Nmax,1:Nbmx,1:Nqmx)
      double precision Feb(0:Nmax,1:Nbmx,1:Nqmx)
      
      md=2*(m-1)
c     Production des flux ascendants et descendants  tous les niveaux alti(i)
      do i=0,md                 ! i est le numro de l'interface [0:md]
         if (i.eq.0) then
            call Fasc(band,quad,alti(i),md,1,B1f,B2f,
     &           Fh(i,band,quad))
            call Fdes(band,quad,alti(i),md,1,B1f,B2f,
     &           Fb(i,band,quad))
         else
            call Fasc(band,quad,alti(i),md,i,B1f,B2f,
     &           Fh(i,band,quad))
            call Fdes(band,quad,alti(i),md,i,B1f,B2f,
     &           Fb(i,band,quad))
         endif
      enddo
c     Production des flux mis uniquement, ascendants et descendants,
c      tous les niveaux e(i)
      do i=0,m                  ! i est le numro de l'interface [0:m]
         if (i.eq.0) then
            call Fe_asc(band,quad,e(i),md,1,B1f,B2f,
     &           Feh(i,band,quad))
            call Fe_des(band,quad,e(i),md,1,B1f,B2f,
     &           Feb(i,band,quad))
         else if (i.eq.m) then
            call Fe_asc(band,quad,e(i),md,i,B1f,B2f,
     &           Feh(i,band,quad))
            call Fe_des(band,quad,e(i),md,i,B1f,B2f,
     &           Feb(i,band,quad))
         else
            call Fe_asc(band,quad,e(i),md,i,B1f,B2f,
     &           Feh(i,band,quad))
            call Fe_des(band,quad,e(i),md,i+1,B1f,B2f,
     &           Feb(i,band,quad))
         endif
      enddo                     ! sur i

      return
      end

      

      subroutine Fasc(band,quad,z,md,i,B1,B2,fh)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'options.inc'
      include 'param.inc'
      integer md,i,j
      integer Nb,Nq,band,quad
      double precision expint,z,fh
      double precision kai,kaj
      double precision Tau_gz1,Tau_z3z1,Tau_z4z1
      double precision Tau_z2s,Tau_z2z3,Tau_z2z4
      double precision B1(0:2*Nmax-1),B2(0:2*Nmax-1)
      double precision z1,z2,z3,z4
      double precision tmp1,tmp2,tmp3
      double precision delta_lambda
      double precision Ac,Bc,ka1
      double precision taui,tauj,tauH,tau1,Tau_gz3
      double precision Fd0
      double precision terme1,terme2
c     Calcule le flux ascendant  l'altitude z
c     Entres:
c       + z: altitude de calcul du flux ascendant
c       + md: nombre de mailles dans le tableau "alti"
c       + i: numro de la maille "alti" dans laquelle est situ z
c       + B1: tableau des B au bas des md mailles "alti"
c       + B2: tableau des B en haut des md mailles "alti"

      tauH=0.0D+0
      do j=1,md
         z1=alti(j-1)
         z2=alti(j)
         call find_ka(band,quad,int(j/2)+1,(z1+z2)/2.0D+0,kaj)
         tauH=tauH+kaj*(z2-z1)
      enddo
c     tauH is the optical depth of the atmosphere

      delta_lambda=lambda_hi(band)-lambda_lo(band)
      z1=alti(i-1)
      z2=alti(i)
      if (i.eq.1) then
         Tau_gz1=0.0D+0
      else
         call calc_tau_abs_mlay(band,quad,1,i-1,1,Tau_gz1)
      endif
      call find_ka(band,quad,int(i/2)+1,(z1+z2)/2.0D+0,kai)
      taui=kai*(z2-z1)

      if (ref.eq.1) then ! specular reflection at ground level
         Bc=0
         do j=2,md
            z3=alti(j-1)
            z4=alti(j)
            call find_ka(band,quad,int(j/2)+1,(z3+z4)/2.0D+0,kaj)
            tauj=kaj*(z4-z3)
            call calc_tau_abs_mlay(band,quad,1,j-1,1,Tau_gz3)
            Bc=Bc
     &           +B1(j)*expint(3,Tau_gz1+kai*(z-z1)+Tau_gz3)
     &           +(B2(j)-B1(j))/tauj
     &           *expint(4,Tau_gz1+kai*(z-z1)+Tau_gz3)
     &           -B2(j)*expint(3,Tau_gz1+kai*(z-z1)+Tau_gz3+tauj)
     &           -(B2(j)-B1(j))/tauj
     &           *expint(4,Tau_gz1+kai*(z-z1)+Tau_gz3+tauj)
         enddo
         call find_ka(band,quad,int(i/2)+1,
     &        (alti(1)+alti(0))/2.0D+0,ka1)
         tau1=ka1*(alti(1)-alti(0))
         Ac=B1(1)*expint(3,Tau_gz1+kai*(z-z1))
     &        +(B2(1)-B1(1))/tau1*expint(4,Tau_gz1+kai*(z-z1))
     &        +B2(md+1)*expint(3,tauH+Tau_gz1+kai*(z-z1))
     &        -B2(1)*expint(3,tau1+Tau_gz1+kai*(z-z1))
     &        -(B2(1)-B1(1))/tau1*expint(4,tau1+Tau_gz1+kai*(z-z1))
     &        +Bc
c     "Ac" is the downward flux at ground level
         tmp1=em_sol(band)*B1(0)*expint(3,kai*(z-z1)+Tau_gz1)
     &        +(1.0D+0-em_sol(band))*Ac

      else if (ref.eq.2) then ! diffuse reflection at ground level
         call Fdes(band,quad,0.0D+0,md,1,B1,B2,Fd0)
         tmp1=(em_sol(band)*B1(0)+
     &        (1.0D+0-em_sol(band))*Fd0)
     &        *expint(3,Tau_gz1+kai*(z-z1))

      endif ! over ref

      terme1=tmp1
c     "terme1" is the flux emitted at ground level, plus the downward flux at 
c     ground level that is reflected by the ground, and transmitted to z.
c     It can also be seen as the upward flux at ground level, attenuated to altitude z.

      tmp2=0.0D+0
      if (i.gt.1) then
         do j=1,i-1
            z3=alti(j-1)
            z4=alti(j)
            call find_ka(band,quad,int(j/2)+1,(z3+z4)/2.0D+0,kaj)
            tauj=kaj*(z4-z3)
            if (j.eq.i-1) then
               Tau_z4z1=0.0D+0
            else
               call calc_tau_abs_mlay(band,quad,j+1,i-1,1,Tau_z4z1)
            endif
            call calc_tau_abs_mlay(band,quad,j,i-1,1,Tau_z3z1)
            tmp2=tmp2+B2(j)*expint(3,kai*(z-z1)+Tau_z4z1)
     &           -(B2(j)-B1(j))/tauj*expint(4,kai*(z-z1)+Tau_z4z1)
     &           -B1(j)*expint(3,kai*(z-z1)+Tau_z3z1)
     &           +(B2(j)-B1(j))/tauj*expint(4,kai*(z-z1)+Tau_z3z1)
         enddo
      endif


      tmp3=(B1(i)+(B2(i)-B1(i))/(z2-z1)*(z-z1))/2.0D+0
     &     -(B2(i)-B1(i))/taui/3.0D+0
     &     -B1(i)*expint(3,kai*(z-z1))
     &     +(B2(i)-B1(i))/taui*expint(4,kai*(z-z1))

      terme2=tmp2+tmp3
c     "terme2" is the upward emission attenuated to altitude z.

      fh=2.0D+0*pi*(terme1+terme2)*delta_lambda*w_moy(band,quad)

      return
      end

      


      
      subroutine Fdes(band,quad,z,md,i,B1,B2,fb)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'param.inc'
      double precision expint,z,fb
      double precision dBi,dBj,kai,kaj
      double precision Tau_gz1,Tau_z3z1,Tau_z4z1
      double precision Tau_z2s,Tau_z2z3,Tau_z2z4
      double precision taui,tauj
      double precision B1(0:2*Nmax-1),B2(0:2*Nmax-1)
      integer md,i,j
      double precision z1,z2,z3,z4
      double precision tmp1,tmp2,delta_lambda
      integer Nb,Nq,band,quad
c     Calcule le flux descendant  l'altitude z
c     Entres:
c       + z: altitude de calcul du flux descendant
c       + md: nombre de mailles dans le tableau "alti"
c       + i: numro de la maille "alti" dans laquelle est situ z
c       + B1: tableau des B au bas des md mailles "alti"
c       + B2: tableau des B en haut des md mailles "alti"

      delta_lambda=lambda_hi(band)-lambda_lo(band)
      z1=alti(i-1)
      z2=alti(i)
      dBi=(B2(i)-B1(i))/(z2-z1)
      if (i.eq.md) then
         Tau_z2s=0.0D+0
      else
         call calc_tau_abs_mlay(band,quad,i+1,md,1,Tau_z2s)
      endif
      call find_ka(band,quad,int(i/2)+1,(z1+z2)/2.0D+0,kai)
      taui=kai*(z2-z1)
      tmp1=B2(md+1)*expint(3,kai*(z2-z)+Tau_z2s)
     &     +(B1(i)+dBi*(z-z1))/2.0D+0+(B2(i)-B1(i))/taui/3.0D+0
     &     -B2(i)*expint(3,kai*(z2-z))
     &     -(B2(i)-B1(i))/taui*expint(4,kai*(z2-z))
      tmp2=0.0D+0
      if (i.lt.md) then
         do j=i+1,md
            z3=alti(j-1)
            z4=alti(j)
            dBj=(B2(j)-B1(j))/(z4-z3)
            call find_ka(band,quad,int(j/2)+1,(z3+z4)/2.0D+0,kaj)
            tauj=kaj*(z4-z3)
            if (j.eq.i+1) then
               Tau_z2z3=0.0D+0
            else
               call calc_tau_abs_mlay(band,quad,i+1,j-1,1,Tau_z2z3)
            endif
            call calc_tau_abs_mlay(band,quad,i+1,j,1,Tau_z2z4)
            tmp2=tmp2+B1(j)*expint(3,kai*(z2-z)+Tau_z2z3)
     &           +(B2(j)-B1(j))/tauj*expint(4,kai*(z2-z)+Tau_z2z3)
     &           -B2(j)*expint(3,kai*(z2-z)+Tau_z2z4)
     &           -(B2(j)-B1(j))/tauj*expint(4,kai*(z2-z)+Tau_z2z4)
         enddo
      endif
      fb=2.0D+0*pi*(tmp1+tmp2)*delta_lambda*w_moy(band,quad)

      return
      end

      
      subroutine Fe_asc(band,quad,z,md,i,B1f,B2f,feh)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'param.inc'
      double precision expint,z,feh
      double precision ka1,ka2
      double precision B1f(0:2*Nmax-1),B2f(0:2*Nmax-1)
      double precision B1,B2,B3,dB1,dB2
      integer md,i,j,mdo
      double precision z1,z2,z3
      double precision delta_lambda
      integer Nb,Nq,band,quad
c     Calcule le flux ascendant, mis uniquement dans la maille i,
c      l'altitude z (dans la maille i)
c     Entres:
c       + z: altitude de calcul du flux ascendant
c       + md: nombre de mailles dans le tableau "alti"
c       + i: numro de la maille "e" dans laquelle est situ z
c       + B1: tableau des B au bas des md mailles "alti"
c       + B2: tableau des B en haut des md mailles "alti"

      delta_lambda=lambda_hi(band)-lambda_lo(band)
c     Quelques points de rflexion sur les altitudes et les maillages...

c     Si on a spcifi i=1 ou m, alors on veut calculer le flux
c     mis par la maille "alti" correspondante  la maille i spcifie.
c     Dans ce cas, j est le numro de la maille de "alti" correspondante
c      la maille i de "e"
      if ((i.eq.1).or.(i.eq.m)) then
         mdo=0
         if (i.eq.1) then
            j=1
         else
            j=md
         endif
      endif
c     Si on a spcifi i=2  m-1, alors on veut calculer le flux
c     mis par l'ensemble constitu par les deux mailles de "alti"
c     qui composent la maille i de "e". Dans ce cas, j est le numro
c     de la maille de "alti" la plus basse de ces deux mailles,
c     c'est  dire que la maille i de "e" est constitue par les
c     mailles j et j+1 de "alti".
      if ((i.gt.1).and.(i.lt.m)) then
         mdo=1
         j=2*i-2
      endif

      z1=alti(j-1)
      z2=alti(j)
      B1=B1f(j)
      B2=B2f(j)
      dB1=(B2-B1)/(z2-z1)
      call find_ka(band,quad,int(j/2)+1,(z1+z2)/2.0D+0,ka1)
      if (mdo.eq.1) then
         z3=alti(j+1)
         B3=B2f(j+1)
         dB2=(B3-B2)/(z3-z2)
         call find_ka(band,quad,int((j+1)/2)+1,(z2+z3)/2.0D+0,ka2)
      endif

      if (mdo.eq.0) then ! si on a une maille simple
c     Dans le cas spcial o on veut le flux ascendant au niveau
c     du sol, on le calcule explicitement
         if (z.eq.0.0D+0) then
            feh=pi*B1f(1)*delta_lambda*w_moy(band,quad)
         else ! sinon on calcule le flux mis par le gaz
            feh=2.0D+0*pi*((B1+dB1*(z-z1))/2.0D+0-dB1/(3.0D+0*ka1)
     &           -B1*expint(3,ka1*(z-z1))
     &           +dB1/ka1*expint(4,ka1*(z-z1)))
     &           *delta_lambda*w_moy(band,quad)
         endif
      else ! si on a une maille double
         feh=2.0D+0*pi*((B2+dB2*(z-z2))/2.0D+0-dB2/(3.0D+0*ka2)
     &        +(dB2/ka2-dB1/ka1)*expint(4,ka2*(z-z2))
     &        -B1*expint(3,ka2*(z-z2)+ka1*(z2-z1))
     &        +db1/ka1*expint(4,ka2*(z-z2)+ka1*(z2-z1)))
     &        *delta_lambda*w_moy(band,quad)
      endif ! sur mdo

      return
      end

      
      subroutine Fe_des(band,quad,z,md,i,B1f,B2f,feb)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'param.inc'
      double precision expint,z,feb
      double precision ka1,ka2
      double precision B1f(0:2*Nmax-1),B2f(0:2*Nmax-1)
      double precision B1,B2,B3,dB1,dB2
      integer md,i,j,mdo
      double precision z1,z2,z3
      double precision delta_lambda
      integer Nb,Nq,band,quad
c     Calcule le flux descendant, mis uniquement dans la maille i,
c      l'altitude z (dans la maille i)
c     Entres:
c       + z: altitude de calcul du flux ascendant
c       + m: nombre de mailles dans le tableau "e"
c       + md: nombre de mailles dans le tableau "alti"
c       + i: numro de la maille "e" dans laquelle est situ z
c       + B1: tableau des B au bas des md mailles "alti"
c       + B2: tableau des B en haut des md mailles "alti"

      delta_lambda=lambda_hi(band)-lambda_lo(band)
c     Quelques points de rflexion sur les altitudes et les maillages...

c     Si on a spcifi i=1 ou m, alors on veut calculer le flux
c     mis par la maille "alti" correspondante  la maille i spcifie.
c     Dans ce cas, j est le numro de la maille de "alti" correspondante
c      la maille i de "e"
      if ((i.eq.1).or.(i.eq.m)) then
         mdo=0
         if (i.eq.1) then
            j=1
         else
            j=md
         endif
      endif
c     Si on a spcifi i=2  m-1, alors on veut calculer le flux
c     mis par l'ensemble constitu par les deux mailles de "alti"
c     qui composent la maille i de "e". Dans ce cas, j est le numro
c     de la maille de "alti" la plus basse de ces deux mailles,
c     c'est  dire que la maille i de "e" est constitue par les
c     mailles j et j+1 de "alti".
      if ((i.gt.1).and.(i.lt.m)) then
         mdo=1
         j=2*i-2
      endif

      z1=alti(j-1)
      z2=alti(j)
      B1=B1f(j)
      B2=B2f(j)
      dB1=(B2-B1)/(z2-z1)
      call find_ka(band,quad,int(j/2)+1,(z1+z2)/2.0D+0,ka1)
      if (mdo.eq.1) then
         z3=alti(j+1)
         B3=B2f(j+1)
         dB2=(B3-B2)/(z3-z2)
         call find_ka(band,quad,int((j+1)/2)+1,(z2+z3)/2.0D+0,ka2)
      endif

      if (mdo.eq.0) then ! si on a une maille simple
c     Dans le cas spcial o on veut le flux descendant au sommet
c     de l'atmosphre, on le calcule explicitement
         if (z.eq.alti(md)) then
            feb=pi*B2f(md)*delta_lambda*w_moy(band,quad)
         else ! sinon on calcule le flux mis par le gaz
            feb=2.0D+0*pi*((B1+dB1*(z-z1))/2.0D+0+dB1/(3.0D+0*ka1)
     &           -B2*expint(3,ka1*(z2-z))
     &           -dB1/ka1*expint(4,ka1*(z2-z)))
     &           *delta_lambda*w_moy(band,quad)
         endif
      else ! si on a une maille double
         feb=2.0D+0*pi*((B1+dB1*(z-z1))/2.0D+0+dB1/(3.0D+0*ka1)
     &        +(dB2/ka2-db1/ka1)*expint(4,ka1*(z2-z))
     &        -B3*expint(3,ka1*(z2-z)+ka2*(z3-z2))
     &        -dB2/ka2*expint(4,ka1*(z2-z)+ka2*(z3-z2)))
     &        *delta_lambda*w_moy(band,quad)
      endif ! sur mdo

      return
      end
