c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine calc_e2(m2,e2,pres2,pres_gcm,alt2)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'options.inc'
      include 'param.inc'

      integer i,i1,i2,m2,f,i20,out
      double precision a,dalt
      double precision pres_init(0:Nmax)
      double precision alt2(0:Nmax)
      double precision e2(0:Nmax)
      double precision pres2(0:Nmax)
      double precision pres_gcm(0:Nmax)

      do i=0,m-1
         pres_init(i)=pres(i)
      enddo

c     Debug
c      write(*,*) 'm2=',m2
c      do i=0,m2-1
c         write(*,*) 'pres2(',i,')=',pres2(i)
c      enddo
c      stop
c     Debug

c     Je normalise les anciens niveaux de pression pour que les pressions
c     au sol soient les mmes entre l'ancienne et la nouvelle grille
c     de pression
c     Comment le 08/02/2007
c      if (ga0.eq.1) then
c         do i=0,m-1
c            pres(i)=pres_init(i)/pres_init(0)*pres2(0)
c         enddo
c      endif
c     Comment le 08/02/2007

c     Calcul du tableau alt2, qui comporte les altitudes
c     auxquelles sont fournies les pressions pres2

c     ga0=1 conservation des quantits d'absorbant
      if (ga0.eq.1) then
         alt2(0)=alt(0)
         i20=1
      else
         i20=0
      endif
      do i2=i20,m2-1
c     trouver 'i1' tel que pres(i1) > pres2(i2) > pres(i1+1)
         call find_pres_i1(pres2(i2),i1,out)
         if (out.eq.-1) then
c     Si le niveau de pression est suprieur  la pression du sol
c     pour l'ancienne grille
            i1=0
c     On interpolle entre les 2 premiers niveaux de pression connus
         else if (out.eq.1) then
c     Si le niveau de pression est infrieur  la pression
c     du sommet du modle pour l'ancienne grille
            i1=m-2
c     On interpolle entre les 2 derniers niveaux de pression connus
         endif
c     Interpolation exponentielle pour trouver alt2(i2):
c     p(z)=pres(i1)*exp[-a(z-alt(i))]
         call p2z(pres(i1),pres(i1+1),pres2(i2),
     &        alt(i1),alt(i1+1),alt2(i2))
c         a=dlog(pres(i1)/pres(i1+1))/(alt(i1+1)-alt(i1))
c         alt2(i2)=alt(i1)+dlog(pres(i1)/pres2(i2))/a
c     Debug
c         if (dabs(pres2(i2)/101300-40.0).lt.1.0D+1) then
c            write(*,*) 'pres2(',i2,')=',pres2(i2),' Pa'
c            write(*,*) 'pres2(',i2,')=',pres2(i2)/101300,' bar'
c            write(*,*) 'alt2(',i2,')=',alt2(i2)
c         endif
c     Debug
c     Debug
c         if (i2.eq.m2-1) then
c            write(*,*) 'out=',out,' m=',m,' i1=',i1
c            write(*,*) 'P1=pres(',i1,')=',pres(i1)
c            write(*,*) 'pres(',m-1,')=',pres(m-1)
c            write(*,*) 'P2=pres(',i1+1,')=',pres(i1+1)
c            write(*,*) 'z1=',alt(i1),' z2=',alt(i1+1)
c            write(*,*) 'P=',pres2(i2)
c            write(*,*) 'a=',a
c            write(*,*) 'alt2(',i2,')=',alt2(i2)
c         endif
c     Debug
      enddo ! sur i2
      if (ga0.eq.1) then
         alt2(m2-1)=alt(m-1)
      endif

c     Debug
c      do i=0,m2-1
c         write(*,*) 'pres2(',i,')=',pres2(i),' alt2(',i,')=',alt2(i)
c      enddo
c      stop
c     Debug

c     Calcul du tableau e2
      do i2=0,m2
c     trouver 'i1' tel que pres(i1) > pres_gcm(i2) > pres(i1+1)
         call find_pres_i1(pres2(i2),i1,out)
         if (out.eq.-1) then
c     Si le niveau de pression est suprieur  la pression du sol
c     pour l'ancienne grille
            i1=0
c     On interpolle entre les 2 premiers niveaux de pression connus
         else if (out.eq.1) then
c     Si le niveau de pression est infrieur  la pression
c     du sommet du modle pour l'ancienne grille
            i1=m-2
c     On interpolle entre les 2 derniers niveaux de pression connus
         endif
c     Interpolation exponentielle pour trouver alt2(i2):
c     p(z)=pres(i1)*exp[-a(z-alt(i))]
         call p2z(pres(i1),pres(i1+1),pres_gcm(i2),
     &        alt(i1),alt(i1+1),e2(i2))
      enddo

c     Debug
      open(11,file='./results/e2.txt')
      do i=0,m2-1
         write(11,*) i,pres2(i),e2(i),alt2(i)
      enddo
      write(11,*) m2,e2(m2)
      close(11)
c      stop
c     Debug


      return
      end
