c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine calc_stop(band,quad,DeltaXmax,Bo,ksi_min)

      implicit none

c     Cette routine calcule le poids minimal que peut atteindre un rayon avant que son
c     chemin ne soit arrt.
c
c     Entres :
c       + DeltaXmax : delta T maximum dans l'atmosphre
c       + Bo : luminance du point de dpart du rayon
c
c     Sorties :
c       + ksi_min : poids minimal
c     

      include 'param.inc'
      include 'max.inc'
      include 'data.inc'
      include 'options.inc'
      double precision Bo,ksi_min,dBmax
      double precision ksi_pne,ksi_flux,ksi_fnet
      double precision Planck
      double precision Xsol,Xespace,DeltaXmax,de_min,de
      integer i,ptl,profil,band,quad

c     Calcul de DeltaBmax

      dBmax=Planck(DeltaXmax,lambda_lo(band),lambda_hi(band))

c     Recherche de la maille atmosphrique la plus petite
      de_min=e(1)-e(0)
      do i=2,m
         de=e(i)-e(i-1)
         if (de.lt.de_min) then
            de_min=de
         endif
      enddo ! sur i
c     de_min est l'paisseur (en mtres) de la maille atmosphrique
c     la plus petite

c     Calcul des deux critres d'arrt, pour les pne et pour les flux
      ksi_pne=eps_pne/dBmax*de_min
      ksi_flux=eps_flux/Bo
      ksi_fnet=eps_fnet/dBmax

c     Calcul du critre d'arrt minimal
      ksi_min=ksi_pne
      if (ksi_flux.lt.ksi_min) then
         ksi_min=ksi_flux
      endif

      if (ksi_fnet.lt.ksi_min) then
         ksi_min=ksi_fnet
      endif

      return
      end
