c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine check_results(Nb)
      implicit none
      include 'max.inc'
      include 'param.inc'
      include 'data.inc'
      include 'options.inc'
      include 'files_out.inc'
      include 'formats.inc'
c     Purpose: to check every result written by the code to files for NaN and Inf values.
c     Values identified as a NaN or a Inf will be reported in a log file
      integer i,j,band,out1,out2,ef,Nb
      double precision raf1,raf2,z
      double precision psib(0:Nmax),inc_psib(0:Nmax)
      double precision psib_gg(0:Nmax),inc_psib_gg(0:Nmax)
      double precision psib_gp(0:Nmax),inc_psib_gp(0:Nmax)
      double precision psib_gs(0:Nmax),inc_psib_gs(0:Nmax)
      double precision psib_ge(0:Nmax),inc_psib_ge(0:Nmax)
      double precision pnef(0:Nmax+1,0:Nmax+1)
      double precision inc_pnef(0:Nmax+1,0:Nmax+1)
      double precision fnetb_pne(0:Nmax)
      double precision inc_fnetb_pne(0:Nmax)
      double precision psi_seb,inc_psi_seb
      double precision ksi(0:Nmax+1,0:Nmax+1)
      double precision ksi_theo(0:Nmax+1,0:Nmax+1)
      double precision tPNE(0:Nmax+1,0:Nmax+1)
      double precision inc_tPNE(0:Nmax+1,0:Nmax+1)
      double precision tPNEsym(0:Nmax+1,0:Nmax+1)
      double precision inc_tPNEsym(0:Nmax+1,0:Nmax+1)
      double precision tCRsym(0:Nmax+1,0:Nmax+1)
      double precision inc_tCRsym(0:Nmax+1,0:Nmax+1)
      double precision tbil_gg(1:Nmax),inc_tbil_gg(1:Nmax)
      double precision tbil_pg(1:Nmax),inc_tbil_pg(1:Nmax)
      double precision best_bilan(0:Nmax),inc_best_bilan(0:Nmax)
      double precision best_cr(0:Nmax),inc_best_cr(0:Nmax)
      double precision tpsi(1:Nmax),inc_tpsi(1:Nmax)
      double precision tpsi_rev(1:Nmax),inc_tpsi_rev(1:Nmax)
      double precision tpsi3(1:Nmax),inc_tpsi3(1:Nmax)
      double precision fasc(0:Nmax+1,0:Nmax)
      double precision fdes(0:Nmax+1,0:Nmax)
      double precision inc_fasc(0:Nmax+1,0:Nmax)
      double precision inc_fdes(0:Nmax+1,0:Nmax)
      double precision fasct(0:Nmax)
      double precision fdest(0:Nmax)
      double precision inc_fasct(0:Nmax)
      double precision inc_fdest(0:Nmax)
      double precision fnett(0:Nmax)
      double precision inc_fnett(0:Nmax)
      double precision fnett_pne(0:Nmax)
      double precision inc_fnett_pne(0:Nmax)
      
      call screen(37,0,0,0.D+0,0.0D+0)

      open(77,file='./results/errors.log')
      write(77,*) 'Karine errors log file'
      ef=0
      

c     Results per narrowband
      open(10,file=file_bil_freq)
      open(11,file=file_inc_bil_freq)
      open(12,file=file_bil_freq_gg)
      open(13,file=file_inc_bil_freq_gg)
      open(14,file=file_bil_freq_gp)
      open(15,file=file_inc_bil_freq_gp)
      open(16,file=file_bil_freq_gs)
      open(17,file=file_inc_bil_freq_gs)
      open(18,file=file_bil_freq_ge)
      open(19,file=file_inc_bil_freq_ge)
      open(20,file='./results/psi_sol_esp.txt')
      open(21,file=file_pne_mono)
      open(22,file='./results/Flux_nets_mono-nu.txt')
      open(23,file='./results/ksi.txt')
      open(24,file='./results/ksi_theo.txt')
      read(21,*) ! m,Nb
      read(22,*) ! m,Nb
      read(23,*) ! m,Nb
      read(24,*) ! m,Nb

      do band=1,Nb
c         call signal_handler()  ! signal handling
         if ((srf.eq.1).and.((band.ge.nb_min).and.
     &        (band.le.nb_max))) then
            read(10,50) (psib(i),i=1,m)
            read(11,50) (inc_psib(i),i=1,m)
            read(12,50) (psib_gg(i),i=1,m)
            read(13,50) (inc_psib_gg(i),i=1,m)
            read(14,50) (psib_gp(i),i=1,m)
            read(15,50) (inc_psib_gp(i),i=1,m)
            read(16,50) (psib_gs(i),i=1,m)
            read(17,50) (inc_psib_gs(i),i=1,m)
            read(18,50) (psib_ge(i),i=1,m)
            read(19,50) (inc_psib_ge(i),i=1,m)
            read(20,*) raf1,raf2,psi_seb,inc_psi_seb
            if (cpm.eq.1) then
               read(21,*)       ! lambda_lo(band),lambda_hi(band)
               do i=0,m+1
                  read(21,50) (pnef(i,j),j=0,m+1)
                  read(21,50) (inc_pnef(i,j),j=0,m+1)
               enddo
               read(22,*)       ! lambda_lo(band),lambda_hi(band)
               read(22,50) (fnetb_pne(i),i=0,m)
               read(22,50) (inc_fnetb_pne(i),i=0,m)
               read(22,50)
               read(22,50)
               read(23,*)       ! lambda_lo(band),lambda_hi(band)
               read(24,*)       ! lambda_lo(band),lambda_hi(band)
            endif               ! cpm
            do i=0,m+1
               read(23,50) (ksi(i,j),j=0,m+1) ! sr.m/cm
               read(24,50) (ksi_theo(i,j),j=0,m+1) ! sr.m/cm
            enddo
            
            call test_nan(psi_seb,out1)
            call test_inf(psi_seb,out2)
            if ((out1.eq.1).or.(out2.eq.1)) then
               ef=1
               write(77,*) 'NER ground-space=',psi_seb
            endif

            call test_nan(inc_psi_seb,out1)
            call test_inf(inc_psi_seb,out2)
            if ((out1.eq.1).or.(out2.eq.1)) then
               ef=1
               write(77,*) 'NER ground-space unc.=',inc_psi_seb
            endif


            do i=1,m

               call test_nan(psib(i),out1)
               call test_inf(psib(i),out2)
               if ((out1.eq.1).or.(out2.eq.1)) then
                  ef=1
                  write(77,*) 'Budget for band=',band,' layer=',i,'=',
     &                 psib(i)
               endif

               call test_nan(inc_psib(i),out1)
               call test_inf(inc_psib(i),out2)
               if ((out1.eq.1).or.(out2.eq.1)) then
                  ef=1
                  write(77,*) 'Budget uncertainty for band=',band,
     &                 ' layer=',i,'=',inc_psib(i)
               endif

               call test_nan(psib_gg(i),out1)
               call test_inf(psib_gg(i),out2)
               if ((out1.eq.1).or.(out2.eq.1)) then
                  ef=1
                  write(77,*) 'Gas-gas budget for band=',band,
     &                 ' layer=',i,'=',psib_gg(i)
               endif

               call test_nan(inc_psib_gg(i),out1)
               call test_inf(inc_psib_gg(i),out2)
               if ((out1.eq.1).or.(out2.eq.1)) then
                  ef=1
                  write(77,*) 'Gas-gas budget uncertainty for band=',
     &                 band,' layer=',i,'=',inc_psib_gg(i)
               endif

               call test_nan(psib_gp(i),out1)
               call test_inf(psib_gp(i),out2)
               if ((out1.eq.1).or.(out2.eq.1)) then
                  ef=1
                  write(77,*) 'Gas-boundary budget for band=',band,
     &                 ' layer=',i,'=',psib_gp(i)
               endif

               call test_nan(inc_psib_gp(i),out1)
               call test_inf(inc_psib_gp(i),out2)
               if ((out1.eq.1).or.(out2.eq.1)) then
                  ef=1
                  write(77,*) 'Gas-boundary budget unc. for band=',
     &                 band,' layer=',i,'=',inc_psib_gp(i)
               endif

               call test_nan(psib_gs(i),out1)
               call test_inf(psib_gs(i),out2)
               if ((out1.eq.1).or.(out2.eq.1)) then
                  ef=1
                  write(77,*) 'Gas-surface budget for band=',band,
     &                 ' layer=',i,'=',psib_gs(i)
               endif

               call test_nan(inc_psib_gs(i),out1)
               call test_inf(inc_psib_gs(i),out2)
               if ((out1.eq.1).or.(out2.eq.1)) then
                  ef=1
                  write(77,*) 'Gas-surface budget unc. for band=',
     &                 band,' layer=',i,'=',inc_psib_gs(i)
               endif

               call test_nan(psib_ge(i),out1)
               call test_inf(psib_ge(i),out2)
               if ((out1.eq.1).or.(out2.eq.1)) then
                  ef=1
                  write(77,*) 'Gas-space budget for band=',band,
     &                 ' layer=',i,'=',psib_ge(i)
               endif

               call test_nan(inc_psib_ge(i),out1)
               call test_inf(inc_psib_ge(i),out2)
               if ((out1.eq.1).or.(out2.eq.1)) then
                  ef=1
                  write(77,*) 'Gas-space budget unc. for band=',
     &                 band,' layer=',i,'=',inc_psib_ge(i)
               endif

            enddo ! i

            if (cpm.eq.1) then
               do i=0,m+1
                  do j=0,m+1

                     call test_nan(pnef(i,j),out1)
                     call test_inf(pnef(i,j),out2)
                     if ((out1.eq.1).or.(out2.eq.1)) then
                        ef=1
                        write(77,*) 'NER for band=',
     &                       band,' i=',i,' j=',j,'=',pnef(i,j)
                     endif      ! out

                     call test_nan(inc_pnef(i,j),out1)
                     call test_inf(inc_pnef(i,j),out2)
                     if ((out1.eq.1).or.(out2.eq.1)) then
                        ef=1
                        write(77,*) 'NER uncertainty for band=',
     &                       band,' i=',i,' j=',j,'=',inc_pnef(i,j)
                     endif      ! out

                  enddo         ! j

                  call test_nan(fnetb_pne(i),out1)
                  call test_inf(fnetb_pne(i),out2)
                  if ((out1.eq.1).or.(out2.eq.1)) then
                     ef=1
                     write(77,*) 'Net flux for band=',
     &                    band,' layer=',i,'=',fnetb_pne(i)
                  endif         ! out

                  call test_nan(inc_fnetb_pne(i),out1)
                  call test_inf(inc_fnetb_pne(i),out2)
                  if ((out1.eq.1).or.(out2.eq.1)) then
                     ef=1
                     write(77,*) 'Net flux uncertainty for band=',
     &                    band,' layer=',i,'=',inc_fnetb_pne(i)
                  endif         ! out

               enddo            ! i
            endif               ! cpm

            do i=0,m+1
               do j=0,m+1

                  call test_nan(ksi(i,j),out1)
                  call test_inf(ksi(i,j),out2)
                  if ((out1.eq.1).or.(out2.eq.1)) then
                     ef=1
                     write(77,*) 'ksi for band=',
     &                    band,' i=',i,' j=',j,'=',ksi(i,j)
                  endif         ! out
                  call test_nan(ksi_theo(i,j),out1)
                  call test_inf(ksi_theo(i,j),out2)
                  if ((out1.eq.1).or.(out2.eq.1)) then
                     ef=1
                     write(77,*) 'analytic ksi for band=',
     &                    band,' i=',i,' j=',j,'=',ksi_theo(i,j)
                  endif         ! out
                  
               enddo ! j
            enddo ! i


         endif                  ! srf

      enddo                     ! band

      close(10)
      close(11)
      close(12)
      close(13)
      close(14)
      close(15)
      close(16)
      close(17)
      close(18)
      close(19)
      close(20)
      close(21)
      close(22)
      close(23)
      close(24)

c     Spectrally integrated NERs
      open(10,file=file_pne)
      open(11,file=file_pnesym)
      open(12,file=file_CR)
      do i=0,m+1
         do j=0,m+1

            read(10,*) tPNE(i,j),inc_tPNE(i,j)
            call test_nan(tPNE(i,j),out1)
            call test_inf(tPNE(i,j),out2)
            if ((out1.eq.1).or.(out2.eq.1)) then
               ef=1
               write(77,*) 'NER for i=',i,' j=',j,'=',tPNE(i,j)
            endif               ! out
            call test_nan(inc_tPNE(i,j),out1)
            call test_inf(inc_tPNE(i,j),out2)
            if ((out1.eq.1).or.(out2.eq.1)) then
               ef=1
               write(77,*) 'NER unc. for i=',i,' j=',j,
     &              '=',inc_tPNE(i,j)
            endif               ! out
            
            read(11,*) tPNEsym(i,j),inc_tPNEsym(i,j)
            call test_nan(tPNEsym(i,j),out1)
            call test_inf(tPNEsym(i,j),out2)
            if ((out1.eq.1).or.(out2.eq.1)) then
               ef=1
               write(77,*) 'Symetrical NER for i=',i,' j=',j,
     &              '=',tPNEsym(i,j)
            endif               ! out
            call test_nan(inc_tPNEsym(i,j),out1)
            call test_inf(inc_tPNEsym(i,j),out2)
            if ((out1.eq.1).or.(out2.eq.1)) then
               ef=1
               write(77,*) 'Symetrical NER unc. for i=',i,' j=',j,
     &              '=',inc_tPNEsym(i,j)
            endif               ! out

            read(12,*) tCRsym(i,j),inc_tCRsym(i,j)
            call test_nan(tCRsym(i,j),out1)
            call test_inf(tCRsym(i,j),out2)
            if ((out1.eq.1).or.(out2.eq.1)) then
               ef=1
               write(77,*) 'Symetrical CR for i=',i,' j=',j,
     &              '=',tCRsym(i,j)
            endif               ! out
            call test_nan(inc_tCRsym(i,j),out1)
            call test_inf(inc_tCRsym(i,j),out2)
            if ((out1.eq.1).or.(out2.eq.1)) then
               ef=1
               write(77,*) 'Symetrical CR unc. for i=',i,' j=',j,
     &              '=',inc_tCRsym(i,j)
            endif               ! out

         enddo ! j
      enddo ! i
      close(10)
      close(11)
      close(12)

c     Spectrally integrated budgets
      open(10,file=file_tsource)
      do i=1,m
         read(10,55) z,
     &        tbil_gg(i),
     &        inc_tbil_gg(i),
     &        tbil_pg(i),
     &        inc_tbil_pg(i),
     &        best_bilan(i),
     &        inc_best_bilan(i),
     &        best_cr(i),
     &        inc_best_cr(i)

         call test_nan(tbil_gg(i),out1)
         call test_inf(tbil_gg(i),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Gas-gas budget for i=',i,
     &           '=',tbil_gg(i)
         endif                  ! out
         call test_nan(inc_tbil_gg(i),out1)
         call test_inf(inc_tbil_gg(i),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Gas-gas budget unc. for i=',i,
     &           '=',inc_tbil_gg(i)
         endif                  ! out

         call test_nan(tbil_pg(i),out1)
         call test_inf(tbil_pg(i),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Gas-boundary budget for i=',i,
     &           '=',tbil_pg(i)
         endif                  ! out
         call test_nan(inc_tbil_pg(i),out1)
         call test_inf(inc_tbil_pg(i),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Gas-boundary budget unc. for i=',i,
     &           '=',inc_tbil_pg(i)
         endif                  ! out

         call test_nan(best_bilan(i),out1)
         call test_inf(best_bilan(i),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Budget for i=',i,
     &           '=',best_bilan(i)
         endif                  ! out
         call test_nan(inc_best_bilan(i),out1)
         call test_inf(inc_best_bilan(i),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Budget unc. for i=',i,
     &           '=',inc_best_bilan(i)
         endif                  ! out

         call test_nan(best_cr(i),out1)
         call test_inf(best_cr(i),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'CR for i=',i,
     &           '=',best_cr(i)
         endif                  ! out
         call test_nan(inc_best_cr(i),out1)
         call test_inf(inc_best_cr(i),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'CR unc. for i=',i,
     &           '=',inc_best_cr(i)
         endif                  ! out

      enddo
      close(10)

      open(11,file='./results/Tsource2.txt')
      do i=1,m
         read(11,50) tpsi(i),inc_tpsi(i),
     &        tpsi_rev(i),inc_tpsi_rev(i),
     &        tpsi3(i),inc_tpsi3(i)

         call test_nan(tpsi(i),out1)
         call test_inf(tpsi(i),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Direct budget for i=',i,
     &           '=',tpsi(i)
         endif                  ! out
         call test_nan(inc_tpsi(i),out1)
         call test_inf(inc_tpsi(i),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Direct budget unc. for i=',i,
     &           '=',inc_tpsi(i)
         endif                  ! out

         call test_nan(tpsi_rev(i),out1)
         call test_inf(tpsi_rev(i),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Reverse budget for i=',i,
     &           '=',tpsi_rev(i)
         endif                  ! out
         call test_nan(inc_tpsi_rev(i),out1)
         call test_inf(inc_tpsi_rev(i),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Reverse budget unc. for i=',i,
     &           '=',inc_tpsi_rev(i)
         endif                  ! out

         call test_nan(tpsi3(i),out1)
         call test_inf(tpsi3(i),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Budget as sum for i=',i,
     &           '=',tpsi3(i)
         endif                  ! out
         call test_nan(inc_tpsi3(i),out1)
         call test_inf(inc_tpsi3(i),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Budget as sum unc. for i=',i,
     &           '=',inc_tpsi3(i)
         endif                  ! out

      enddo ! i
      close(11)


      open(10,file=file_flux_ascendants)
      open(11,file=file_flux_descendants)
      open(12,file=file_flux_ascendants_totaux)
      open(13,file=file_flux_descendants_totaux)
      open(14,file='./results/Flux_nets_int.txt')
      do j=0,m
         read(10,50) (fasc(i,j),i=0,m+1)
         read(10,50) (inc_fasc(i,j),i=0,m+1)
         read(11,50) (fdes(i,j),i=0,m+1)
         read(11,50) (inc_fdes(i,j),i=0,m+1)
         read(12,*) raf1,fasct(j),inc_fasct(j)
         read(13,*) raf1,fdest(j),inc_fdest(j)
         read(14,50) raf1,fnett(j),inc_fnett(j),
     &        fnett_pne(j),inc_fnett_pne(j)

         do i=0,m+1
            call test_nan(fasc(i,j),out1)
            call test_inf(fasc(i,j),out2)
            if ((out1.eq.1).or.(out2.eq.1)) then
               ef=1
               write(77,*) 'Upward flux for i=',i,' j=',j,
     &              '=',fasc(i,j)
            endif               ! out
            call test_nan(inc_fasc(i,j),out1)
            call test_inf(inc_fasc(i,j),out2)
            if ((out1.eq.1).or.(out2.eq.1)) then
               ef=1
               write(77,*) 'Upward flux unc. for i=',i,' j=',j,
     &              '=',inc_fasc(i,j)
            endif               ! out

            call test_nan(fdes(i,j),out1)
            call test_inf(fdes(i,j),out2)
            if ((out1.eq.1).or.(out2.eq.1)) then
               ef=1
               write(77,*) 'Downward flux for i=',i,' j=',j,
     &              '=',fdes(i,j)
            endif               ! out
            call test_nan(inc_fdes(i,j),out1)
            call test_inf(inc_fdes(i,j),out2)
            if ((out1.eq.1).or.(out2.eq.1)) then
               ef=1
               write(77,*) 'Downward flux unc. for i=',i,' j=',j,
     &              '=',inc_fdes(i,j)
            endif               ! out

         enddo ! i
         
         call test_nan(fasct(j),out1)
         call test_inf(fasct(j),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Total upward flux for i=',j,
     &           '=',fasct(j)
         endif                  ! out
         call test_nan(inc_fasct(j),out1)
         call test_inf(inc_fasct(j),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Total upward flux unc. for i=',j,
     &           '=',inc_fasct(j)
         endif

         call test_nan(fdest(j),out1)
         call test_inf(fdest(j),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Total downward flux for i=',j,
     &           '=',fdest(j)
         endif                  ! out
         call test_nan(inc_fdest(j),out1)
         call test_inf(inc_fdest(j),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Total downward flux unc. for i=',j,
     &           '=',inc_fdest(j)
         endif                  ! out

         call test_nan(fnett(j),out1)
         call test_inf(fnett(j),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Total net flux for i=',j,
     &           '=',fnett(j)
         endif                  ! out
         call test_nan(inc_fnett(j),out1)
         call test_inf(inc_fnett(j),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Total net flux unc. for i=',j,
     &           '=',inc_fnett(j)
         endif                  ! out

         call test_nan(fnett_pne(j),out1)
         call test_inf(fnett_pne(j),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Total net flux as sum of NERs for i=',j,
     &           '=',fnett_pne(j)
         endif                  ! out
         call test_nan(inc_fnett_pne(j),out1)
         call test_inf(inc_fnett_pne(j),out2)
         if ((out1.eq.1).or.(out2.eq.1)) then
            ef=1
            write(77,*) 'Total net flux as sum of NERs unc. for i=',j,
     &           '=',inc_fnett_pne(j)
         endif                  ! out
         
      enddo ! j
      close(10)
      close(11)
      close(12)
      close(13)
      close(14)

      if (ef.eq.0) then ! no error detected
         call screen(1202,0,0,0.D+0,0.0D+0)
         write(77,*) 'No invalid result was found'
      else ! presence of errors
         call screen(1203,0,0,0.D+0,0.0D+0)
      endif

      close(77)

      return
      end
