c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine cumul_phase()

      implicit none

c     Cette routine calcule la cumule de la fonction de phase sur
c     l'intervalle de mu=[-1,1]
c     Le fichier contenant les valeurs de la fonction de phase doit
c     contenir : d'abord le nombre de points de discrtisation
c     de la fonction de phase, puis deux colonnes ; en premire
c     colonne, les valeurs de mu=cos(theta), et en seconde
c     colonne, les valeurs de la fonction de phase.
c     Attention : on veut absolument que l'intgrale de la fonction
c     de phase ainsi dfinie soit gale  1 !
c

      include 'max.inc'
      include 'data.inc'
      include 'files_in.inc'
      integer i,j,out
      double precision phase(1:Nmax,1:PhMax),mu(1:Nmax,1:PhMax)
      double precision delta_mu,somme,sum_g
      
      out=1

      open(10,file=file_phase)
      call screen(36,0,0,0.0D+0,0.0D+0)
      

      do j=1,m
         read(10,*) n_ph(j)
         do i=1,n_ph(j)
            read(10,*) mu(j,i),phase(j,i)
         enddo ! sur i
      enddo ! sur j
      close(10)

      do j=1,m
         somme=0.0D+0
         do i=2,n_ph(j)
            delta_mu=dabs(mu(j,i)-mu(j,i-1))
            somme=somme+delta_mu*(phase(j,i)+phase(j,i-1))/2.0D+0
         enddo ! sur i
c     Eventuellement si on a trs mal fait les choses et que l'intgrale
c     de la fonction de phase ne soit pas gale  1 -> on normalise

c     Debug
c         write(*,*) 'j=',j,' somme=',somme
c     Debug
         
         do i=1,n_ph(j)
            phase(j,i)=phase(j,i)/somme
         enddo

c     Calcul du paramtre d'assymtrie correspondant  cette fonction
c     de phase
         sum_g=0.0D+0
         do i=2,n_ph(j)
            delta_mu=dabs(mu(j,i)-mu(j,i-1))
            sum_g=sum_g+delta_mu*(phase(j,i-1)+phase(j,i))/2.0D+0*
     &           (mu(j,i)+mu(j,i-1))/2.0D+0
         enddo ! sur i
         g_util=sum_g
c     Debug
c         write(*,*) 'j=',j,' g_util=',g_util
c     Debug

c     Calcul de la fonction cumule cumul_ph
         cumul_ph(j,1,1)=mu(j,1)
         cumul_ph(j,1,2)=0.0D+0
         do i=2,n_ph(j)
            delta_mu=dabs(mu(j,i)-mu(j,i-1))
            cumul_ph(j,i,1)=mu(j,i)
            cumul_ph(j,i,2)=cumul_ph(j,i-1,2)+delta_mu*
     &           (phase(j,i)+phase(j,i-1))/2.0D+0
         enddo ! sur i
c     Debug
c            write(*,*) cumul_ph(j,1,1),cumul_ph(j,1,2)
c            write(*,*) cumul_ph(j,n_ph(j),1),cumul_ph(j,n_ph(j),2)
c     Debug
      enddo ! sur j

      return
      end

      
