c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      double precision function dBdT(T,lambda)
      implicit none
      include 'max.inc'
      include 'param.inc'
      include 'data.inc'
c     Cette function calcule la drive de la luminance de Planck
c     par rapport  la temprature
c      une valeur de la temprature et de la longueur d'onde
c
c     Entres :
c       + T : temprature en Kelvin
c       + lambda: longueur d'onde (en m)
c
c     Sorties :
c       + dBdT : valeur de la drive de la luminance de Planck
c                par rapport  la temprature
c
      double precision in,c1,c2,T
      double precision lambda

      c1=2*pi*hPl*c0**2 ! W.m2
      c2=hPl*c0/kBz*1.D+6 ! m.K
c     ATTENTION ! lambda doit tre entre en micromtres !

c      write(*,*) 'c1=',c1,'W.m2'
c      write(*,*) 'c2=',c2,'m.K'

      if (T.eq.0) then
         dBdT=0.0D+0
      else
         dBdT=1.0D+24/pi*c1*c2*dexp(c2/(T*lambda))/
     &        (lambda**6*T**2*(dexp(c2/
     &        (T*lambda))-1.0D+0)**2)
      endif

      return
      end
