c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine distri(m,m2,e,e2,i_start,i_end,k,k2)
      implicit none
      include 'max.inc'
      include 'param.inc'
      include 'options.inc'
      
      integer m,m2,i,j,i2
      integer i_start(1:Nmax)
      integer i_end(1:Nmax)
      double precision e(0:Nmax),e2(0:Nmax)
      double precision k(1:Nmax),k2(1:Nmax)
      double precision tot,tot2,H,H2
      double precision min
      parameter(min=1.0D-10)
      
c     Purpose: to distribute optical depths from the initial 'e' grid
c     to the final 'e2' grid
      do i2=1,m2
         k2(i2)=0.0D+0
c     Si la maille i2 "nouvelle" est entirement incluse dans une mme
c     maille "ancienne", alors on lui affecte le mme coefficient
         if (i_start(i2).eq.i_end(i2)) then
            k2(i2)=k(i_start(i2))
c     Sinon la maille i2 "nouvelle" s'tend sur au moins deux mailles
c     "anciennes". Il faut calculer un coefficient qui correspond 
c     une moyenne pondre des coefficients des mailles "anciennes"
c     concernes
         else
            k2(i2)=k(i_start(i2))*(e(i_start(i2))-e2(i2-1))
            if (i_end(i2).gt.i_start(i2)+1) then
               do j=i_start(i2)+1,i_end(i2)-1
                  k2(i2)=k2(i2)+k(j)*(e(j)-e(j-1))
               enddo
            endif
            k2(i2)=k2(i2)+k(i_end(i2))*(e2(i2)-e(i_end(i2)-1))
            k2(i2)=k2(i2)/(e2(i2)-e2(i2-1))
         endif

      enddo ! sur i2

c     Vrification pour s'assurer qu'on a bien les mmes quantits d'absorbant
c     au dpart et sur la grille "nouvelle"

      tot=0.0D+0
      do i=1,m
         tot=tot+k(i)*(e(i)-e(i-1))
      enddo
      tot2=0.0D+0
      do i=1,m2
         tot2=tot2+k2(i)*(e2(i)-e2(i-1))
      enddo
      
      if ((tot.ne.0.0D+0).and.(ga0.eq.1).and.
     &     ((tot2/tot.lt.1.0D+0-min).or.(tot2/tot.gt.1.0D+0+min))) then
         call screen(1121,0,0,tot,tot2)

         do i=1,m2
            if (dabs(k2(i)/k(1)-1.0D+0).gt.1.D-5) then
               call screen(1122,i,0,k(i),k2(i))
            endif
         enddo

         H=0.0D+0
         H2=0.0D+0
         do i=1,m
            H=H+e(i)-e(i-1)
         enddo
         do i=1,m2
            H2=H2+e2(i)-e2(i-1)
         enddo
         call screen(1123,0,0,H,H2)
         stop
      endif

      return
      end
