
c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine init_nb_pdf(sens,Nb,Nq,nb_pdfh,cumul_pdfh,nb_pdfb,
     &     cumul_pdfb,opth,optb)
      implicit none
      
c     Calcul du pdf de tirage des bandes troites pour chaque maille
c     d'mission, dans l'hypothse o l'atmosphre est uniquement absorbante
c     SANS DIFFUSION

      include 'max.inc'
      include 'data.inc'
      include 'param.inc'
      include 'options.inc'
      include 'files_out.inc'
      include 'freq.inc'
      include 'formats.inc'

      double precision dBdT,dBdzc,T,Planck
      double precision tau_sg,tau_eg,tr_sg,tr_eg,tau_atmos,tr_atmos
      integer i,j,p,Nb,Nq,band,quad,k,l,sens,md,k_min,k_max,n_max
      integer th1,tb1,mr
      double precision B_sol,B_esp,B_i,B_j,Bd
      double precision raf1,raf2,raf3,raf4,raf5,raf6,raf7,raf8,raf9
      integer raf10,raf11
      double precision sum1,sum2,sum3,delta_lambda
      double precision z1,z2,z3,z4,dB,B1,B2,B3,B4,dBp
      double precision mu0,pne(0:Nmax+1,0:Nmax+1),kai,kaj,tau_B,tau_int
      double precision ksi_theo(0:Nmax+1,0:Nmax+1)
      double precision rksi_theo(0:Nmax+1,0:Nmax+1)
c      double precision dPNEd_dka(0:2*(Nmax+1),0:2*(Nmax+1))
c      double precision dPNE_dka(0:Nmax+1,0:Nmax+1)
      double precision tpne(0:Nmax+1,0:Nmax+1)
      double precision rtpne(0:Nmax+1,0:Nmax+1)
      double precision psi(0:Nmax+1,1:Kmax)
      double precision tpsi(0:Nmax+1)
      double precision rtpsi_total(0:Nmax+1)
      double precision rtpsi_gs(0:Nmax+1)
      double precision rtpsi_ge(0:Nmax+1)
      double precision rtpsi_gg(0:Nmax+1)
      double precision sum_psi(0:Nmax+1)
      double precision psi_sol_theo(1:Kmax),psi_esp_theo(1:Kmax)
      double precision tpsih(0:Nmax+1),tpsib(0:Nmax+1)
      double precision psih(0:Nmax+1,1:Kmax),psib(0:Nmax+1,1:Kmax)
      double precision psi_gg(0:Nmax+1,1:Kmax),psi_gp(0:Nmax+1,1:Kmax)
      double precision psi_gs(0:Nmax+1,1:Kmax),psi_ge(0:Nmax+1,1:Kmax)
      double precision tpsi_gg(0:Nmax+1),tpsi_gp(0:Nmax+1)
      double precision sum_psih(0:Nmax+1),sum_psib(0:Nmax+1)
      double precision expint
      double precision tmp1,tmp2(0:Nmax+1)
      double precision psi_b(0:Nmax+1)
      double precision psi_b_gg(0:Nmax+1)
      double precision psi_b_gp(0:Nmax+1)
      double precision psi_b_gs(0:Nmax+1)
      double precision psi_b_ge(0:Nmax+1)
      double precision rpsi_b(0:Nmax+1)
      double precision rpsi_b_gg(0:Nmax+1)
      double precision rpsi_b_gp(0:Nmax+1)
      double precision rpsi_b_gs(0:Nmax+1)
      double precision rpsi_b_ge(0:Nmax+1)
      integer mf,Nbf,Nqf,nb_minf,nb_maxf,res,c,th,tb,tnan
      double precision nbw,tc,dtc,tw
      parameter(mu0=1.0D+0/1.66D+0)
      double precision Tcentre(0:Nmax+1)
      double precision rTcentre(0:Nmax+1)
c      parameter(mu0=1.0D+0/2.0D+0)
c     Flux
      double precision B1f(0:2*Nmax-1),B2f(0:2*Nmax-1)
      double precision Fh(0:2*Nmax-2,1:Nbmx,1:Nqmx)
      double precision Fb(0:2*Nmax-2,1:Nbmx,1:Nqmx)     ! flux monochromatiques
      double precision tFh(0:2*Nmax-2),tFb(0:2*Nmax-2) ! flux intgrs
      double precision bFh(0:2*Nmax-2),bFb(0:2*Nmax-2) ! flux par bande
      double precision tFnet(0:2*Nmax-2) ! flux nets
      double precision tFnet_pne(0:Nmax) ! flux nets intgrs  partir des PNE intgres
      double precision bFnet_pne(0:Nmax) ! flux nets par bande  partir des PNE par bande
      double precision bFnet(0:Nmax) ! flux nets par bande  partir des flux + et - 
      double precision sum_Fh(0:2*Nmax-2)
      double precision sum_Fb(0:2*Nmax-2)
      double precision psif(1:Nmax)
c     Flux mis uniquement
      double precision Feh(0:Nmax,1:Nbmx,1:Nqmx)
      double precision Feb(0:Nmax,1:Nbmx,1:Nqmx)
      double precision tFeh(0:Nmax),tFeb(0:Nmax)
      double precision sum_Feh(0:Nmax),sum_Feb(0:Nmax)
      double precision nz
      parameter(nz=1.0D+0)

      double precision ner_band(0:Nmax+1,0:Nmax+1)
      double precision rner_band(0:Nmax+1,0:Nmax+1)
      double precision nbw_tab(1:Nbmx)
      double precision coeff

c     sensitivities...
      integer strlen
      double precision dkadTp(1:Nbmx,1:Nqmx,1:Nmax)
c     dner_dT est la matrice des sensibilits des PNE aux tempratures
c     utilise pour un point de quadrature
      double precision dner_dT(0:Nmax+1,0:Nmax+1,0:Nmax+1)
c     dner_dT_band est la matrice des sensibilits sommes pour chaque bande troite
      double precision dner_dT_band(0:Nmax+1,0:Nmax+1,0:Nmax+1)
      double precision dksi_dT_band(0:Nmax+1,0:Nmax+1,0:Nmax+1)
      double precision dksi_dTg(0:Nmax+1,0:Nmax+1,0:Nmax+1,1:Nbmx)
c     sum_dpsidT est la matrice des sensibilits sommes sur tout le spectre
      double precision sum_dpsidT(0:Nmax+1,0:Nmax+1,0:Nmax+1)
c     les matrices A_ref, C_ref, D_ref, E_ref et F_ref sont les matrices de
c     sensibilits A, C, D, E et F (cf. papier), sommes sur tout le spectre
      double precision A_ref(0:Nmax+1,0:Nmax+1,0:Nmax+1)
      double precision C_ref(0:Nmax+1,0:Nmax+1,0:Nmax+1)
      double precision D_ref(0:Nmax+1,0:Nmax+1,0:Nmax+1)
      double precision E_ref(0:Nmax+1,0:Nmax+1,0:Nmax+1)
      double precision F_ref(0:Nmax+1,2,0:Nmax+1)
      double precision dFnet_dT_band(0:Nmax,0:Nmax+1)
      double precision dbudget_dT_band(0:Nmax+1,0:Nmax+1)
      double precision dFnet_dT(0:Nmax,0:Nmax+1)
      double precision dbudget_dT(0:Nmax+1,0:Nmax+1)
      character*100 file_kg
      character*100 file_sumdpsi
      character*100 file_sum_ACDEF
      character*100 file_out
      integer nspecies,i_min,i_max,ispecies
      double precision dkadx(1:Nbmx,1:Nqmx,1:Nmax,1:Nsmx)
      double precision dner_dx(0:Nmax+1,0:Nmax+1,0:Nmax+1)
      double precision dner_dx_band(0:Nmax+1,0:Nmax+1,0:Nmax+1,1:Nsmx)
      double precision dksi_dx_band(0:Nmax+1,0:Nmax+1,0:Nmax+1,1:Nsmx)
      character*100 file_dnerdx
      character*100 file_dksidT
      character*100 file_dksidx
      character*1 zero_ch,ispecies_ch1
      character*2 ispecies_ch2
c     ...sensitivities
      
      call numk(Nq,nb_min,1,k_min)
      call numk(Nq,nb_max,Nq,k_max)
      call calc_T(Tcentre)
      call calc_rT(m-2,rTcentre)

      call calc_dQ() ! Calcul des masses thermiques des diffrentes mailles de calcul
c     Si on choisit de faire un calcul MC et de lire les pdf dans le fichier correspondant
      if ((cmc.eq.1).and.(mco.eq.3)) then
c     Si calcul MC demand (cmc=1) et reprise du pdf prcdent
c     demand (mco=3) alors on lit le pdf spectral
c     prcdemment sauvegard
         open(10,file=file_freq_opti)
         read(10,*) mf,Nbf,Nqf,nb_minf,nb_maxf
         if ((mf.eq.m).and.(Nbf.eq.Nb).and.(Nqf.eq.Nq).and.
     &        (nb_minf.eq.nb_min).and.
     &        (nb_maxf.eq.nb_max)) then
            do i=0,m+1
                if (k_min-1.ge.1) then
                   do k=1,k_min-1
                      nb_pdfh(i,k)=0.0D+0
                      nb_pdfb(i,k)=0.0D+0
                      cumul_pdfh(i,k)=0.0D+0
                      cumul_pdfb(i,k)=0.0D+0
                   enddo ! k
                endif
               read(10,51) (nb_pdfh(i,k),k=k_min,k_max)
               read(10,51) (nb_pdfb(i,k),k=k_min,k_max)
               read(10,51) (cumul_pdfh(i,k),k=k_min,k_max)
               read(10,51) (cumul_pdfb(i,k),k=k_min,k_max)
               read(10,51) (opth(i,c),c=0,Na)
               read(10,51) (optb(i,c),c=0,Na)
                if (Nb*Nq.ge.k_max+1) then
                   do k=k_max+1,Nb*Nq
                      nb_pdfh(i,k)=0.0D+0
                      nb_pdfb(i,k)=0.0D+0
                      cumul_pdfh(i,k)=1.0D+0
                      cumul_pdfb(i,k)=1.0D+0
                   enddo ! k
                endif
            enddo ! i
            call screen(26,0,0,0.0D+0,0.0D+0)
         else
            call screen(27,0,0,0.0D+0,0.0D+0)
            stop
         endif
         close(10)
         goto 10000
      endif
c     Si jamais on choisit de ne pas faire un calcul MC et de lire les pdf
c     => incohrence
      if ((cmc.eq.0).and.(mco.eq.3)) then
         call screen(1017,0,0,0.0D+0,0.0D+0)
         stop
      endif

      if (mco.eq.1) then
         call screen(12,0,0,0.0D+0,0.0D+0)
      else if (mco.eq.2) then
         call screen(33,0,0,0.0D+0,0.0D+0)
      endif
c     Remarque :
c     On fait appel  la subroutine "wall" pour calculer les luminances des parois
c     en passant en argument #1 la valeur '2' -> dans la routine "wall", a ne
c     correspond  rien, donc le seul argument retourn est la luminance de la paroi
c     spcifie par l'argument #2 : 0 pour le sol m+1 pour l'espace
      
      md=2*(m-1)
      do i=0,m+1
         do j=0,m+1
            tPNE(i,j)=0.0D+0
         enddo
      enddo
      do i=0,m+1
         tpsi(i)=0.0D+0
         tpsi_gg(i)=0.0D+0
         tpsi_gp(i)=0.0D+0
         sum_psi(i)=0.0D+0
         sum_psih(i)=0.0D+0
         sum_psib(i)=0.0D+0
      enddo
c     Flux
      do i=0,md
         tFh(i)=0.0D+0
         tFb(i)=0.0D+0
         sum_Fh(i)=0.0D+0
         sum_Fb(i)=0.0D+0
      enddo
c     Flux mis uniquement
      do i=0,m
         tFeh(i)=0.0D+0
         tFeb(i)=0.0D+0
         sum_Feh(i)=0.0D+0
         sum_Feb(i)=0.0D+0
      enddo
      
      open(30,file=file_bil_freq_theo)
      open(31,file=file_bil_freq_gg_theo)
      open(32,file=file_bil_freq_gp_theo)
      open(33,file=file_bil_freq_gs_theo)
      open(34,file=file_bil_freq_ge_theo)

      open(42,file='./results/rbil_freq_theo.txt')
      open(43,file='./results/rbil_freq_gg_theo.txt')
      open(44,file='./results/rbil_freq_gp_theo.txt')
      open(45,file='./results/rbil_freq_gs_theo.txt')
      open(46,file='./results/rbil_freq_ge_theo.txt')


      tw=0.0D+0
      call cur_date(date_start)
      do band=nb_min,nb_max
         tw=tw+(no_hi(band)-no_lo(band))
c     Debug
c         write(*,*) 'band=',band,' nbw=',no_hi(band)-no_lo(band),
c     &        ' tw=',tw
c     Debug
      enddo

      if (mco.eq.0) then
         call screen(25,0,0,0.0D+0,0.0D+0)
      endif

c     sensitivities...
      if (calc_dNERdTp.eq.1) then
c     Des initialisations
         call init_sum_dpsidT(sum_dpsidT)
         call init_dksi_dTg(Nb,dksi_dTg)
         call init_dFnet_dT(dFnet_dT)
         call init_dbudget_dT(dbudget_dT)
c     Lecture des coefficients d(ka)/d(T)
         call read_dkadT(Nb,Nq,dkadTp)
      endif
      if (calc_dNERdx.eq.1) then
         call read_dkadx(Nb,Nq,dkadx,nspecies,i_min,i_max)
      endif
      if ((calc_dNERdTp.eq.1).or.(calc_dNERdx.eq.1)) then
         call check_sizes(Nb,Nq,nspecies)
      endif
c     ...sensitivities

      open(21,file='./results/PNE_mono-nu_theo.txt')
      open(22,file='./results/Flux_nets_mono-nu_theo.txt')
      open(23,file='./results/ksi_theo.txt')
      open(51,file='./results/rPNE_mono-nu_theo.txt')
      open(53,file='./results/rksi_theo.txt')
      write(21,*) m,Nb
      write(22,*) m,Nb
      write(23,*) m,Nb
      write(51,*) m-2,Nb
      write(53,*) m-2,Nb

c     sensitivities...
      file_dnerdx=path_sens(1:strlen(path_sens))//
     &     '/dNERdX_analytic.txt'
      if ((calc_dNERdx.ne.1).or.(s_dNERdx.ne.1)) then
         goto 420
      endif
      open(24,file=file_dnerdx)
      write(24,*) 'Analytic sensitivities of NER to concentrations'
      write(24,*) 'Number of species:',nspecies
      write(24,*) 'Number of gas layers:',m
      write(24,*) 'Number of narrowbands:',Nb
      write(24,*) 'Concentrations vary in gas layers:',i_min,
     &     '-',i_max
      write(24,*) 'Dimension of d(NER)/d(x): W/m/cm/(#/cm)'
      write(24,*)
 420  continue

      file_dksidT=path_sens(1:strlen(path_sens))//
     &     '/dksidT_analytic.txt'
      if ((calc_dNERdTp.ne.1).or.(s_dksidT.ne.1)) then
         goto 421
      endif
      open(25,file=file_dksidT)
      write(25,*) 'Analytic sensitivities of ksi to temperatures'
      write(25,*) 'Number of temperatures:',m+2
      write(25,*) 'Number of gas layers:',m
      write(25,*) 'Number of narrowbands:',Nb
      write(25,*) 'Temperature vary in gas layers:',0,'-',m+1
      write(25,*) 'Dimension of d(ksi)/d(T): sr.m/cm/K'
      write(25,*)
 421  continue

      if ((calc_dnerdx.eq.0).or.
     &     ((calc_dnerdx.eq.1).and.(s_dksidx.eq.0))) then
         goto 323
      endif
      do ispecies=1,nspecies
         if (ispecies.lt.10) then
            write(zero_ch,11) 0
            write(ispecies_ch1,11) ispecies
            ispecies_ch2=zero_ch(1:strlen(zero_ch))//
     &           ispecies_ch1(1:strlen(ispecies_ch1))
         else
            write(ispecies_ch2,12) ispecies
         endif
         file_dksidx=path_sens(1:strlen(path_sens))//
     &        '/dksidx_species'//
     &        ispecies_ch2(1:strlen(ispecies_ch2))//
     &        '_analytic.txt'
         open(26,file=file_dksidx)
         write(26,*) 'Analytic sensitivities of ksi to concentrations'
         write(26,*) 'Species index:',ispecies,' / ',nspecies
         write(26,*) 'Number of gas layers:',m
         write(26,*) 'Number of narrowbands:',Nb
         write(26,*) 'Concentrations vary in gas layers:',
     &        i_min,'-',i_max
         write(26,*) 'Dimension of d(ksi)/d(x): sr.m/cm/(#/cm)'
         write(26,*)
         close(26)
      enddo                     ! ispecies
 323  continue
c     ...sensitivities
      
      do band=1,Nb              ! dbut boucle sur les bandes
         call print_state(Nb,Nq,band,0,-1,0)
         delta_lambda=lambda_hi(band)-lambda_lo(band)

         quad=1 ! pour avoir des valeurs de B
         call wall(2,sens,band,quad,0,raf1,raf2,raf3,raf4,raf5,
     &        B_sol,raf6,raf7,raf8,raf9,raf11)
         call wall(2,sens,band,quad,m+1,raf1,raf2,raf3,raf4,raf5,
     &        B_esp,raf6,raf7,raf8,raf9,raf11)
         do i=0,m+1
            do j=0,m+1
               ner_band(i,j)=0.0D+0
            enddo ! j
         enddo ! i
         do i=0,md
            bFh(i)=0.0D+0
            bFb(i)=0.0D+0
         enddo ! i
c     Flux
c     Production des B1 et B2, respectivement B de bas et de haut
c     de chaque maille alti
         do i=0,md+1
            if (i.eq.0) then
               B1f(i)=B_sol
            else
               call find_B(band,quad,alti(i-1),B1f(i))
            endif
            if (i.eq.md+1) then
               B2f(i)=B_esp
            else
               call find_B(band,quad,alti(i),B2f(i))
            endif
         enddo
c     Flux

         if ((band.ge.nb_min).and.(band.le.nb_max).and.
     &        (mco.ne.3).and.(mco.ne.0)) then ! affichage progression du calcul
            call screen(24,band,0,0.0D+0,0.0D+0)
         endif
         nbw=no_hi(band)-no_lo(band)
         nbw_tab(band)=nbw
         psi_sol_theo(band)=0.0D+0
         psi_esp_theo(band)=0.0D+0
         do i=1,m
            psi_b(i)=0.0D+0
            psi_b_gg(i)=0.0D+0
            psi_b_gp(i)=0.0D+0
            psi_b_gs(i)=0.0D+0
            psi_b_ge(i)=0.0D+0
         enddo
c     sensitivities...
         if (calc_dNERdTp.eq.1) then
            call init_dner_dT(dner_dT_band)
         endif
         if (calc_dNERdx.eq.1) then
            call init_dner_dx(nspecies,dner_dx_band)
         endif
c     ...sensitivities
         do quad=1,Nq         ! dbut boucle sur les k
c            call signal_handler() ! signal handling
            call numk(Nq,band,quad,k)
            coeff=delta_lambda*w_moy(band,quad) ! m
            if ((band.lt.nb_min).or.(band.gt.nb_max)) then ! test sur k
               nb_pdfh(i,k)=0.0D+0
               nb_pdfb(i,k)=0.0D+0
               do i=0,m+1
                  do j=0,m+1
                     PNE(i,j)=0.0D+0
                  enddo
               enddo
            else
c     Flux
c     Si on a choisi de ne pas utiliser un pdf uniforme
               if ((mco.ne.0).and.(mco.ne.3)) then
                  call analytic_fluxes(band,quad,B1f,B2f,Fh,Fb,
     &                 Feh,Feb)
                  do i=0,md     ! i est le numro de l'interface [0:md]
                     tFh(i)=tFh(i)+Fh(i,band,quad)
                     tFb(i)=tFb(i)+Fb(i,band,quad)
                     sum_Fh(i)=sum_Fh(i)+dabs(Fh(i,band,quad))
                     sum_Fb(i)=sum_Fb(i)+dabs(Fb(i,band,quad))
                  enddo
                  do i=0,m      ! i est le numro de l'interface [0:m]
                     tFeh(i)=tFeh(i)+Feh(i,band,quad)
                     tFeb(i)=tFeb(i)+Feb(i,band,quad)
                     sum_Feh(i)=sum_Feh(i)+dabs(Feh(i,band,quad))
                     sum_Feb(i)=sum_Feb(i)+dabs(Feb(i,band,quad))
                  enddo         ! sur i

               endif            ! test pour savoir si on a demand un pdf uniforme ou pas
c     Flux
               if (mco.eq.0) then ! Tirage frquentiel uniforme

                  do i=0,md+1
                     if (i.eq.0) then
                        nb_pdfb(i,k)=0.0D+0
                     else
                        nb_pdfb(i,k)=nbw/tw*w_moy(band,quad)
                     endif
                     if (i.eq.m+1) then
                        nb_pdfh(i,k)=0.0D+0
                     else
                        nb_pdfh(i,k)=nbw/tw*w_moy(band,quad)
                     endif
                  enddo
               else if (mco.ne.3) then ! calcul des PNE

                  call analytic_NER(band,quad,PNE)
c     Debug
c                  if (k.eq.2) then
c                     write(*,*) 'PNE(0,1) av=',PNE(0,1)
c                  endif
c     Debug
c     [PNE]=W/m/m
                  call update_ner(PNE,coeff,ner_band)
c     Recombinaison des PNE pour la bande
                  call recombine_integrated_ner(m,ner_band,mr,rner_band)
c     Calcul des bilans recombins
                  call budget_from_ner(mr,rner_band,rpsi_b,
     &                 rpsi_b_gs,rpsi_b_ge,rpsi_b_gg)
c     Debug
c                  if (k.eq.2) then
c                     write(*,*) 'PNE(0,1) ap=',ner_band(0,1)
c                     write(*,*) 'coeff=',coeff
c                     write(*,*) PNE(0,1)*coeff
c                     stop
c                     do i=0,m+1
c                        do j=0,m+1
c                           write(*,*) 'PNE(',i,',',j,')=',ner_band(i,j)
c                        enddo   ! j
c                     enddo      ! i
c                     stop
c                  endif
c     Debug
c     [ner_band]=W/m
                  
c     sensitivities...
                  if (calc_dNERdTp.eq.1) then
                     call analytic_dNERdT(band,quad,dkadTp,dner_dT)
c     [dner_dT]=W/m/m/K
                     call update_dner_dT(dner_dT,coeff,dner_dT_band)
c     [dner_dT_band]=W/m/K
                  endif
                  if (calc_dNERdx.eq.1) then
                     do ispecies=1,nspecies
                        call analytic_dNERdx(band,quad,dkadx,nspecies,
     &                       i_min,i_max,ispecies,dner_dx)
c     [dner_dx]=W/m/m/[x]
                        call update_dner_dx(dner_dx,coeff,ispecies,
     &                       dner_dx_band)
c     [dner_dx_band]=W/m/[x]
                     enddo ! ispecies
                  endif
c     ...sensitivities

                  call analytic_budgets(k,nbw,PNE,coeff,
     &                 psi,psi_gg,psi_gp,psi_gs,psi_ge,psih,psib)
c     psi,psi_gg,psi_gp,psi_gs,psi_ge: W/m/cm

                  call update_budgets(k,nbw,psi,psih,psib,
     &                 psi_gg,psi_gp,psi_gs,psi_ge,psi_b,
     &                 psi_b_gg,psi_b_gp,psi_b_gs,
     &                 psi_b_ge,tpsi,tpsi_gg,tpsi_gp,tpsih,tpsib,
     &                 sum_psi,sum_psih,sum_psib)
                  
               endif            ! test sur mco

            endif               ! test sur k

c     Incrmentation des flux ascendants et descendants sur la bande troite
            do i=0,md
               bFh(i)=bFh(i)+Fh(i,band,quad)
               bFb(i)=bFb(i)+Fb(i,band,quad)
            enddo

 4321       continue

         enddo ! boucle sur quad
         
c         open(10,file=file_bil_freq_theo)
c         open(11,file=file_bil_freq_gg_theo)
c         open(12,file=file_bil_freq_gp_theo)
c         open(13,file=file_bil_freq_gs_theo)
c         open(14,file=file_bil_freq_ge_theo)
c         if (band.ne.nb_min) then
c            do i=1,band-nb_min
c               read(10,*)
c               read(11,*)
c               read(12,*)
c               read(13,*)
c               read(14,*)
c            enddo
c         endif
         do i=1,m
            call check(psi_b(i))
            call check(psi_b_gg(i))
            call check(psi_b_gp(i))
            call check(psi_b_gs(i))
            call check(psi_b_ge(i))
         enddo
         write(30,50) (psi_b(i),i=1,m) ! mW/m/cm-
         write(31,50) (psi_b_gg(i),i=1,m)
         write(32,50) (psi_b_gp(i),i=1,m)
         write(33,50) (psi_b_gs(i),i=1,m)
         write(34,50) (psi_b_ge(i),i=1,m)

c     Debug
c         write(*,*) 'band=',band
c     Debug
         do i=1,m
            call check(rpsi_b(i))
            call check(rpsi_b_gg(i))
            call check(rpsi_b_gp(i))
            call check(rpsi_b_gs(i))
            call check(rpsi_b_ge(i))
         enddo
         write(42,50) (rpsi_b(i),i=1,m)
         write(43,50) (rpsi_b_gg(i),i=1,m)
         write(44,50) (rpsi_b_gp(i),i=1,m)
         write(45,50) (rpsi_b_gs(i),i=1,m)
         write(46,50) (rpsi_b_ge(i),i=1,m)

c     Incrmentation de la matrice des PNE intgre sur le spectre
            do i=0,m+1
               do j=0,m+1
                  tPNE(i,j)=tPNE(i,j)+ner_band(i,j) ! W/m
               enddo
            enddo
c     Pour JL : calcul du bilan en W/m2/cm-1 au sol et en TOA
            do i=0,m+1
               psi_sol_theo(band)=psi_sol_theo(band)+
     &              ner_band(0,i)/nbw
               psi_esp_theo(band)=psi_esp_theo(band)+
     &              ner_band(m+1,i)/nbw
            enddo
  
c     Sauvegarde des PNE analytiques
         write(21,*) lambda_lo(band),lambda_hi(band)
         do i=0,m+1
            do j=0,m+1
               call check(ner_band(i,j))
            enddo
            write(21,50) (ner_band(i,j)/nbw_tab(band),j=0,m+1) ! W/m/cm
         enddo
c     Sauvegarde des PNE analytiques recombines
         write(51,*) lambda_lo(band),lambda_hi(band)
         do i=0,mr+1
            do j=0,mr+1
               call check(rner_band(i,j))
            enddo
            write(51,50) (rner_band(i,j)/nbw_tab(band),j=0,mr+1) ! W/m/cm
         enddo

c     Sauvegarde de la matrice des ksi analytique
         call ksi_matrix(0,band,Tcentre,ner_band,ksi_theo)
         write(23,*) lambda_lo(band),lambda_hi(band)
         do i=0,m+1
            do j=0,m+1
               call check(ksi_theo(i,j))
            enddo
            write(23,50) (ksi_theo(i,j),j=0,m+1) ! sr.m/cm
         enddo
c     Sauvegarde de la matrice des ksi analytique recombine
         call ksi_matrix(1,band,rTcentre,rner_band,rksi_theo)
         write(53,*) lambda_lo(band),lambda_hi(band)
         do i=0,mr+1
            do j=0,mr+1
               call check(rksi_theo(i,j))
            enddo
            write(53,50) (rksi_theo(i,j),j=0,mr+1) ! sr.m/cm
         enddo

         do i=0,m
            if (i.eq.0) then
               bFnet(i)=bFh(i)-bFb(i)
            else if (i.eq.m) then
               bFnet(i)=bFh(md)-bFb(md)
            else
               bFnet(i)=bFh(2*i-1)-bFb(2*i-1)
            endif
            bFnet(i)=bFnet(i)/nbw ! W/m/cm
         enddo

c     Calcul des flux nets par bande  partir des pne par bande
         call Flux_nets_pne_theo(ner_band,bFnet_pne)
c     [ner_band]=W/m
c     [bFnet_pne]=W/m
         write(22,*) lambda_lo(band),lambda_hi(band)
         do i=0,m
            call check(bFnet(i))
            call check(bFnet_pne(i))
         enddo
         write(22,50) (bFnet(i)/nbw_tab(band),i=0,m) ! W/m/cm
         write(22,50) (-bFnet_pne(i)/nbw_tab(band),i=0,m) ! W/m/cm
         
c     sensitivities...
         if (calc_dNERdTp.eq.1) then
c     Computing d(Fnet)/d(T)
            call dFnet_dT_theo(nbw,dNER_dT_band,dFnet_dT_band)
c     [dner_dT_band]=W/m/K
c     [dFnet_dT_band]=W/m/cm/K
            call update_dFnet_dT(nbw,dFnet_dT_band,dFnet_dT)
c     [dFnet_dT]=W/m/K

c     Computing d(budget)/d(T)
            call dbudget_dT_theo(dNER_dT_band,dbudget_dT_band)
c     [dner_dT_band]=W/m/K
c     [dbudget_dT_band]=W/m/K
            call update_dbudget_dT(dbudget_dT_band,dbudget_dT)
c     [dbudget_dT]=W/m/K

c     Sum of d(NER)/d(T)
            call update_sum_dpsidT(dner_dT_band,sum_dpsidT)
c     [dner_dT_band]=W/m/K
c     [sum_dpsidT]=W/m/K

c     d(ksi)/d(T)
            call update_dksi_dTg(Tcentre,band,nbw_tab,
     &           dner_dT_band,ner_band,dksi_dTg)
c     [dner_dT_band]=W/m/K
c     [dksi_dTg]=sr.m/cm/K
         endif
         if (calc_dNERdx.eq.1) then
            do ispecies=1,nspecies
               call update_dksi_dx(Tcentre,band,nbw_tab,
     &              dner_dx_band,ispecies,dksi_dx_band)
c     [dksi_dx]=sr.m/cm/(#/cm)
            enddo
         endif
         
         if ((calc_dNERdx.eq.1).and.(s_dNERdx.eq.1).
     &        and.(band.ge.nb_min).and.(band.le.nb_max)) then
            write(24,*) lambda_lo(band),lambda_hi(band)
            do ispecies=1,nspecies
               write(24,*) 'Species index:',ispecies,' / ',nspecies
               do p=i_min,i_max
                  write(24,*) 'sensitivity to concentration in layer:'
     &                 ,p
                  do i=0,m+1
                     do j=0,m+1
                        call check(dner_dx_band(i,j,p,ispecies))
                     enddo
                     write(24,50) (dner_dx_band(i,j,p,ispecies)/
     &                    nbw_tab(band),j=0,m+1)
                  enddo         ! i
               enddo            ! p
            enddo               ! ispecies
         endif

         if ((calc_dNERdTp.eq.1).and.(s_dksidT.eq.1).
     &        and.(band.ge.nb_min).and.(band.le.nb_max)) then
            write(25,*) lambda_lo(band),lambda_hi(band)
            do p=0,m+1
               write(25,*) 'sensitivitiy to temperature in layer:',p
               do i=0,m+1
                  do j=0,m+1
                     call check(dksi_dTg(i,j,p,band))
                  enddo
                  write(25,50) (dksi_dTg(i,j,p,band),j=0,m+1)
               enddo            ! i
            enddo               ! p
         endif

         if ((calc_dNERdx.eq.1).and.(s_dksidx.eq.1).
     &        and.(band.ge.nb_min).and.(band.le.nb_max)) then
            do ispecies=1,nspecies
               if (ispecies.lt.10) then
                  write(zero_ch,11) 0
                  write(ispecies_ch1,11) ispecies
                  ispecies_ch2=zero_ch(1:strlen(zero_ch))//
     &                 ispecies_ch1(1:strlen(ispecies_ch1))
               else
                  write(ispecies_ch2,12) ispecies
               endif
               file_dksidx=path_sens(1:strlen(path_sens))//
     &              '/dksidx_species'//
     &              ispecies_ch2(1:strlen(ispecies_ch2))//
     &              '_analytic.txt'
               
               open(26,file=file_dksidx)
               do i=1,7+(band-1)*(1+(i_max-i_min)*(m+3))
                  read(26,*)
               enddo            ! i
               write(26,*) lambda_lo(band),lambda_hi(band)
               do p=i_min,i_max
                  write(26,*) 'sensitivitiy to concentration in layer:'
     &                 ,p
                  do i=0,m+1
                     do j=0,m+1
                        call check(dksi_dx_band(i,j,p,ispecies))
                     enddo
                     write(26,50) (dksi_dx_band(i,j,p,ispecies),
     &                    j=0,m+1)
                  enddo         ! i
               enddo            ! p
               close(26)
            enddo               ! ispecies
         endif
c     ...sensitivities
         
      enddo                     ! boucle sur bandes
      
      close(21)
      close(22)
      close(23)
      close(24)
      close(25)
      close(51)
      close(53)
      close(30)
      close(31)
      close(32)
      close(33)
      close(34)
      close(42)
      close(43)
      close(44)
      close(45)
      close(46)
c     sensitivities...
      if (calc_dNERdTp.eq.1) then
         open(35,file='./results/dFnet_dT_theo.txt')
         open(36,file='./results/dbudget_dT_theo.txt')
         write(35,*) m+2,m+1
         write(36,*) m+2,m+2
         do p=0,m+1
            do i=0,m
               call check(dFnet_dT(i,p))
            enddo
            do i=0,m+1
               call check(dbudget_dT(i,p))
            enddo
            write(35,50) (dFnet_dT(i,p),i=0,m)
            write(36,50) (dbudget_dT(i,p),i=0,m+1)
         enddo ! p
         close(35)
         close(36)
      endif

      if (calc_dNERdTp.eq.1) then
         call screen(40,0,0,0.0D+0,0.0D+0)
c     A, C, D, E and F matrices
         call sum_ACDEF(Nb,Tcentre,dksi_dTg,
     &        A_ref,C_ref,D_ref,E_ref,F_ref)

c     Saving the dksi matrix
c         if (s_dksidT.eq.0) then
c            goto 111
c         endif
c         call screen(41,0,0,0.0D+0,0.0D+0)
c         file_kg='dksidT_global_analytic.txt'
c         file_out=path_sens(1:strlen(path_sens))//
c     &        file_kg(1:strlen(file_kg))
c         open(15,file=file_out)
c         write(15,*) 'Analytic dKSI/dT matrices for Venus'' atmosphere'
c         write(15,*) 'Total number of matrices:',m+2
c         do p=0,m+1
c            write(15,*) 
c            write(15,*) 'dKSI/dT matrix number:',p+1
c            write(15,*)
c            write(15,*) m,Nb
c            do band=1,Nb
c               write(15,*) lambda_lo(band),lambda_hi(band)
c               do i=0,m+1
c                  write(15,50) (dksi_dTg(i,j,p,band),j=0,m+1) ! sr.m/cm/K
c               enddo            ! i
c            enddo               ! band
c         enddo                  ! p
c         close(15)

 111     continue
c     Saving the sum of dNER
         if (s_sumdNERdT.eq.0) then
            goto 222
         endif
         call screen(42,0,0,0.0D+0,0.0D+0)
         file_sumdpsi='sum_dpsidT_analytic.txt'
         file_out=path_sens(1:strlen(path_sens))//
     &        '/'//
     &        file_sumdpsi(1:strlen(file_sumdpsi))
         open(16,file=file_out(1:strlen(file_out)))
         do p=0,m+1
            do i=0,m+1
               do j=0,m+1
                  call check(sum_dpsidT(i,j,p))
               enddo
               write(16,50) (sum_dpsidT(i,j,p),j=0,m+1)
            enddo               ! i
         enddo                  ! p
         close(16)

 222     continue
c     Saving the A, C, D, E and F matrices
         if (s_ACDEF.eq.0) then
            goto 333
         endif
         file_sum_ACDEF='/sum_ACDEF_analytic.txt'
         file_out=path_sens(1:strlen(path_sens))//
     &        file_sum_ACDEF(1:strlen(file_sum_ACDEF))
         open(17,file=file_out(1:strlen(file_out)))
         do p=0,m+1
            do i=0,m+1
               do j=0,m+1
                  call check(A_ref(i,j,p))
                  call check(C_ref(i,j,p))
                  call check(D_ref(i,j,p))
                  call check(E_ref(i,j,p))
               enddo
               do j=1,2
                  call check(F_ref(i,j,p))
               enddo
               write(17,50) (A_ref(i,j,p),j=0,m+1)
               write(17,50) (C_ref(i,j,p),j=0,m+1)
               write(17,50) (D_ref(i,j,p),j=0,m+1)
               write(17,50) (E_ref(i,j,p),j=0,m+1)
               write(17,50) (F_ref(i,j,p),j=1,2)
            enddo               ! i
         enddo                  ! p
         close(17)

 333     continue
      endif
c     ...sensitivities

c     Flux - sauvegarde des flux
      open(10,file='./results/flux_theo.txt')
      do i=0,md
         call check(tFh(i))
         call check(tFb(i))
         write(10,50) alti(i)/1.0D+3,tFh(i),tFb(i)
      enddo
      close(10)

      call Flux_nets_pne_theo(tPNE,tFnet_pne)
      open(14,file='./results/Flux_nets_int_theo.txt')
      do i=0,m
         if (i.eq.0) then
            tFnet(i)=tFh(i)-tFb(i)
         else if (i.eq.m) then
            tFnet(i)=tFh(md)-tFb(md)
         else
            tFnet(i)=tFh(2*i-1)-tFb(2*i-1)
         endif
         call check(tFnet(i))
         call check(tFnet_pne(i))
         write(14,50) e(i)/1.0D+3,tFnet(i),-tFnet_pne(i)
      enddo
      close(14)
c     Flux
      
c     Sauvegarde psi_sol(band)
      open(10,file='./results/psi_sol_theo.txt')
      do band=nb_min,nb_max
         call check(psi_sol_theo(band))
         write(10,*) lambda_lo(band),lambda_hi(band),psi_sol_theo(band)
      enddo
      close(10)
c     Sauvegarde psi_esp(k)
      open(10,file='./results/psi_esp_theo.txt')
      do band=nb_min,nb_max
         call check(psi_esp_theo(band))
         write(10,*) lambda_lo(band),lambda_hi(band),psi_esp_theo(band)
      enddo
      close(10)
      
c     Recombinaison des PNE
      call recombine_integrated_ner(m,tPNE,mr,rtPNE)
c     Sauvegarde des PNE, CR et bilans
      open(10,file=file_pne_theo)
      open(11,file=file_CR_theo)
      do i=0,m+1
         do j=0,m+1
            call check(tPNE(i,j))
            write(10,*) tPNE(i,j)
            if ((i.eq.0).or.(i.eq.m+1)) then
               write(11,*) 0.0D+0
            else
               write(11,*) tPNE(i,j)*d_t/dQe(i)
            endif
         enddo
      enddo
      close(10)
      close(11)

      open(10,file=file_bil_theo)
      do i=1,m
         call check(tpsi_gg(i))
         call check(tpsi_gp(i))
         call check(tpsi(i))
         write(10,50) (e(i)+e(i-1))/2.0D+3,
     &        tpsi_gg(i)*1.0D+3, ! mW/m
     &        tpsi_gp(i)*1.0D+3, ! mW/m
     &        tpsi(i)*1.0D+3, ! mW/m
     &        tpsi(i)*d_t/dQe(i)
      enddo
      close(10)

c     Sauvegarde des PNE recombines
      open(10,file='./results/rPNEtheo.txt')
      do i=0,mr+1
         do j=0,mr+1
            call check(rtPNE(i,j))
            write(10,*) rtPNE(i,j)
         enddo
      enddo
      close(10)
c     calcul des bilans sur maillage recombin
      call budget_from_ner(mr,rtpne,rtpsi_total,
     &     rtpsi_gs,rtpsi_ge,rtpsi_gg)
c     Sauvegarde
      open(10,file='./results/rbil_theo.txt')
      do i=1,mr
         call check(rtpsi_gg(i))
         call check(rtpsi_gs(i))
         call check(rtpsi_ge(i))
         call check(rtpsi_total(i))
         write(10,50) (er(i)+er(i-1))/2.0D+3,
     &        rtpsi_gg(i)*1.0D+3,
     &        (rtpsi_gs(i)+rtpsi_ge(i))*1.0D+3,
     &        rtpsi_total(i)*1.0D+3,
     &        rtpsi_total(i)*d_t/dQe(i)
      enddo
      close(10)
      
      call screen(30,0,0,0.0D+0,0.0D+0)

c     Et quand mme, on donne le pdf(i,k)...
      if (mco.eq.1) then ! optimisation pour calculs PNE
c     Dans le cas o on a choisi un tirage uniforme, les tableaux
c     nb_pdfh et nb_pdfb sont dj calculs
         do i=0,m+1
            if (sum_psih(i).eq.0.0D+0) then
               do k=1,Kmax
                  nb_pdfh(i,k)=0.0D+0
               enddo
            endif
            if (sum_psib(i).eq.0.0D+0) then
               do k=1,Kmax
                  nb_pdfb(i,k)=0.0D+0
               enddo
            endif
            do k=1,Kmax
               if ((k.ge.k_min).and.(k.le.k_max)) then
                  if (sum_psih(i).ne.0.0D+0) then
                     nb_pdfh(i,k)=dabs(psih(i,k))/sum_psih(i)
                  endif
                  if (sum_psib(i).ne.0.0D+0) then
                     nb_pdfb(i,k)=dabs(psib(i,k))/sum_psib(i)
                  endif
               else
                  nb_pdfh(i,k)=0.0D+0
                  nb_pdfb(i,k)=0.0D+0
               endif
            enddo
            if (i.eq.0) then
               do k=1,Kmax
                  nb_pdfb(i,k)=0.0D+0
               enddo
            endif
            if (i.eq.m+1) then
               do k=1,Kmax
                  nb_pdfh(i,k)=0.0D+0
               enddo
            endif
 4132       continue
         enddo
      endif
      if (mco.eq.2) then ! optimisation 1 pour calculs flux
         do i=0,m+1
            do k=1,Kmax
               call nbands(k,Nq,band,quad)
               nbw=no_hi(band)-no_lo(band)
               if ((k.ge.k_min).and.(k.le.k_max)) then
                  if (i.eq.0) then
                     nb_pdfh(i,k)=dabs(Fh(i,band,quad))/sum_Fh(i)
                     nb_pdfb(i,k)=0.0D+0
                  else  if (i.eq.m+1) then
                     nb_pdfh(i,k)=0.0D+0
                     nb_pdfb(i,k)=nbw/tw*w_moy(band,quad)
                  else if (i.eq.1) then
                     nb_pdfh(i,k)=dabs(Fh(1,band,quad))/sum_Fh(1)
                     nb_pdfb(i,k)=dabs(Fb(0,band,quad))/sum_Fb(0)
                  else if (i.eq.m) then
                     nb_pdfh(i,k)=dabs(Fh(md,band,quad))/sum_Fh(md)
                     nb_pdfb(i,k)=dabs(Fb(md-1,band,quad))/sum_Fb(md-1)
                  else ! pour i=1  m-1
                     nb_pdfh(i,k)=dabs(Fh(2*i-1,band,quad))
     &                    /sum_Fh(2*i-1)
                     nb_pdfb(i,k)=dabs(Fb(2*i-3,band,quad))
     &                    /sum_Fb(2*i-3)
                  endif
               else
                  nb_pdfh(i,k)=0.0D+0
                  nb_pdfb(i,k)=0.0D+0
               endif ! sur k
            enddo ! sur k
         enddo ! sur i
      endif

c     Debug
c      i=1
c      do k=k_min,k_max
c         write(*,*) 'psih(',i,',',k,')=',psih(i,k),
c     &        ' sum_psih(',i,')=',sum_psih(i),
c     &        ' nb_pdfh(',i,',',k,')=',nb_pdfh(i,k)
c      enddo
c      stop
c     Debug

c     Test supplmentaire: dans le cas o les tempratures de deux mailles 
c     sont identiques, on a certainement nb_pdfh(i,k)=0 et nb_pdfb(i,k)=0
c     pour tout k, d'o un problme pour calculer les cumules...
      do i=0,m+1
         th1=0
         do k=1,Kmax
            if (nb_pdfh(i,k).ne.0.0D+0) then
               th1=1
               goto 4221
            endif
         enddo
 4221    continue
         if ((th1.eq.0).and.(i.ne.m+1)) then
            do k=1,Kmax
               nb_pdfh(i,k)=nz
            enddo
            call screen(1314,i,0,0.0D+0,0.0D+0)
         endif

         tb1=0
         do k=1,Kmax
            if (nb_pdfb(i,k).ne.0.0D+0) then
               tb1=1
               goto 4222
            endif
         enddo
 4222    continue
         if ((tb1.eq.0).and.(i.ne.0)) then
            do k=1,Kmax
               nb_pdfb(i,k)=nz
            enddo
            call screen(1315,i,0,0.0D+0,0.0D+0)
         endif
      enddo ! i
      
c     Calcul des fonctions cumules et
c     normalisation en cas de cumule non normalise
      do i=0,m+1
         cumul_pdfh(i,0)=0.0D+0
         do k=1,Kmax
            cumul_pdfh(i,k)=cumul_pdfh(i,k-1)+nb_pdfh(i,k)
         enddo
      enddo
      do i=0,m+1                ! Normalisation
         if ((cumul_pdfh(i,k_max).ne.1.0D+0).and.
     &        (cumul_pdfh(i,k_max).ne.0.0D+0).and.(i.ne.m+1)) then
            do k=1,Kmax
c     Debug
c            if ((i.eq.1).and.(k.eq.k_max)) then
c               write(*,*) 'Avant normalisation:'
c               write(*,*) 'k=',k,' cumul_pdfh(',k,')=',cumul_pdfh(i,k)
c            endif
c     Debug
               cumul_pdfh(i,k)=cumul_pdfh(i,k)/cumul_pdfh(i,k_max)
c     Debug
c            if ((i.eq.1).and.(k.eq.k_max)) then
c               write(*,*) 'Aprs normalisation:'
c               write(*,*) 'k=',k,' cumul_pdfh(',k,')=',cumul_pdfh(i,k)
c            endif
c     Debug
            enddo
         endif
      enddo
      
      do i=0,m+1
         cumul_pdfb(i,0)=0.0D+0
         do k=1,Kmax
            cumul_pdfb(i,k)=cumul_pdfb(i,k-1)+nb_pdfb(i,k)
c     Debug
c            if ((i.eq.1).and.(k.le.k_max)) then
c               write(*,*) 'k=',k,' cumul_pdfb(',k,')=',cumul_pdfb(i,k)
c            endif
c     Debug
         enddo
      enddo
      do i=0,m+1                ! Normalisation
         if ((cumul_pdfb(i,k_max).ne.1.0D+0).and.
     &        (cumul_pdfb(i,k_max).ne.0.0D+0).and.(i.ne.0)) then
            do k=1,Kmax
               cumul_pdfb(i,k)=cumul_pdfb(i,k)/cumul_pdfb(i,k_max)
            enddo
         endif
      enddo

c     Debug
c      write(*,*)
c      write(*,*) 'tableaux pdf'
c      write(*,*)
c      tmp1=0.0D+0
c      do quad=1,Nq
c         tmp1=tmp1+w_moy(1,quad)
c         write(*,*) 'w_moy(',quad,')=',w_moy(1,quad),tmp1
c      enddo
c      write(*,*)
c      do k=k_min,k_max+1
c         write(*,*) k,cumul_pdfb(1,k),nb_pdfb(1,k)
c      enddo
c     Debug
         

c     Vrification au cas o on ait des NaN (on sait jamais ce qui
c     peut se passer pour des paisseurs optiques bizarres)

      tnan=0
      do i=0,m+1
         do k=1,Kmax
            call test_nan(nb_pdfh(i,k),res)
            if (res.eq.1) then ! si c'est un NaN
               tnan=1
            endif
            call test_nan(nb_pdfb(i,k),res)
            if (res.eq.1) then ! si c'est un NaN
               tnan=1
            endif
         enddo
      enddo
      if (tnan.eq.1) then ! Si un seul NaN dtect dans les pdf
         call screen(1116,0,0,0.0D+0,0.0D+0)
         stop
      endif

c     Calcul des tableaux d'acclration 'opt' du tirage frquentiel

      call screen(31,0,0,0.0D+0,0.0D+0)
      do i=0,m+1
         do c=0,Na
            tc=dble(c)/dble(Na)-1.0D-15
c     Remarque: le 1.0D-15 est l pour la bonne raison que, parfois,
c     le rapport dble(c)/dble(Na) est diffrent de 1.0 pour c=Na
c     -> le fortran, c'est trs chiant !
c     Donc j'enlve un truc infime pour tre  peu prs sr que mon
c     rapport tc sera  peu prs toujours dpass par cumul_pdf(i,k)
            do k=1,Kmax
               if (cumul_pdfh(i,k).ge.tc) then
                  opth(i,c)=dble(k)
                  goto 124
               endif
            enddo
 124        continue
            do k=1,Kmax
               if (cumul_pdfb(i,k).ge.tc) then
                  optb(i,c)=dble(k)
                  goto 134
               endif
            enddo
 134        continue
         enddo
      enddo

c     Sauvegarde des tableaux de pdf, de cumule du pdf et d'acclration
      call screen(28,0,0,0.0D+0,0.0D+0)
      open(10,file=file_freq_opti)
      write(10,*) m,Nb,Nq,nb_min,nb_max,k_min,k_max
      do i=0,m+1
          write(10,51) (nb_pdfh(i,k),k=k_min,k_max)
          write(10,51) (nb_pdfb(i,k),k=k_min,k_max)
          write(10,51) (cumul_pdfh(i,k),k=k_min,k_max)
          write(10,51) (cumul_pdfb(i,k),k=k_min,k_max)
          write(10,51) (opth(i,c),c=0,Na)
          write(10,51) (optb(i,c),c=0,Na)
       enddo
      close(10)
      
      if (cmc.eq.0) then
c     Si le calcul par MC n'est pas requis aprs la phase d'optimisation
c     spectrale, on se contente d'crire "1" dans le fichier './temporary/coupure.dat'
c     de faon  faire comprendre au code lors du prochain calcul que ce
c     calcul a bien t termin. Puis le programme est arrt.
         call print_state(Nb,Nq,0,quad,m+1,-1)
         call screen(100,0,0,0.0D+0,0.0D+0)
         stop
      endif

10000 continue
      call print_state(Nb,Nq,0,0,-1,2*n_tir)
     
      return
      end
