c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine invert(tab_in,r_max,tab_out)

      implicit none

c     Cette routine inverse le tableau ray d'entre (et c'est dj pas mal)
c
c     Entres :
c       + ray : tableau de chemin optique
c       + r_max : indice de fin du tableau ray
c
c     Sorties :
c       + tab_out : tableau invers
c

      include 'max.inc'
      include 'param.inc'
      include 'data.inc'
      include 'options.inc'

      integer r_max,r,p,q
      double precision tab_in(0:DiffMax,2),tab_out(0:DiffMax,2)
      double precision ray(0:r_max,2)
      double precision l(0:r_max)

      do p=0,r_max
         ray(p,1)=tab_in(p,1)
         ray(p,2)=tab_in(p,2)
      enddo

c     Calcul des longueurs de chaque segment de droite
      do p=1,r_max-1
         l(p)=ray(p+1,2)-ray(p,2)
      enddo

c     Inversion du tableau ray
      tab_out(0,1)=0.0D+0
      tab_out(0,2)=0.0D+0
      tab_out(1,1)=ray(r_max,1)
      tab_out(1,2)=0.0D+0
      do p=2,r_max
         tab_out(p,1)=ray(r_max-p+1,1)
         tab_out(p,2)=tab_out(p-1,2)+l(r_max-p+1)
      enddo

c     Termin !

      return
      end
         
      
      
