c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine look_for_errors()
      
c     Cette routine recherche les erreurs et incohrences connues dans les
c     dlcarations de donnes et d'options
c

      implicit none
      integer out,ios,outt,index1,index2
      include 'max.inc'
      include 'data.inc'
      include 'options.inc'
      include 'param.inc'
      include 'files_in.inc'
      include 'files_out.inc'
      include 'tab.inc'
      
      call screen(13,0,0,0.0D+0,0.0D+0)
      out=1

c     Vrification des donnes dclares dans "data.in"
      if ((ang_tir_wall.lt.0.0D+0).or.(ang_tir_wall.gt.90.0D+0)) then
         call screen(1303,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((ang_tir_gaz.lt.0.0D+0).or.(ang_tir_gaz.gt.90.0D+0)) then
         call screen(1304,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if (l_min.gt.l_max) then
         call screen(1305,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if (eps_pne.le.0.0D+0) then
         call screen(1307,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if (eps_flux.le.0.0D+0) then
         call screen(1308,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if (eps_fnet.le.0.0D+0) then
         call screen(1313,0,0,0.0D+0,0.0D+0)
         out=0
      endif
c      if ((proba.lt.0.0D+0).or.(proba.gt.1.0D+0)) then
c         call screen(1309,0,0,0.0D+0,0.0D+0)
c         out=0
c      endif
      if (n_tir.le.0) then
         call screen(1310,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if (Ndiff.le.0) then
         call screen(1311,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if (Nsec.le.0) then
         call screen(1316,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if (Nsec.gt.Nsec_mx) then
         call screen(1317,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if (dble(Nsec)/2.0D+0-dble(Nsec/2).ne.0.0D+0) then
         call screen(1318,0,0,0.0D+0,0.0D+0)
         out=0
      endif

c     Vrification des options dfinies dans "options.in"
      if ((tirpp.ne.0).and.(tirpp.ne.1)) then
         call screen(1002,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((lambertp.ne.0).and.(lambertp.ne.1)) then
         call screen(1003,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((isop.ne.0).and.(isop.ne.1)) then
         call screen(1004,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((ref.ne.1).and.(ref.ne.2)) then
         call screen(1005,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((tirpg.ne.0).and.(tirpg.ne.1)) then
         call screen(1006,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((lambertg.ne.0).and.(lambertg.ne.1)) then
         call screen(1007,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((isog.ne.0).and.(isog.ne.1)) then
         call screen(1008,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((fph.ne.1).and.(fph.ne.2)) then
         call screen(1010,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((cpb.ne.1).and.(cpb.ne.2)) then
         call screen(1024,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((atd.ne.0).and.(atd.ne.1)) then
         call screen(1013,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((ate.ne.1).and.(ate.ne.2)) then
         call screen(1009,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((apc.ne.0).and.(apc.ne.1)) then
         call screen(1012,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((amsg.ne.0).and.(amsg.ne.1)) then
         call screen(1001,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((srf.ne.0).and.(srf.ne.1)) then
         call screen(1015,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((pao.ne.1).and.(pao.ne.2)) then
         call screen(1016,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((cmc.ne.0).and.(cmc.ne.1)) then
         call screen(1018,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((ces.ne.1).and.(ces.ne.2)) then
         call screen(1019,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((scc.ne.0).and.(scc.ne.1)) then
         call screen(1020,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((cpm.ne.0).and.(cpm.ne.1)) then
         call screen(1021,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((mco.ne.0).and.(mco.ne.1).and.(mco.ne.2).and.(mco.ne.3)) then
         call screen(1022,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((rg.ne.1).and.(rg.ne.2)) then
         call screen(1025,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((rmh.ne.1).and.(rmh.ne.0)) then
         call screen(1026,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((ga0.ne.1).and.(ga0.ne.0)) then
         call screen(1027,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((calc_dNERdTp.ne.0).and.(calc_dNERdTp.ne.1)) then
         call screen(1028,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((s_dksidT.ne.0).and.(s_dksidT.ne.1)) then
         call screen(1029,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((s_sumdNERdT.ne.0).and.(s_sumdNERdT.ne.1)) then
         call screen(1030,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((s_ACDEF.ne.0).and.(s_ACDEF.ne.1)) then
         call screen(1031,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((calc_dNERdx.ne.0).and.(calc_dNERdx.ne.1)) then
         call screen(1032,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((s_dNERdx.ne.0).and.(s_dNERdx.ne.1)) then
         call screen(1033,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((s_dksidx.ne.0).and.(s_dksidx.ne.1)) then
         call screen(1034,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((udif.ne.1).and.(udif.ne.2)) then
         call screen(1035,0,0,0.0D+0,0.0D+0)
         out=0
      endif

c     Vrification des variables ncessaires au calcul
      if (m.le.0) then
         call screen(1401,m,0,0.0D+0,0.0D+0)
         out=0
      endif
      if ((H.lt.0.0D+0).or.(H.ne.e(m))) then
         call screen(1402,0,0,H,0.0D+0)
         out=0
      endif

c     Prsence des fichiers d'entre
      
      open(10,file=file_ray,status='old',iostat=ios)
      if (ios.ne.0) then ! file not found
         call screen(1146,0,0,0.0D+0,0.0D+0)
         out=0
      endif
      close(10)

      if (rmh.eq.1) then
         open(11,file=file_meshGCM,status='old',iostat=ios)
         if (ios.ne.0) then     !  file not found
            call screen(1144,0,0,0.0D+0,0.0D+0)
            out=0
         endif
         close(11)
      endif

      if (fph.eq.2) then
         open(12,file=file_phase,status='old',iostat=ios)
         if (ios.ne.0) then     ! file not found
            call screen(1145,0,0,0.0D+0,0.0D+0)
            out=0
         endif
         close(12)
      endif

      if (calc_dNERdTp.eq.1) then
         open(13,file=file_dkadT,status='old',iostat=ios)
         if (ios.ne.0) then     ! file not found
            call screen(1152,0,0,0.0D+0,0.0D+0)
            out=0
         endif
         close(13)
      endif

      if (calc_dNERdx.eq.1) then
         open(13,file=file_dkadx,status='old',iostat=ios)
         if (ios.ne.0) then     ! file not found
            call screen(1153,0,0,0.0D+0,0.0D+0)
            out=0
         endif
         close(13)
      endif

      
      if ((cmc.eq.1).and.(mco.eq.3)) then
c     Si calcul MC demand (cmc=1) et reprise du pdf prcdent
c     demand (mco=3) alors il faut galement
c     vrifier la prsence du fichier d'optimisation frquentielle
         open(14,file=file_freq_opti,status='old',iostat=ios)
         if (ios.ne.0) then     ! file not found
            call screen(1150,0,0,0.0D+0,0.0D+0)
            out=0
         endif
         close(14)
      endif
      
      
c     Test sur le maillage "alt"
      call test_zmesh(alt,m-1,index1,index2,outt)
      if (outt.eq.0) then
         call screen(1154,index1,index2,0.0D+0,0.0D+0)
         out=0
      endif
c     Test sur le maillage "e"
      call test_zmesh(e,m,index1,index2,outt)
      if (outt.eq.0) then
         call screen(1155,index1,index2,0.0D+0,0.0D+0)
         out=0
      endif

      
      if (out.eq.1) then
         call screen(14,0,0,0.0D+0,0.0D+0)
      else
         call screen(15,0,0,0.0D+0,0.0D+0)
         stop
      endif

 1234 continue
      return
      end




      subroutine test_zmesh(tab,n,index1,index2,out)
      implicit none
      include 'max.inc'
      integer n,i,j,out,index1,index2
      double precision tab(0:Nmax)
      out=1 ! default: no error
      index1=0
      index2=0
      
c     if tab(i)<=tab(j) for j=0,i-1
      do i=1,n
         do j=0,i-1
            if (tab(i).le.tab(j)) then
               out=0
               index1=i
               index2=j
               goto 123
            endif
         enddo
      enddo


 123  continue
      return
      end

      
