c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      program main
c     -------------------------------------------------------------------------
c     Voir aussi le fichier "readme"
c     -------------------------------------------------------------------------
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'options.inc'
      include 'param.inc'
c      include 'files_out.inc'
      include 'tab.inc'
      include 'freq.inc'
      
c     Dclaration des variables locales
      integer out,arret,mc,md,paq,ptl,profil,p,q,k0,k1,Nb,Nq,band,quad
      integer n_max,sens
      double precision B_em,B_abs,alpha,w,ksi,ksi_min,w_abs,ksi_abs
      double precision ksi_in,ksi_out,w_in,w_out,alpha_in,alpha_out
      double precision raf1,raf2,raf3,raf4,raf5
      double precision Xmin,DeltaXmax

      call init() ! initialisation gnrale
      call coupure() ! Dtection d'une interruption (edf ou stb)
      call read_data() ! Lecture des donnes
      call mesh() ! Maillage de l'atmosphre
      call read_options() ! Lecture des options
      call look_for_errors() ! Recherche des erreurs dans les donnes
      call init_kcoeff(Nb,Nq) ! Lecture des donnes spectrales
      call countd(-1,0,0,0.0D+0) ! Initialisation des compteurs pour diffusion
      call init_nb_pdf(sens,Nb,Nq,nb_pdfh,cumul_pdfh,nb_pdfb,
     &     cumul_pdfb,opth,optb)
      call screen(2,seed0,0,0.0D+0,0.0D+0) ! Affichage du germe alatoire initial
      call init_results(Nb,Nq) ! Initialisation des variables somme totale
      call find_max(Xmin,DeltaXmax) ! Calcul de Xmin et DeltaXmax
      if (fph.eq.2) call cumul_phase()
      do md=md_min,m+1 ! Boucle sur les m+2 mailles
         call screen(1,md,0,0.0D+0,0.0D+0) ! Affichage  l'cran de l'tat du calcul
         call calc_nmax(md,n_max)
         do paq=paq_min,n_max ! boucle sur les n_tir rayons
            mc=md
c            call signal_handler() ! signal handling
c.Bloc mission du rayon - Dbut
            call choice_sens(md,paq,n_max,sens,k0,k1)
            call choice_freq(md,sens,Nb,Nq,nb_pdfh,cumul_pdfh,
     &           nb_pdfb,cumul_pdfb,opth,optb,w,band,quad)
            if ((mc.eq.0).or.(mc.eq.m+1)) then ! Emission de paroi
               call wall(1,sens,band,quad,mc,0.0D+0,0.0D+0,w,0.0D+0,
     &              alpha,B_em,w,raf4,raf5,ksi,arret)
            else ! Emission en maille gazeuse
               if (ate.eq.1) then
                  call initz1(mc,sens,band,quad,DeltaXmax,w,B_em,
     &                 alpha,w,ksi,arret)
               else if (ate.eq.2) then
                  call initz2(mc,sens,band,quad,DeltaXmax,w,B_em,
     &                 alpha,w,ksi,arret)
               endif
            endif
            call update_temp(arret,sens,Nb,Nq,band,quad,md,mc,k0,k1,
     &           B_em,B_em,alpha,0.0D+0,raf2,ksi,w) ! MAJ des flux
            call calc_stop(band,quad,DeltaXmax,B_em,ksi_min)
c.Bloc mission du rayon - Fin
10000       continue
c.Bloc parcours du rayon - Dbut

            if (alpha.lt.pi/2.0D+0) then ! passage en maille suivante
               mc=mc-1
            else
               mc=mc+1
            endif
            call setd(ksi,alpha,w,ksi_in,alpha_in,w_in)
            if ((mc.eq.0).or.(mc.eq.m+1)) then ! Si le rayon rencontre une paroi
               call wall(0,sens,band,quad,mc,ksi_min,alpha_in,
     &              w_in,ksi_in,alpha_out,B_abs,w_out,w_abs,ksi_abs,
     &              ksi_out,arret)
            else ! Si le rayon rencontre une maille de gaz
               call abs_gaz(sens,band,quad,DeltaXmax,mc,ksi_in,w_in,
     &              alpha_in,B_em,B_abs,alpha_out,ksi_abs,w_abs,
     &              ksi_out,w_out,arret)
            endif
            call setr(ksi_out,alpha_out,w_out,ksi,alpha,w)
            call update_temp(arret,sens,Nb,Nq,band,quad,md,mc,
     &           k0,k1,B_em,B_abs,alpha,ksi_abs,w_abs,ksi,w) ! MAJ des temp
            if (arret.eq.1) goto 20000 ! Si le rayon a fini son parcours on arrte
            goto 10000 ! Sinon il continue son parcours
20000       continue
            call update_results(md,k0,k1) ! Mise  jour des variables somme totales
c.Bloc parcours du rayon - Fin
            call print_state(Nb,Nq,band,quad,md,paq)
         enddo ! Fin de la boucle sur les n_tir rayons
      enddo ! Fin de la boucle sur le m+2 mailles
      call postcalc(Nb,Nq) ! Post-traitement des rsultats et sauvegarde
      call check_results(Nb) !  Vrification de validit de tous les rsultats
      call write_iseed() ! Ecriture du germe alatoire pour la prochaine simul
30000 call screen(100,0,0,0.0D+0,0.0D+0)
      end
