c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine pdf_tau_diff(gen,tau_diff_in,tau_diff_out,pdf)

      implicit none
      double precision pdf,R,tau_diff_in,tau_diff_out
      integer gen

c     Cette routine permet de coder le pdf de l'paisseur optique de diffusion
c     sur l'intervalle [0,+inf]
c     
c     Entres :
c       + gen : si gen=0, on ne gnre pas d'paisseur optique suivant le pdf spcifi
c               si gen=1, on gnre une paisseur optique suivant le pdf spcifi
c       + tau_diff_in : paisseur optique de diffusion dont on dsire obtenir le pdf si gen=0
c
c     Sorties :
c       + tau_diff_out : paisseur optique gnr suivant le pdf spcifi
c       + pdf : pdf(tau_diff_in)
c
c     Cette routine peut donc tre utilise pour deux choses :
c       + connatre le pdf d'une paisseur optique donne
c       + calculer une paisseur optique et son pdf
c

      if (gen.eq.1) then
         call rand_uniforme(R)
         tau_diff_out=-dlog(R)
         tau_diff_in=tau_diff_out
      endif

      pdf=dexp(-tau_diff_in)


      return
      end
