c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine print_state(Nb,Nq,band,quad,md,paq)

      implicit none

c     Cette routine sauve l'tat de progression du calcul dans la maille en cours
c     dans le fichier 'status' tous les ntir/n rayons

      include 'max.inc'
      include 'data.inc'
      include 'options.inc'

      integer md,paq,n_max,i,num,Nb,Nq,band,quad
      double precision ntot,nray,ncalc
      double precision layp,totp,nrest
      integer*8 date,date2,date_0,date_int,date_est
      integer hour_int0,min_int0,sec_int0
      integer*8 day_est,month_est,year_est
      integer*8 day2,month2,year2
      integer dates
      integer hour_est,min_est,sec_est
      integer hour2,min2,sec2,rem_sec
      integer diff,sec_int,n_event
      double precision tpc,tpl,tpnb,opt_pr
      character*2 day,month,hour,minute,second
      character*4 year
      character*200 st1
      integer strlen
      double precision eps
      parameter(eps=1.0D-100)
 1000 format (i2.2,i2.2,i4.4,i2.2,i2.2,i2.2)
      
 11   format(a)
 12   format(a,I2,a,I10)
 13   format(a,f5.1,a,f5.1,a)
 22   format(I2)
 24   format(I4)
 34   format(a,f4.2,a)
 35   format(a,f5.2,a)
 36   format(a,f6.2,a)
      call calc_nmax(md,n_max)
      if (dabs(dble(paq)/(dble(n_max)/dble(n_test))-
     &     int(dble(paq)/(dble(n_max)/dble(n_test)))).lt.eps) then
c     S'il est temps d'afficher l'tat intermdiaire du calcul, alors
         date_0=0
         call cur_date(date)    ! get current date
c     'n_max' est le nombre de rayons  lancer dans la maille en cours
c     'layp' est le pourcentage de calcul accompli dans la maille en cours
         layp=dble(paq)/dble(n_max)*1.0D+2
         ntot=0.0D+0
         do i=0,m+1
            call calc_nmax(i,num)
            ntot=ntot+dble(num)
         enddo
c     'ntot' est le nombre total de rayons  lancer pour le calcul complet

         nray=0.0D+0
         if (md.gt.0) then
            do i=0,md-1
               call calc_nmax(i,num)
               nray=nray+dble(num)
            enddo
         endif
         nray=nray+dble(paq)
         totp=nray/ntot*1.0D+2
c     'nray' est le nombre de rayons termins  l'instant prsent
c     'totp' est le pourcentage du calcul total accompli

         open(76,file='status')
         if ((md.eq.m+1).and.(paq.eq.n_tir)) then ! appel par main  la fin
            write(76,11) 'Computation successfully finished'

         else if ((md.eq.-1).and.(paq.eq.0)) then ! appel par init_nb_pdf pendant l'optimisation
c     Ecriture d'informations sur l'optimisation spectrale
            write(76,11) 'Spectral optimization in progress'
            call diff_date(date_start,date,diff)
            opt_pr=dble(band-1)/dble(Nb)*1.0D+2
c            if (opt_pr.lt.1.0D+1) then
c               write(76,34) 'Optmization progress: ',opt_pr,' %'
c            else if (opt_pr.lt.1.0D+2) then
c               write(76,35) 'Optmization progress: ',opt_pr,' %'
c            else
c               write(76,36) 'Optmization progress: ',opt_pr,' %'
c            endif
            write(76,36) 'Optmization progress: ',opt_pr,' %'
            
            
            if (band.eq.1) then
               write(76,11) 'No statistic available yet'
            else
               tpnb=dble(diff)/dble(band-nb_min)
               rem_sec=(nb_max-(band-1))*tpnb
               call add_date(date,rem_sec,date2)
               call convert_date(date2,day2,month2,year2,
     &              hour2,min2,sec2)
               write(day,22) day2
               write(month,22) month2
               write(year,24) year2
               write(hour,22) hour2
               write(minute,22) min2
               write(second,22) sec2
               st1='ETA for spectral optimization: '//day//'/'//
     &              month//'/'//year//' @ '//hour//':'//
     &              minute//':'//second
               write(76,*) 'Average CPU time per narrowband (s): ',tpnb
               write(76,*) st1(1:strlen(st1))
            endif ! band

         else if ((md.eq.-1).and.(paq.eq.-1)) then ! appel par init_nb_pdf pendant l'optimisation
            write(76,11) 'Spectral optimization finished'

         else if ((md.eq.-1).and.(paq.eq.2*n_tir)) then ! appel par init_nb_pdf  la fin
            write(76,11) 'Spectral optimization finished'
            write(76,11) 'Now initializing Monte-Carlo run'

         else
c     Ecriture d'information sur l'tat du calcul MC
            call diff_date(date1,date,diff)

c     'date1' repre le moment o le programme a t lanc (ou relanc)
c     'diff' repre ici le nombre de secondes entre l'instant prsent et
c     le moment ou le programme a t lanc

            if ((md.eq.0).and.(paq.eq.0)) then
c     Si on est dans la maille 0, au rayon 0, alors
               date2=0
               date_int=0
               date_est=0
            else
c     diff=nbre de secondes sparant dbut du calcul (ou moment de la
c     reprise du calcul) et l'heure actuelle
               ncalc=nray-nray1 ! nbre de calculs effectus depuis la reprise
               if (ncalc.ne.0.0D+0) then
c     One ne peut continuer que si ncalc est diffrent de zro, c'est--dire 
c     que si on n'est pas dans le cas o on vient juste de reprendre
                  tpc=dble(diff)/ncalc ! temps moyen ncessaire pour effectuer un calcul
                  if (md.ne.0) then
                     tpl=dble(diff)/dble(md) ! temps moyen par maille
                  endif
                  nrest=ntot-nray ! nombre de calculs restants
                  rem_sec=tpc*nrest ! nombre de secondes estim avant fin simul
                  call add_date(date,rem_sec,date2)
c     date2 est la date estime de fin du calcul MC

c     'date_start' et 'time_start' reprent le moment o la dernire sauvegarde de
c     rsultats intermdiaires a eu lieu

                  call diff_date(date_start,date,sec_int)
c     'sec_int' est le nombre de secondes coul depuis la dernire sauvegarde

c     'sec_int' reprsente le temps qui est suppos s'couler
c     jusqu' la prochaine sauvegarde, en supposant que cette dure sera la mme
c     qu'entre la dernire sauvegarde et celle en cours (sous-entendu on suppose
c     qu'un grand nombre de calculs est effectu entre deux sauvegardes successives
c     et que le CPU sera sollicit de la mme manire en moyenne qu'entre la dernire
c     sauvegarde et celle qui est en cours)

                  call add_date(date,sec_int,date_est)
c     'date_est' est la date suppose pour la prochaine sauvegarde, sous la mme hypothse
               endif
            endif

            if (ncalc.ne.0.0D+0) then
               open(23,file='time')
c               read(23,*) n_event
c               rewind(23)
c               write(23,*) n_event+1
c               if (n_event.ne.0) then
c                  do i=1,n_event
c                     read(23,*)
c                  enddo
c               endif
c     Conversion of "date_int" (seconds) into hours/min/sec
               call convert_sec(sec_int,hour_int0,min_int0,sec_int0)
               write(23,*) 'From (',md_prec,',',paq_prec,') to (',
     &              md,',',paq,') in ',hour_int0,':',min_int0,
     &              ':',sec_int0
c     Conversion of "date_est" (epoch) into day/month/year hour/min/sec
               call convert_date(date_est,day_est,month_est,year_est,
     &              hour_est,min_est,sec_est)

               write(23,*) 'ETA next event: ',day_est,'/',
     &              month_est,'/',year_est,' @ ',hour_est,':',
     &              min_est,':',sec_est
               close(23)
               date_start=date
               md_prec=md
               paq_prec=paq
               
               write(76,12) 'Computation progress: layer ',
     &              md,', statistical event',paq
               write(76,13) 'Progress for current layer: ',layp,
     &              '%,  Total progress: ',totp,'%'
c     Conversion of "date2" (epoch) into day/month/year hour/min/sec
               call convert_date(date2,day2,month2,year2,
     &              hour2,min2,sec2)
               write(day,22) day2
               write(month,22) month2
               write(year,24) year2
               write(hour,22) hour2
               write(minute,22) min2
               write(second,22) sec2
               st1='ETA: '//day//'/'//month//'/'//year//' @ '
     &              //hour//':'//minute//':'//second
               if (md.ne.0) then
                  write(76,*) 'Average CPU time per layer (s): ',tpl
               endif
               if (tpc.lt.0.5D-3) then
                  write(76,*) 'Average CPU time per bundle (s): ',
     &                 tpc*1.0D+6
               else if (tpc.lt.0.5D+0) then
                  write(76,*) 'Average CPU time per bundle (ms): ',
     &                 tpc*1.0D+3
               else
                  write(76,*) 'Average CPU time per bundle (s): ',
     &                 tpc
               endif
               write(76,*) st1(1:strlen(st1))
               if (scc.eq.1) then
                  call sauvegarde(Nb,Nq,band,quad,md,paq)
               endif
            else ! premire sauvegarde  la reprise d'un calcul interrompu
               write(76,12) 'Computation progress: layer ',
     &              md,', statistical event',paq
            endif ! ncalc=0
         endif
      endif

      if (paq.eq.-1) then
         open(76,file='status')
         write(76,11) 'Analytic computation successfully finished'
      endif

      close(76)

      return
      end
