c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine find_ka(band,quad,i,z,ka)
      implicit none
      include 'max.inc'
      include 'data.inc'
      double precision z,ka
      integer i,Nb,Nq,band,quad
c     Profil de ka, le coefficient d'absorption (m-1)

      ka=ka_gaz(band,i,quad)
     &     +ka_aero(band,i,quad)
     &     +ka_cloud(band,i,quad)
      
      return
      end


      subroutine find_kd(band,quad,i,z,kd)
      implicit none
      include 'max.inc'
      include 'data.inc'
      double precision z,kd,w,k
      integer i,Nb,Nq,band,quad
c     Profil de kd, le coefficient de diffusion (m-1)
      
      kd=kd_gaz(band,i,quad)
     &     +kd_aero(band,i,quad)
     &     +kd_cloud(band,i,quad)

      return
      end


      subroutine find_kd_gaz(band,quad,i,z,kd)
      implicit none
      include 'max.inc'
      include 'data.inc'
      double precision z,kd,w,k
      integer i,Nb,Nq,band,quad
c     Profil de kd, le coefficient de diffusion (m-1)
      
      kd=kd_gaz(band,i,quad)

      return
      end

      
      subroutine find_g(band,quad,i,z,g)
      implicit none
      include 'max.inc'
      include 'data.inc'
      double precision z,g
      integer i,Nb,Nq,band,quad,res,out
c     Profil de g, le paramtre d'asymtrie de la fonction de phase
c     pour nuages et arosols (gaz trait  part)

      g=(kd_aero(band,i,quad)*g_aero(band,i,quad)
     &     +kd_cloud(band,i,quad)*g_cloud(band,i,quad))
     &     /(kd_aero(band,i,quad)+kd_cloud(band,i,quad))

c     Ici on a un g construit  partir des paramtres d'asymtrie
c     donnes pour les arosols et pour les nuages

      return
      end

      
      subroutine find_B(band,quad,z,B)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'param.inc'
      include 'options.inc'
c     Profil de luminance ou de temprature du gaz uniquement (pas les parois)
      
      double precision z,B,Xmin,Xmax,DeltaXmax,Xsol,Xespace,X,Planck
      integer ptl,profil,i
      integer Nb,Nq,band,quad


      ptl=2 ! ptl=1 -> profil de luminace ; ptl=2 -> profil de temprature

      Xsol=Planck(temp(0),lambda_lo(band),lambda_hi(band)) ! Valeur pour le sol
      Xespace=0.0D+0 ! Valeur pour l'espace

c      Xmin=0.0D+0 ! Valeur minimale pour le gaz
c      DeltaXmax=1.0D+0 ! Valeur d'cart maximal - NE JAMAIS ANNULER CETTE VARIABLE

      call find_max(Xmin,DeltaXmax) ! Calcul de Xmin et DeltaXmax dans l'atmosphre

      profil=8 ! Profil prdfini si diffrent de 0
c     Valeurs de profils (profils prdfinis) :
c       + profil=1 -> profil par steps 1 : X=Xmin pour 0 < z < H/2, X=Xmin+DeltaXmax pour H/2 < z < H
c       + profil=2 -> profil par steps 2 : X=Xmin+DeltaXmax pour 0 < z < H/2, X=Xmin pour H/2 < z < H
c       + profil=3 -> profil plat : X=Xmin+DeltaXmax pour 0 < z < H
c       + profil=4 -> profil linaire 1 : X=Xmin+DeltaXmax en z=0, X=Xmin en z=H
c       + profil=5 -> profil linaire 2 : X=Xmin en z=0, X=Xmin+DeltaXmax en z=H
c       + profil=6 -> profil parabolique 1 : X=Xmin+DeltaXmax en z=H/2, X=Xmin en z=0 et z=H
c       + profil=7 -> profil parabolique 2 : X=Xmin en z=H/2, X=Xmin+DeltaXmax en z=0 et z=H
c       + profil=8 -> profil atmosphrique linaire par mailles
c
c     Si profil=0, on dfinit un autre profil -- non list --  l'aide de tous les paramtres dsirs.
c     

      if (profil.eq.0) then     ! profil utilisateur
         X=0.0D+0
c     X=1.D+0 !  specifier
      else if (profil.eq.1) then ! profil par steps 1
         if (z.lt.H/2.D+0) then
            X=Xmin
         else
            X=Xmin+DeltaXmax
         endif
      else if (profil.eq.2) then ! profil par steps 2
         if (z.lt.H/2.D+0) then
            X=Xmin+DeltaXmax
         else
            X=Xmin
         endif
      else if (profil.eq.3) then ! profil plat
         X=Xmin+DeltaXmax
      else if (profil.eq.4) then ! profil lineaire 1
         X=DeltaXmax*(1.D+0-z/H)+Xmin
      else if (profil.eq.5) then ! profil lineaire 2
         X=DeltaXmax*z/H+Xmin
      else if (profil.eq.6) then ! profil parabolique 1
         X=-4.D+0*DeltaXmax*(z/H-0.5D+0)**2 +
     &        (Xmin+DeltaXmax)
      else if (profil.eq.7) then ! profil parabolique 2
         X=4.D+0*DeltaXmax*(z/H-0.5D+0)**2 +
     &        Xmin
      else if (profil.eq.8) then ! profil atmosphrique linaire par mailles
         call find_T_gaz(z,X)
      endif

c     On connat X  l'altitude "alt"
c     Si ptl=1, X est une luminance
c     Si ptl=2, X est une temprature et il faut calculer la luminance (ncessit de connatre lambda)
 
      if (ptl.eq.1) then
         B=X
      else
         B=Planck(X,lambda_lo(band),lambda_hi(band))
      endif

      return
      end



      subroutine find_T_gaz(z,T)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'param.inc'
      include 'options.inc'
      double precision z,T
      integer i
      do i=1,m-1
         if ((z.ge.alt(i-1)).and.(z.le.alt(i))) then
            T=(temp(i)-temp(i-1))/(alt(i)-alt(i-1))*(z-alt(i-1))
     &           +temp(i-1)
         endif
      enddo

c     Test3
c      T=0.0D+0
c     Test3

      return
      end
