      subroutine sum_ACDEF(Nb,Tcentre,dksi_dTg,
     &     A_ref,C_ref,D_ref,E_ref,F_ref)
      implicit none

      include 'max.inc'
      include 'data.inc'
      integer i,j,p,band,Nb
      double precision nbw(1:Nbmx),lambda
      double precision Planck,dBdT
      double precision Bi_ref,Bj_ref
      double precision dBdTi_ref,dBdTj_ref
      double precision Tcentre(0:Nmax+1)
      double precision dksi_dTg(0:Nmax+1,0:Nmax+1,0:Nmax+1,1:Nbmx)
c     les matrices A_ref, C_ref, D_ref, E_ref et F_ref sont les matrices de
c     sensibilits A, C, D, E et F (cf. papier), sommes sur tout le spectre
      double precision A_ref(0:Nmax+1,0:Nmax+1,0:Nmax+1)
      double precision C_ref(0:Nmax+1,0:Nmax+1,0:Nmax+1)
      double precision D_ref(0:Nmax+1,0:Nmax+1,0:Nmax+1)
      double precision E_ref(0:Nmax+1,0:Nmax+1,0:Nmax+1)
      double precision F_ref(0:Nmax+1,2,0:Nmax+1)

      do band=1,Nb
         nbw(band)=1.0D+4/lambda_lo(band)-1.0D+4/lambda_hi(band)
      enddo                     ! band

      do p=0,m+1

         do i=0,m+1
            do j=0,m+1
               A_ref(i,j,p)=0.0D+0
               C_ref(i,j,p)=0.0D+0
               D_ref(i,j,p)=0.0D+0
               E_ref(i,j,p)=0.0D+0
            enddo               ! j
            F_ref(i,1,p)=0.0D+0
            F_ref(i,2,p)=0.0D+0
         enddo                  ! i

         do band=1,Nb
            lambda=(lambda_lo(band)+lambda_hi(band))/2.0D+0
            do i=0,m+1
               Bi_ref=Planck(Tcentre(i),lambda_lo(band),
     &              lambda_hi(band)) ! W/m/sr/m
               dBdTi_ref=dBdT(Tcentre(i),lambda) ! W/m/sr/m/K
               do j=0,m+1
                  Bj_ref=Planck(Tcentre(j),lambda_lo(band),
     &                 lambda_hi(band)) ! W/m/sr/m
                  dBdTj_ref=dBdT(Tcentre(j),lambda) ! W/m/sr/m/K
                  A_ref(i,j,p)=A_ref(i,j,p)+
     &                 (dksi_dTg(i,j,p,band)*Bi_ref)*nbw(band) ! W/m/K
                  D_ref(i,j,p)=D_ref(i,j,p)+
     &                 (dksi_dTg(i,j,p,band)*Bj_ref*nbw(band)) ! W/m/K
                  C_ref(i,j,p)=C_ref(i,j,p)+
     &                 (dksi_dTg(i,j,p,band)*dBdTi_ref*nbw(band)) ! W/m/K
                  E_ref(i,j,p)=E_ref(i,j,p)+
     &                 (dksi_dTg(i,j,p,band)*dBdTj_ref*nbw(band)) ! W/m/K

                  if (j.eq.i-1) then ! F(i,i-1,p)
                     F_ref(i,1,p)=F_ref(i,1,p)+
     &                    0.5D+0*dksi_dTg(i,i-1,p,band)*
     &                    (dBdTi_ref+dBdTj_ref)*
     &                    nbw(band)      ! W/m/K
                  else if (j.eq.i+1) then ! F(i,i+1,p)
                     F_ref(i,2,p)=F_ref(i,2,p)+
     &                    0.5D+0*dksi_dTg(i,i+1,p,band)*
     &                    (dBdTi_ref+dBdTj_ref)*
     &                    nbw(band)      ! W/m/K
                  endif

               enddo            ! j
            enddo               ! i
         enddo ! band
      enddo ! p

      return
      end
