c     Copyright (C) 2000-2008
c     Universite Paul Sabatier, Toulouse, France

c     This program is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 2, or (at your option)
c     any later version.

c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with this program; if not, write to the Free Software
c     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
c     USA.
c
      subroutine symetry(PNE,inc_PNE,PNEsym,inc_PNEsym)
      implicit none
c     Permet de symtriser le tableau 'PNE' et le tableau 'inc_PNE'
      
      include 'max.inc'
      include 'param.inc'
      include 'data.inc'
      integer i,j
      double precision s1,s2
      double precision PNE(0:Nmax+1,0:Nmax+1)
      double precision inc_PNE(0:Nmax+1,0:Nmax+1)
      double precision PNEsym(0:Nmax+1,0:Nmax+1)
      double precision inc_PNEsym(0:Nmax+1,0:Nmax+1)


      do i=0,m
         do j=i+1,m+1
            s1=inc_PNE(i,j)
            s2=inc_PNE(j,i)
            if ((s1.eq.0.0D+0).or.(s2.eq.0.0D+0)) then
               if (s1.eq.0.0D+0) then ! il faut prendre pne(j,i)
                  PNEsym(i,j)=-PNE(j,i)
                  PNEsym(j,i)=PNE(j,i)
                  inc_PNEsym(i,j)=s2
                  inc_PNEsym(j,i)=s2
               else if (s2.eq.0.0D+0) then ! il faut prendre pne(i,j)
                  PNEsym(i,j)=PNE(i,j)
                  PNEsym(j,i)=-PNE(i,j)
                  inc_PNEsym(i,j)=s1
                  inc_PNEsym(j,i)=s1
               endif
            else ! sinon s1 et s2 != 0
               if (s1.lt.s2) then ! il faut prendre pne(i,j)
                  PNEsym(i,j)=PNE(i,j)
                  PNEsym(j,i)=-PNE(i,j)
                  inc_PNEsym(i,j)=s1
                  inc_PNEsym(j,i)=s1
               else ! il faut prendre pne(j,i)
                  PNEsym(i,j)=-PNE(j,i)
                  PNEsym(j,i)=PNE(j,i)
                  inc_PNEsym(i,j)=s2
                  inc_PNEsym(j,i)=s2
               endif
            endif ! s1=0 ou s2=0
         enddo ! sur j
      enddo ! sur i
      PNEsym(m+1,m+1)=0.0D+0
      inc_PNEsym(m+1,m+1)=0.0D+0

      return
      end



      subroutine read_seed0()
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer ios

      open(10,file='./config/seed0',status='old',iostat=ios)
      if (ios.ne.0) then ! file not found
         call screen(1151,0,0,0.0D+0,0.0D+0)
         stop
      endif
      read(10,*) seed0
      close(10)

      return
      end



      subroutine write_seed0()
      implicit none
      include 'max.inc'
      include 'data.inc'

      open(10,file='./config/seed0')
      write(10,*) seed0
      close(10)

      return
      end



      subroutine setd(ksi,alpha,w,ksi_in,alpha_in,w_in)
      implicit none
      double precision ksi,alpha,w,ksi_in,alpha_in,w_in

      ksi_in=ksi
      alpha_in=alpha
      w_in=w

      return
      end


      subroutine setr(ksi_out,alpha_out,w_out,ksi,alpha,w)
      implicit none
      double precision ksi,alpha,w,ksi_out,alpha_out,w_out

      ksi=ksi_out
      alpha=alpha_out
      w=w_out

      return
      end


      subroutine statis(n,sum,sum2,val,var,inc)
      implicit none
      double precision sum,sum2,val,var,inc
      integer n

      val=sum/n
      var=dabs(sum2/n-(sum/n)**2)
      inc=dsqrt(var/n)
      call check(val)
      call check(var)
      call check(inc)

      return
      end



      subroutine check(value)
      implicit none
      double precision value

      if (dabs(value).le.1.0D-100) then
         value=0.0D+0
      endif

      return
      end


      subroutine Flux_nets_pne(tPNE,inc_tPNE,
     &     fnett_pne,inc_fnett_pne)
      implicit none

c     Calcule les flux nets  partir des PNE
      include 'max.inc'
      include 'param.inc'
      include 'data.inc'
      integer i,j,p
      double precision tPNE(0:Nmax+1,0:Nmax+1)
      double precision inc_tPNE(0:Nmax+1,0:Nmax+1)
      double precision fnett_pne(0:Nmax)
      double precision inc_fnett_pne(0:Nmax)
      double precision s1(0:Nmax),s2

      do p=0,m ! p: numro de l'interface
         fnett_pne(p)=0.0D+0
         inc_fnett_pne(p)=0.0D+0
         s2=0.0D+0
         do i=0,p
            s1(i)=0.0D+0
            do j=p+1,m+1
               fnett_pne(p)=fnett_pne(p)+tPNE(i,j)
               s1(i)=s1(i)+inc_tPNE(i,j)
            enddo               ! sur j
            s2=s2+s1(i)**2
         enddo                  ! sur i
         inc_fnett_pne(p)=dsqrt(s2)
         
      enddo                     ! sur p

      return
      end




      subroutine Flux_nets_pne_theo(tPNE,fnett_pne)
      implicit none
c     Identique  Flux_nets_pne mais pour les PNE mono-
      include 'max.inc'
      include 'param.inc'
      include 'data.inc'
      integer i,j,inter
      double precision tPNE(0:Nmax+1,0:Nmax+1)
      double precision fnett_pne(0:Nmax)

      do inter=0,m ! inter : numro de l'interface
         fnett_pne(inter)=0.0D+0
         do i=0,inter
            do j=inter+1,m+1
               fnett_pne(inter)=fnett_pne(inter)+tPNE(i,j)
            enddo               ! sur j
         enddo                  ! sur i
         
      enddo                     ! sur inter

      return
      end


c     sensitivities...
      subroutine dFnet_dT_theo(nbw,dNER_dT_band,dFnet_dT_band)
      implicit none
      include 'max.inc'
      include 'param.inc'
      include 'data.inc'
      integer i,j,p,inter
      double precision nbw
      double precision dner_dT_band(0:Nmax+1,0:Nmax+1,0:Nmax+1)
      double precision dFnet_dT_band(0:Nmax,0:Nmax+1)
      double precision dner_dT(0:Nmax+1,0:Nmax+1)
      double precision dfnet_dT(0:Nmax)

c     [dner_dT_band]=W/m/K
c     [dFnet_dT_band]=W/m/cm/K

      do p=0,m+1                ! p : numro de la temprature
         do i=0,m+1
            do j=0,m+1
               dner_dT(i,j)=dner_dT_band(i,j,p) ! W/m/K
            enddo ! j
         enddo ! i
         call Flux_nets_pne_theo(dner_dT,dfnet_dT)
c     dfnet_dT=W/m/K
         do i=0,m
            dFnet_dT_band(i,p)=dfnet_dT(i)/nbw ! W/m/cm/K
         enddo ! i
      enddo                     ! sur p

      return
      end
c     ...sensitivities



      subroutine budget_from_ner(m,ner,budget_total,
     &     budget_gs,budget_ge,budget_gg)
      implicit none
      include 'max.inc'
      integer i,j,m
      double precision ner(0:Nmax+1,0:Nmax+1)
      double precision budget_total(0:Nmax+1)
      double precision budget_gs(0:Nmax+1)
      double precision budget_ge(0:Nmax+1)
      double precision budget_gg(0:Nmax+1)

      do i=0,m+1
         budget_total(i)=0.0D+0
         do j=0,m+1
            budget_total(i)=budget_total(i)+ner(i,j)
         enddo ! j
         budget_gs(i)=ner(i,0)
         budget_gg(i)=0.0D+0
         budget_ge(i)=ner(i,m+1)
         budget_gg(i)=budget_total(i)-(budget_gs(i)+budget_ge(i))
      enddo ! i

      return
      end



c     sensitivities...
      subroutine dbudget_dT_theo(dNER_dT_band,dbudget_dT_band)
      implicit none
      include 'max.inc'
      include 'param.inc'
      include 'data.inc'
      integer i,j,p
      double precision dner_dT_band(0:Nmax+1,0:Nmax+1,0:Nmax+1)
      double precision dbudget_dT_band(0:Nmax+1,0:Nmax+1)
      double precision dner_dT(0:Nmax+1,0:Nmax+1)
      double precision dbudget_dT(0:Nmax+1)
      double precision dbudgetgs_dT(0:Nmax+1)
      double precision dbudgetge_dT(0:Nmax+1)
      double precision dbudgetgg_dT(0:Nmax+1)

      do p=0,m+1
         do i=0,m+1
            do j=0,m+1
               dner_dT(i,j)=dner_dT_band(i,j,p)
            enddo ! j
         enddo ! i
         call budget_from_ner(m,dner_dT,dbudget_dT,
     &        dbudgetgs_dT,dbudgetge_dT,dbudgetgg_dT)
         do i=0,m+1
            dbudget_dT_band(i,p)=dbudget_dT(i)
         enddo ! i
      enddo ! p

      return
      end
c     ...sensitivities




      subroutine nbands(k,Nq,band,quad)
      implicit none
      integer k,Nq,band,quad

      band=int(dble(k-1)/dble(Nq))+1
      quad=k-int(dble(band-1)*dble(Nq))

      return
      end


      subroutine numk(Nq,band,quad,k)
      implicit none
      integer Nq,band,quad,k

      k=(band-1)*Nq+quad

      return
      end


c      double precision function lambda_min(l)
c      implicit none
c      include 'max.inc'
c      include 'data.inc'
c      double precision l

cc     Attention : l (longueur d'onde) doit tre
cc     entre en micromtres. lambda_min correspond
cc      la valeur de la longueur d'onde de la borne
cc     gauche (min) de l'intervalle spectral dont le
cc     centre est l

c      lambda_min=1.0D+4/(1.0D+4/l+nbw/2.0D+0)

c      return
c      end

c      double precision function lambda_max(l)
c      implicit none
c      include 'max.inc'
c      include 'data.inc'
c      double precision l

cc     Attention : l (longueur d'onde) doit tre
cc     entre en micromtres. lambda_min correspond
cc      la valeur de la longueur d'onde de la borne
cc     droite (max) de l'intervalle spectral dont le
cc     centre est l

c      lambda_max=1.0D+4/(1.0D+4/l-nbw/2.0D+0)

c      return
c      end

c      double precision function dlambda(l)
c      implicit none
c      include 'max.inc'
c      include 'data.inc'
c      double precision l

cc     Attention : l (longueur d'onde) doit tre
cc     entre en micromtres. dlambda est renvoy
cc     en micromtres : c'est la largeur en m
cc     de l'intervalle spectral dont l est le centre

c      dlambda=1.0D+4/(1.0D+4/l-nbw/2.0D+0)-
c     &     1.0D+4/(1.0D+4/l+nbw/2.0D+0)

c      return
c      end


      double precision function cr_coeff(i)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'param.inc'
      double precision T,p,Cp,rho
      integer i
      
      if (i.eq.0) then
         T=temp(0)
         p=pres(0)
         Cp=capa(0)
         rho=dens(0)
      else if (i.eq.1) then
         T=(temp(1)-temp(0))/(alt(1)-alt(0))*
     &        ((e(1)-e(0))/2.0D+0-alt(0))+temp(0)
         p=(pres(1)-pres(0))/(alt(1)-alt(0))*
     &        (e(1)+e(0))/2.0D+0+pres(0)
         Cp=(capa(1)-capa(0))/(alt(1)-alt(0))*
     &        (e(1)+e(0))/2.0D+0+capa(0)
         rho=(dens(1)-dens(0))/(alt(1)-alt(0))*
     &        (e(1)+e(0))/2.0D+0+dens(0)
      else if (i.eq.m) then
         T=(temp(m-1)-temp(m-2))/(alt(m-1)-alt(m-2))*
     &        ((e(m)+e(m-1))/2.0D+0-alt(m-1))+temp(m-2)
         p=(pres(m-1)-pres(m-2))/(alt(m-1)-alt(m-2))*
     &        ((e(m)+e(m-1))/2.0D+0-alt(m-1))+pres(m-2)
         Cp=(capa(m-1)-capa(m-2))/(alt(m-1)-alt(m-2))*
     &        ((e(m)+e(m-1))/2.0D+0-alt(m-1))+capa(m-2)
         rho=(dens(m-1)-dens(m-2))/(alt(m-1)-alt(m-2))*
     &        ((e(m)+e(m-1))/2.0D+0-alt(m-1))+dens(m-2)
      else if (i.eq.m+1) then
         T=temp(m-1)
         p=pres(m-1)
         Cp=capa(m-1)
         rho=dens(m-1)
      else
         T=temp(i)
         p=pres(i)
         Cp=capa(i)
         rho=dens(i)
      endif

      cr_coeff=1.0D+0/(rho*Cp)*3600.D+0*24.0D+0 ! K/m3/J
      
      return
      end
      
      integer function strlen(st)
      integer i
      character st*(*)
      i=len(st)
      do while (st(i:i).eq.' ')
         i=i-1
      enddo
      strlen=i
      return
      end


      subroutine test_nan(value,out)
      implicit none
      integer t1,t2,out
      double precision value
c
c     Cette routine teste si le rel 'value' fourni est un NAN ou pas.
c     Si out=0, "value" a une valeur relle.
c     Si out=1, "value" est un NAN
c
      out=0 ! default
      if (value.le.0.0D+0) then
         t1=0
      else
         t1=1
      endif
      if (value.ge.0.0D+0) then
         t2=0
      else
         t2=1
      endif
      if ((t1.eq.1).and.(t2.eq.1)) then
         out=1
      endif

      return
      end


      subroutine test_inf(value,out)
      implicit none
      double precision value,big,inf
      integer out
      parameter(big=1.0D+300)
c     Input: value (double precision)
c     Output: out
c       + out=0 means "value" has a finite value
c       + out=1 means "value" is infinite

      inf=dexp(big) ! this is infinity, for sure
      out=0 ! default=no problem
      if (dabs(value).eq.inf) then
         out=1 ! value=Inf
      endif

      return
      end



      subroutine diff_date(date1,date2,diff)
      implicit none
      integer*8 date1,date2
      integer diff
c     Purpose: compute time difference (in seconds)
c     between date2 and date1, given in epoch format
c     Debug
      if (date2.lt.date1) then
         write(*,*) 'Warning in diff_date:'
         write(*,*) 'date2=',date2,' < date1=',date1
      endif
c     Debug
      diff=date2-date1

      return
      end


      subroutine add_date(date1,diff,date2)
      implicit none
      integer*8 date1,date2
      integer diff
      date2=date1+diff

      return
      end
      


      subroutine convert_sec(dates,hour,min,sec)
      implicit none
      integer dates
      integer hour,min,sec
      
      hour=0
      min=0
      if (dates.gt.3600) then
         hour=dates/3600
         dates=dates-hour*3600
      endif
      if (dates.gt.60) then
         min=dates/60
         dates=dates-min*60
      endif
      sec=dates
      
      return
      end



      subroutine calc_dQ()
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'param.inc'

      integer i,i1,i2,out,res
      double precision z1,z2,p1,p2
      double precision g1,g2,g
      double precision Cp1,Cp2,Cp
      double precision rho

c     dQe(i) reprsente maintenant la quantit d'nergie ncessaire  lever de 1K
c     la temprature de la maille i (dans le maillage de calcul "e").

      do i=1,m
c     Calcul des niveaux de pression p1 et p2, respectivement en bas et en haut
c     de la maille numro "i" du tableau "e" (p1>p2)
         z1=e(i-1)
         z2=e(i)
         call find_alt_i1(z1,i1,out)
         if (out.eq.0) then
            i1=i1-1
         else if (out.eq.-1) then
            i1=0
         else if (out.eq.1) then
            i1=m-1
         endif
         call find_alt_i1(z2,i2,out)
         if (out.eq.0) then
            i2=i2-1
         else if (out.eq.-1) then
            i2=0
         else if (out.eq.1) then
            i2=m-1
         endif
         call z2p(alt(i1),alt(i1+1),z1,pres(i1),pres(i1+1),p1)
         call z2p(alt(i2),alt(i2+1),z2,pres(i2),pres(i2+1),p2)
         call lin_interp(alt(i1),alt(i1+1),z1,capa(i1),capa(i1+1),Cp1)
         call lin_interp(alt(i2),alt(i2+1),z2,capa(i2),capa(i2+1),Cp2)
         Cp=(Cp1+Cp2)/2.0D+0
         call lin_interp(alt(i1),alt(i1+1),z1,grav(i1),grav(i1+1),g1)
         call lin_interp(alt(i2),alt(i2+1),z2,grav(i2),grav(i2+1),g2)
         g=(g1+g2)/2.0D+0
         rho=(p1-p2)/(g*(e(i)-e(i-1))) ! kg/m
         dQe(i)=Cp*rho ! (J/K/kg)*(kg/m)=J/K/m
c     Debug
c         write(*,*) 'dQe(',i,')=',dQe(i)
c         write(*,*) 'Cp=',Cp,' rho=',rho
c         write(*,*) 'p1=',p1,' p2=',p2
c         write(*,*) 'alt(',i1,')=',alt(i1),' alt(',i1+1,')=',alt(i1+1)
c         write(*,*) 'z1=',z1
c         write(*,*) 'pres(',i1,')=',pres(i1),
c     &        ' pres(',i1+1,')=',pres(i1+1)
c     Debug
      enddo ! i

      return
      end


      subroutine z2p(z1,z2,z,p1,p2,p)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'param.inc'

      double precision p,p1,p2,z,z1,z2,a
c     Calcule la pression "p" correspondant  l'altitude "z",
c     sachant que 'p' est siut entre p1 (niveau de pression de bas de la
c     maille, situ  l'altitude z1) et p2 (niveau de pression de haut
c     de la maille, situ  l'altitude z2) en supposant une loi
c     d'volution en exponentielle de la pression entre les niveaux
c     z1 et z2: p(z)=p1*exp(-a*(z-z1))
      a=1.0D+0/(z2-z1)*dlog(p1/p2)
      p=p1*dexp(-a*(z-z1))

      return
      end


      subroutine p2z(p1,p2,p,z1,z2,z)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'param.inc'

      double precision p,p1,p2,z,z1,z2,a
c     Calcule l'altitude "z" correspondant  la pression "p" ,
c     sachant que 'p' est siut entre p1 (niveau de pression de bas de la
c     maille, situ  l'altitude z1) et p2 (niveau de pression de haut
c     de la maille, situ  l'altitude z2) en supposant une loi
c     d'volution en exponentielle de la pression entre les niveaux
c     z1 et z2: p(z)=p1*exp(-a*(z-z1))
      a=1.0D+0/(z2-z1)*dlog(p1/p2)
      z=z1+dlog(p1/p)/a

      return
      end


      subroutine lin_interp(z1,z2,z,a1,a2,a)
      implicit none
      include 'max.inc'
      include 'param.inc'

      double precision z1,z2,z,a1,a2,a

c     Interpolation linaire de la quantit "a":
c     a1 est connu en z1, a2 est connu en z2
c     on cherche a en z, en supposant une loi d'volution linaire
c     entre z1 et z2

      a=a1+(a2-a1)/(z2-z1)*(z-z1)

      return
      end


      subroutine find_e_i1(z,i1,out)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'param.inc'
c     Purpose: identify the layer 'i1' of array 'e' within which 
c     is altitude 'z'. 
      integer i,f,i1,out
      double precision z

      f=0
      do i=1,m
         if ((z.ge.e(i-1)).and.(z.le.e(i))) then
            i1=i
            f=1
            out=0
            goto 123
         endif
      enddo
      if (f.eq.0) then ! maille pas identifie
         if (z.lt.e(0)) then
            out=-1
         else if (z.gt.e(m)) then
            out=1
         endif
      endif

 123  continue
      return
      end


      subroutine find_alt_i1(z,i1,out)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'param.inc'
c     Purpose: identify the layer 'i1' of array 'alt' within which 
c     is altitude 'z'. 
      integer i,f,i1,out
      double precision z

      f=0
      do i=1,m-1
         if ((z.ge.alt(i-1)).and.(z.le.alt(i))) then
            i1=i
            f=1
            out=0
            goto 123
         endif
      enddo
      if (f.eq.0) then ! maille pas identifie
         if (z.lt.alt(0)) then
            out=-1
         else if (z.gt.alt(m-1)) then
            out=1
         endif
      endif

 123  continue
      return
      end


      subroutine find_pres_i1(p,i1,out)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'param.inc'
c     Purpose: find integer 'i1', the index of the layer in array 'pres',
c     so that pressure level 'p' is included between the pressure levels
c     at layer 'i1' interfaces pres(i1) and pres(i1+1)

      integer i,f,i1,out
      double precision p
      
      f=0
      do i=0,m-2
         if ((p.le.pres(i)).and.(p.ge.pres(i+1)))
     &        then
            f=1
            i1=i
            out=0
            goto 123
         endif
      enddo
      if (f.eq.0) then ! si maille 'i1' non identifie
         if (p.gt.pres(0)) then
            out=-1
         else if (p.lt.pres(m-1)) then
            out=1
         endif
      endif
 123  continue
c     Debug
c      write(*,*) 'pres(',m-1,')=',pres(m-1),' p=',p,' out=',out
c     Debug
      return
      end


      subroutine lin_interp_rm(m2,alt2,tab,tab2)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'param.inc'

      integer m2,i,i1,i2,out
      double precision alt2(0:Nmax)
      double precision tab(0:Nmax)
      double precision tab2(0:Nmax)
c     Debug
c      integer sig
c     Debug

c     Debug
c      do i=0,m2
c         write(*,*) 'alt2(',i,')=',alt2(i)
c      enddo
c     Debug

      do i2=0,m2-1
c     On repre dans quelle maille de "alt" se situe "alt2(i2)"
         call find_alt_i1(alt2(i2),i1,out)
         if (out.eq.-1) then
            i1=1
         else if (out.eq.1) then
            i1=m-1
         endif
c     Interpolation linaire de la quantit tab2(i2) entre tab(i1-1) et tab(i1)
         tab2(i2)=tab(i1-1)+(tab(i1)-tab(i1-1))/(alt(i1)-alt(i1-1))
     &        *(alt2(i2)-alt(i1-1))
c     Debug
c         if (sig.eq.1) then
c            write(*,*) 'i1=',i1,' tab(',i1-1,')=',tab(i1-1),
c     &           ' tab(',i1,')=',tab(i1),' alt(',i1-1,')=',alt(i1-1),
c     &           ' alt(',i1,')=',alt(i1),' alt2(',i2,')=',alt2(i2),
c     &           ' tab2(',i2,')=',tab2(i2)
c         endif
c     Debug
      enddo ! sur i2

      return
      end


      subroutine set_one_NbNq(band,quad,m,kw,k)
      implicit none
      include 'max.inc'
      include 'param.inc'

      integer i,m,band,quad
      double precision kw(1:Nbmx,1:Nmax,1:Nqmx)
      double precision k(1:Nmax)

      do i=1,m
         k(i)=kw(band,i,quad)
      enddo
     
      return
      end


      subroutine set_two_NbNq(band,quad,m,k,kw)
      implicit none
      include 'max.inc'
      include 'param.inc'

      integer i,m,band,quad
      double precision kw(1:Nbmx,1:Nmax,1:Nqmx)
      double precision k(1:Nmax)

      do i=1,m
         kw(band,i,quad)=k(i)
      enddo
     
      return
      end


      subroutine set_one_Nb(band,m,kw,k)
      implicit none
      include 'max.inc'
      include 'param.inc'

      integer i,m,band
      double precision kw(1:Nbmx,1:Nmax)
      double precision k(1:Nmax)

      do i=1,m
         k(i)=kw(band,i)
      enddo
     
      return
      end


      subroutine set_two_Nb(band,m,k,kw)
      implicit none
      include 'max.inc'
      include 'param.inc'

      integer i,m,band
      double precision kw(1:Nbmx,1:Nmax)
      double precision k(1:Nmax)

      do i=1,m
         kw(band,i)=k(i)
      enddo
     
      return
      end


      subroutine postmesh()
      implicit none
      include 'max.inc'
      include 'param.inc'
      include 'data.inc'

      integer i,mr
      double precision sum

      H=e(m)

c     Fabrication du tableau 'alti' regroupant les altitudes de haut de
c     maille pour un maillage dboubl : division de l'atmosphre suivant
c     les altitudes 'e' et les altitudes 'alt'

      alti(0)=alt(0)
      do i=1,m-1
         alti(2*i-1)=e(i)
         alti(2*i)=alt(i)
      enddo

c     Production du tableau "er" pour matrices recombines
      mr=m-2
      er(0)=e(0)
      do i=1,mr-1
         er(i)=e(i+1)
      enddo
      er(mr)=e(m)
      

c     Calcul de la temprature moyenne de l'atmosphre
      sum=0.0D+0
      do i=0,m-2
         sum=sum+temp(i)*(alt(i+1)-alt(i))
      enddo
      Tm=sum/alt(m-1)

      open(10,file='./results/mesh_z.txt')
      write(10,*) ' i - z(i-1) - z(i)'
      do i=1,m
         write(10,*) i,e(i-1)
         write(10,*) i,e(i)
         write(10,*) 
      enddo
      close(10)
      open(11,file='./results/pressure.txt')
      open(12,file='./results/temperature.txt')
      open(13,file='./results/h2o.txt')
      open(14,file='./results/o3.txt')
      do i=0,m-1
         write(11,*) i+1,alt(i)/1.0D+3,pres(i)
         write(12,*) i+1,alt(i)/1.0D+3,temp(i)
         write(13,*) i+1,alt(i)/1.0D+3,h2o(i)
         write(14,*) i+1,alt(i)/1.0D+3,o3(i)
      enddo
      close(11)
      close(12)
      close(13)
      close(14)

      return
      end


      subroutine cur_date(date)
      implicit none
c     Purpose: to return the current date (at epoch format)
c     in variable "date"
      integer strlen
      integer*8 date
      character*100 command
      
      command='bash/cur_date.bash'
      call system(command(1:strlen(command)))
      open(20,file='./bash/date')
      read(20,*) date
      close(20)

      return
      end
  

      subroutine convert_date(date_epoch,day,month,year,hour,min,sec)
      implicit none
      integer*8 date,date_epoch
      integer*8 day,month,year
      integer hour,min,sec
      
c     convert epoch date using "epochToDate" script
      open(40,file='./bash/epoch')
      write(40,*) date_epoch
      close(40)
      call system('./bash/epoch2date.bash')
      open(41,file='./bash/date')
      read(41,*) date
      close(41)

      year=date/100000/100000
      date=date-year*100000*100000
      month=date/100000000
      date=date-month*100000000
      day=date/1000000
      date=date-day*1000000
      hour=date/10000
      date=date-hour*10000
      min=date/100
      date=date-min*100
      sec=date

      return
      end


      subroutine detect_viewer(out)
      implicit none
c     Purpose: identify which viewer will be used when special
c     signal 10 is sent to Karine
      integer out,strlen,n_list,i,j
      character*20 name,app
c     Default: no viewer found (out=0)
      out=0
      call system('./bash/detect_viewer.bash')
      open(10,file='./bash/name')
      read(10,*) name
      close(10)
      
      open(11,file='./bash/n_list')
      read(11,*) n_list
      close(11)

      do i=1,n_list
         open(12,file='./bash/list')
         if (i.gt.1) then
            do j=1,i-1
               read(12,*)
            enddo
         endif
         read(12,*) app
         close(12)
         if (app(1:strlen(app)).eq.name(1:strlen(name))) then
            out=i
         endif
      enddo ! i

      return
      end



      subroutine detect_javac(out)
      implicit none
      integer out

c     This routine will detect if the "javac" command
c     is installed (out=1) or not (out=0)
      call system('./bash/detect_java.bash')
      open(10,file='./bash/javac_detected')
      read(10,*) out
      close(10)

      return
      end


      subroutine detect_mail(out)
      implicit none
      integer out

c     This routine will detect if the "mail" command
c     is installed (out=1) or not (out=0)
      call system('./bash/detect_mail.bash')
      open(10,file='./bash/mail_detected')
      read(10,*) out
      close(10)

      return
      end


      subroutine detect_mutt(out)
      implicit none
      integer out

c     This routine will detect if the "mutt" command
c     is installed (out=1) or not (out=0)
      call system('./bash/detect_mutt.bash')
      open(10,file='./bash/mutt_detected')
      read(10,*) out
      close(10)

      return
      end






      subroutine send_mail(sma,dest,fichier)
      implicit none
      integer b,k,m,g
      double precision size,size_limit
      integer out,strlen,sma,outmail,outmutt,outc
      character*100 dest,fichier,mailcommand
      character*200 command
      character*100 attachment,file_name
      size_limit=5.0D+0 ! Mb

c     Si l'utilisateur n'a pas donn le droit d'envoyer de mail,
c     on ne l'envoie pas...
      if (sma.eq.0) then
         goto 123
      endif

c     Dtection de connexion
      call detect_connexion(outc)
c     Si la machine n'est pas connecte au Net, inutile de continuer
      if (outc.eq.0) then
         goto 123
      endif

c     Dtection de la commande "mail"
      call detect_mail(outmail)
c     Dtection de la commande "mutt"
      call detect_mutt(outmutt)

      if (outmutt.eq.1) then
c     Si 'mutt' a t trouv, c'est le programme d'envoi de mail
c     qui sera utilis (peut envoyer des fichiers attachs)
         mailcommand='mutt'
         command='rm -f ./temporary/atmos_data.txt.gz'
         call system(command(1:strlen(command)))
         call gzip_atmosdata()
         file_name='./temporary/atmos_data.txt.gz'
         call file_size(file_name,size,b,k,m,g)
         if ((b.eq.1).or.(k.eq.1).or.
     &        ((m.eq.1).and.(size.lt.size_limit))) then
            attachment='-a data.in -a options.in'//
     &           ' -a ./temporary/atmos_data.txt.gz'
         else
            attachment='-a data.in -a options.in'
         endif
      else if (outmail.eq.1) then
c     Si 'mutt' n'est pas install, mais que 'mail' l'est, alors on
c     utilisera ce programme, mme s'il ne peut pas envoyer
c     de fichiers attachs
         mailcommand='mail'
         attachment=' '
      else
c     Sinon inutile de se fatiguer
         goto 123
      endif

      command=mailcommand(1:strlen(mailcommand))//
     &     ' -s "karine news" '//
     &     attachment(1:strlen(attachment))//' '//
     &     dest(1:strlen(dest))//
     &     ' < '//
     &     fichier(1:strlen(fichier))
c     Debug
c      write(*,*) 'command=',command(1:strlen(command))
c      stop
c     Debug
      call system(command(1:strlen(command))) ! envoi du mail
      command='rm -f '//fichier(1:strlen(fichier))
      call system(command(1:strlen(command)))
      command='rm -f ./temporary/atmos_data.txt.gz'
      call system(command(1:strlen(command)))

 123  continue
      return
      end



      subroutine detect_kernel(out)
      implicit none
      integer out,k
 21   format(I2)

c     This routine will detect if the systems runs a 
c     2.4 kernel (out=1) or not (out=0)
      call system('./bash/detect_kernel.bash')
      open(10,file='./bash/kernel2.4')
      read(10,21) k
      close(10)
      out=0 ! default: kernel 2.4 is not used
      if (k.eq.1) then
         out=1 ! if 2.4 kernel has been detected, out=1
      endif

      return
      end


      subroutine detect_connexion(out)
      implicit none
      integer out
 21   format(I2)

c     This routine will detect if the systems is connected 
c     to the Net (out=1) or not (out=0)
      call system('./bash/check_connexion.bash')
      open(10,file='./bash/connexion')
      read(10,21) out
      close(10)

      return
      end



      subroutine erase_results()
      implicit none
      character*100 command
      
      command='rm -f ./results/*.txt ./results/*.log'
      call system_command(command)

      return
      end



      subroutine angular_discretization()
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'param.inc'
      integer i

c     Debug
c      write(*,*) 'coucou, Nsec=',Nsec
c     Debug
      do i=1,Nsec
         theta_sec(i,1)=pi/Nsec*(i-1)
         theta_sec(i,2)=pi/Nsec*i
c     Debug
c         write(*,*) 'i=',i,theta_sec(i,1),theta_sec(i,2)
c     Debug
      enddo
c     Debug
      open(11,file='./results/angular_discretization.txt')
      do i=1,Nsec
         write(11,*) i,theta_sec(i,1),theta_sec(i,2)
      enddo
      close(11)
c     Debug

      return
      end


      subroutine find_sec(alpha,sec,dtheta)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'param.inc'
      integer i,sec,secf
      double precision alpha,dtheta

      secf=0
      do i=1,Nsec
         if ((alpha.ge.theta_sec(i,1)).and.
     &        (alpha.le.theta_sec(i,2))) then
            sec=i
            dtheta=theta_sec(i,2)-theta_sec(i,1)
            secf=1
            goto 123
         endif
      enddo
 123  continue
      if (secf.eq.0) then
         write(*,*) 'Error from routine find_sec:'
         write(*,*) 'Angular sector could not be found'
         write(*,*) 'alpha=',alpha
         stop
      endif

      return
      end



      subroutine make_start_mail(smail,fichier)
      implicit none
      include 'max.inc'
      include 'data.inc'
      include 'email.inc'
      integer strlen,smail,omutt
      character*100 fichier,command
      character*100 user,machine,machtype,kernel
      character*100 shell,pwd
      integer*8 date,day,month,year
      integer hour,min,sec
 21   format(a,I2,a,I2,a,I4,a,I2,a,I2,a,I2)

c     Si l'utilisateur n'a pas donn le droit d'envoyer de mail,
c     inutile de le fabriquer.
      if (smail.eq.0) then
         goto 123
      endif

      call find_user(user)
      call find_machine(machine)
      call find_machtype(machtype)
      call find_kernel(kernel)
      call find_shell(shell)
      call find_pwd(pwd)
      call cur_date(date)
      call convert_date(date,day,month,year,hour,min,sec)
      call read_seed0()

      open(12,file='./t1')
      write(12,*) 'This email has been sent by Karine'
      write(12,*)
      write(12,*) 'User: '//user(1:strlen(user))
      write(12,*) 'email address: '//user_email(1:strlen(user_email))
      write(12,*) 'From: '//machine(1:strlen(machine))
      write(12,*) 'CPU type: '//machtype(1:strlen(machtype))
      write(12,*) 'Kernel version: '//kernel(1:strlen(kernel))
      write(12,*) 'Connexion shell: '//shell(1:strlen(shell))
      write(12,*) 'Karine installation path: '//pwd(1:strlen(pwd))
      write(12,*) 'Run started on ',day,' /',month,' /',year,
     &     ' @ ',hour,':',min,':',sec
      write(12,*) 'seed0: ',seed0
      write(12,*)
      close(12)

c     Dtection de la commande "mutt"
      call detect_mutt(omutt)
c     Debug
c      write(*,*) 'omutt=',omutt
c      stop
c     Debug
c     Si la commande 'mutt' est installe, alors pas besoin d'crire les
c     fichiers 'data.in' et options.in' dans le corps du texte: on peut les
c     envoyer en fichiers attachs
      if (omutt.eq.1) then
         command='cp t1 '//
     &        fichier(1:strlen(fichier))
         call system_command(command)
         command='rm -f t1'
         call system_command(command)
         goto 123
      endif

c     Si 'mutt' n'est pas install, alors on sera oblig d'utiliser 'mail', qui
c     ne peut pas envoyer de fichiers attachs. Il faut inclure les fichiers
c     en question dans le corps du texte.
      open(13,file='./t2')
      write(13,*)
      write(13,*) '+-----------------------------------------------+'
      write(13,*) '+        Karine "data.in" file                   +'
      write(13,*) '+-----------------------------------------------+'
      write(13,*)
      close(13)

      open(14,file='./t3')
      write(14,*)
      write(14,*) '+-----------------------------------------------+'
      write(14,*) '+        Karine "options.in" file              +'
      write(14,*) '+-----------------------------------------------+'
      write(14,*)
      close(14)

      command='cat t1 t2 data.in t3 options.in > '//
     &     fichier(1:strlen(fichier))
      call system_command(command)
      command='rm -f t1 t2 t3'
      call system_command(command)

 123  continue
      return
      end



      subroutine system_command(commande)
      integer strlen
      character*100 commande

      call system(commande(1:strlen(commande)))

      return
      end




      subroutine find_user(user)
      implicit none
      character*100 user
      
      call system('./bash/find_user.bash')
      open(11,file='./bash/user')
      read(11,*) user
      close(11)

      return
      end



      subroutine find_machine(machine)
      implicit none
      character*100 machine
      
      call system('./bash/find_machine.bash')
      open(11,file='./bash/machine')
      read(11,*) machine
      close(11)

      return
      end



      subroutine find_machtype(machtype)
      implicit none
      character*100 machtype
      
      call system('./bash/find_machtype.bash')
      open(11,file='./bash/machtype')
      read(11,*) machtype
      close(11)

      return
      end



      subroutine find_kernel(kernel)
      implicit none
      character*100 kernel
      
      call system('./bash/find_kernel.bash')
      open(11,file='./bash/kernel1')
      read(11,*) kernel
      close(11)

      return
      end



      subroutine find_shell(shell)
      implicit none
      character*100 shell
      
      call system('./bash/find_shell.bash')
      open(11,file='./bash/shell')
      read(11,*) shell
      close(11)

      return
      end



      subroutine find_pwd(pwd)
      implicit none
      character*100 pwd
      
      call system('./bash/find_pwd.bash')
      open(11,file='./bash/pwd')
      read(11,*) pwd
      close(11)

      return
      end




      subroutine erase_temporary()
      implicit none

      call system('rm -f ./bash/connexion')
      call system('rm -f ./bash/init')
      call system('rm -f ./bash/javac_detected')
      call system('rm -f ./bash/kern')
      call system('rm -f ./bash/kernel')
      call system('rm -f ./bash/kernel1')
      call system('rm -f ./bash/quote')
      call system('rm -f ./bash/kernel2.4')
      call system('rm -f ./bash/line')
      call system('rm -f ./bash/machine')
      call system('rm -f ./bash/machtype')
      call system('rm -f ./bash/mail_detected')
      call system('rm -f ./bash/mutt_detected')
      call system('rm -f ./bash/name')
      call system('rm -f ./bash/number')
      call system('rm -f ./bash/pingres')
      call system('rm -f ./bash/res')
      call system('rm -f ./bash/user')
      call system('rm -f ./bash/wc_str')
      call system('rm -f ./bash/shell')
      call system('rm -f ./bash/pwd')

      return
      end




      subroutine erase_temporary_final()
      implicit none

      call system('rm -f ./bash/date')
      call system('rm -f ./bash/epoch')
      call system('rm -f ./bash/init')
      call system('rm -f ./bash/n_list')
      call system('rm -f ./bash/overwrite_init_line.class')
      call system('rm -f ./bash/overwrite_progress_line.class')
      call system('rm -f options_en1.txt')
      call system('rm -f options_en2.txt')
      call system('rm -f data_en1.txt')
      call system('rm -f data_en2.txt')
      call system('rm -f ')
      call system('rm -f ')
      call system('rm -f ')
      call system('rm -f ')




      return
      end




      subroutine make_config()
      implicit none
      include 'email.inc'
c     Cette routine va crer le fichier de prfrences utilisateur
c     lors de la premire utilisation de Karine
      integer outm,a1,strlen
      character*1 ans
      character*100 command

      call detect_mail(outm) ! dtection de la commande "mail"

      if (outm.eq.1) then
         write(*,*)
         write(*,*) 'You may contribute to the development of Karine'
         write(*,*) 'by allowing this code to send relevant information'
         write(*,*) 'to the author by email. No personal information'
         write(*,*) 'will be sent. Karine will only send what is'
         write(*,*) 'needed for debugging and improving the code.'
         write(*,*) 'If you enable this feature, ou will also need to'
         write(*,*) 'give a valid email address, so that you can be'
         write(*,*) 'contacted whenever critical updates are released.'
         write(*,*)
 123     continue
         write(*,*) 'Do you want to enable this feature ? (y/n)'
         read(*,*) ans
         if ((ans.ne.'y').and.(ans.ne.'n')) then
            write(*,*) 
            write(*,*) 'Incorrect answer - retrying'
            goto 123
         endif
         write(*,*)
         if (ans.eq.'y') then
            a1=1
            write(*,*) 'You chose to send information by email'
 122        continue
            write(*,*) 
            write(*,*) 'In order to stay informed about new versions,'
            write(*,*) 'please fill in your email address below.'
            write(*,*) 'If you do not want to give your email address,'
            write(*,*) 'type any character string.'
            read(*,*) user_email
            write(*,*)
 124        continue
            write(*,*) 'Is this email address correct (y/n) ?'
            read(*,*) ans
            if ((ans.ne.'y').and.(ans.ne.'n')) then
               write(*,*) 
               write(*,*) 'Incorrect answer - retrying'
               goto 124
            endif
            if (ans.eq.'n') then
               goto 122
            endif
            write(*,*) 'Thank you very much, you have been added'
            write(*,*) 'to the mailing list'
         else
            a1=0
            user_email='user@domain'
            write(*,*) 'You chose not to send any email'
         endif
         write(*,*)
         write(*,*) 'You can change your settings at any time'
         write(*,*) 'by editing the following configuration file:'
         write(*,*) './config/configure.txt'
         write(*,*)
      else
         a1=0
         user_email='user@domain'
      endif

      open(14,file='./config/a1')
      write(14,*) a1
      close(14)
      open(15,file='./config/a2')
      write(15,*) user_email(1:strlen(user_email))
      close(15)

      command='cd ./config; cat tmp1 a1 tmp2 a2 tmp3 > configure.txt'
      call system(command(1:strlen(command)))
      command='rm -f config/tmp* config/a*'
      call system(command(1:strlen(command)))

      return
      end


      subroutine read_config(sma)
      implicit none
      include 'email.inc'
      integer i,ios,strlen
      integer iostmp1,iostmp2,iostmp3
      integer sma

      open(19,file='./config/configure.txt',status='old',iostat=ios)
      if (ios.ne.0) then        ! fichier 'configure.txt' pas trouv
         close(19)
         write(*,*) 'File "./config/configure.txt" could not be opened'
         write(*,*) '...'
c     Vrification de la prsence des 3 fichiers ncessaires  la production
c     de "configure.txt"
         open(16,file='./config/tmp1',status='old',iostat=iostmp1)
         close(16)
         open(17,file='./config/tmp2',status='old',iostat=iostmp2)
         close(17)
         open(18,file='./config/tmp3',status='old',iostat=iostmp3)
         close(18)
c     Si 1 des 3 fichiers est absent
         if ((iostmp1.ne.0).or.(iostmp2.ne.0).or.(iostmp3.ne.0)) then
            write(*,*) 'Impossible to regenerate "configure.txt"'
            write(*,*) 'You will have to reinstall Karine from source'
            write(*,*) 'or contact the author by email:'
            write(*,*) author_email(1:strlen(author_email))
            stop
c     Si les 3 fichiers sont encore l
         else
            write(*,*) '"./config/configure.txt" will be regenerated'
            write(*,*) '...'
            call make_config()
            open(19,file='./config/configure.txt')
         endif
      endif

      do i=1,12
         read(19,*)
      enddo
      read(19,*) sma
      do i=1,4
         read(19,*)
      enddo
      read(19,*) user_email
      close(19)

 123  continue
      return
      end




      subroutine detect_first_use()
      implicit none
      integer ios
      include 'options.inc'
c     Cette routine dtecte la premire utilisation de KARINE
      apc=1
      open(10,file='./temporary/coupure.dat', status='old', iostat=ios)
      if (ios.ne.0) then ! fichier './temporary/coupure.dat' n'existe pas => premire utilisation
         close(10)
c     Cration du fichier './temporary/coupure.dat'
         open(11,file='./temporary/coupure.dat',status='new')
         write(11,*) 1
         close(11)
c     Affichage d'un petit message sympa...
         call screen(29,0,0,0.0D+0,0.0D+0)
c     Et production du fichier de configuration
         call make_config()
      else
         close(10)
      endif

      return
      end



      subroutine overwrite_progress_line(number)
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer number

      open(53,file='./bash/number')
      write(53,*) number
      write(53,*) m
      close(53)
      call system('cd ./bash; java overwrite_progress_line number')

      return
      end



      subroutine overwrite_init_line(number)
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer number

      open(54,file='./bash/init')
      write(54,*) number
      write(54,*) nb_min
      write(54,*) nb_max
      close(54)
      call system('cd ./bash; java overwrite_init_line init')

      return
      end



      subroutine set_file(dir,file)
      implicit none
      character*200 dir,file,file_in,file_out
      character*1 first_char,slash
      integer strlen,strsz_dir

      file_in=file
      slash="/"
      first_char=file_in(1:1)
c     Debug
c      write(*,*) 'This is set_file'
c      write(*,*) 'First character= ',first_char
c      write(*,*) 'slash= ',slash
c     Debug
      if (first_char.eq.slash) then
         file_out=file_in
      else
         file_out=dir(1:strlen(dir))//
     &        slash(1:strlen(slash))//
     &        file_in(1:strlen(file_in))
      endif
      file=file_out
c     Debug
c      write(*,*) 'file_out=',file_out
c      write(*,*) 'End of set_file'
c     Debug

      return
      end


c     sensitivities...
      subroutine init_sum_dpsidT(sum_dpsidT)
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer i,j,p
      double precision sum_dpsidT(0:Nmax+1,0:Nmax+1,0:Nmax+1)

      do p=0,m+1
         do i=0,m+1
            do j=0,m+1
               sum_dpsidT(i,j,p)=0.0D+0
            enddo               ! j
         enddo       
      enddo                     !p

      return
      end
c     ...sensitivities



c     sensitivities...
      subroutine init_dksi_dTg(Nb,dksi_dTg)
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer i,j,p,band,Nb
      double precision dksi_dTg(0:Nmax+1,0:Nmax+1,0:Nmax+1,1:Nbmx)

      do band=1,Nb
         do p=0,m+1
            do i=0,m+1
               do j=0,m+1
                  dksi_dTg(i,j,p,band)=0.0D+0
               enddo            ! j
            enddo               ! i
         enddo                  ! p
      enddo                     ! band

      return
      end
c     ...sensitivities


c     sensitivities...
      subroutine init_dFnet_dT(dFnet_dT)
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer i,p
      double precision dFnet_dT(0:Nmax,0:Nmax+1)

      do p=0,m+1
         do i=0,m
            dFnet_dT(i,p)=0.0D+0
         enddo ! i
      enddo ! p
      
      return
      end
c     ...sensitivities


c     sensitivities...
      subroutine init_dbudget_dT(dbudget_dT)
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer i,p
      double precision dbudget_dT(0:Nmax+1,0:Nmax+1)

      do p=0,m+1
         do i=0,m+1
            dbudget_dT(i,p)=0.0D+0
         enddo ! i
      enddo ! p
      
      return
      end
c     ...sensitivities


c     sensitivities...
      subroutine init_dner_dT(dner_dT_band)
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer i,j,p
      double precision dner_dT_band(0:Nmax+1,0:Nmax+1,0:Nmax+1)

      do p=0,m+1
         do i=0,m+1
            do j=0,m+1
               dner_dT_band(i,j,p)=0.0D+0
            enddo               ! j
         enddo                  ! i
      enddo                     ! p

      return
      end
c     ...sensitivities


c     sensitivities...
      subroutine init_dner_dx(nspecies,dner_dx_band)
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer i,j,p,ispecies,nspecies
      double precision dner_dx_band(0:Nmax+1,0:Nmax+1,0:Nmax+1,1:Nsmx)
      
      do ispecies=1,nspecies
         do p=0,m+1
            do i=0,m+1
               do j=0,m+1
                  dner_dx_band(i,j,p,ispecies)=0.0D+0
               enddo            ! j
            enddo               ! i
         enddo                  ! p
      enddo                     ! ispecies

      return
      end
c     ...sensitivities



      subroutine update_ner(ner,coeff,ner_band)
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer i,j,p
      double precision coeff
      double precision ner(0:Nmax+1,0:Nmax+1)
      double precision ner_band(0:Nmax+1,0:Nmax+1)

      do i=0,m+1
         do j=0,m+1
            ner_band(i,j)=ner_band(i,j)+
     &           ner(i,j)*coeff ! W/m
         enddo                  ! j
      enddo                     ! i

c     Debug
c      write(*,*) 'ner(0,1)=',ner(0,1)
c      write(*,*) 'ner_band(0,1)=',ner_band(0,1)
c      write(*,*) 'coeff=',coeff
c     Debug

c     Debug
c      do i=0,m+1
c         do j=0,m+1
c            write(*,*) 'PNE(',i,',',j,')=',ner(i,j)
c         enddo                  ! j
c      enddo                     ! i
c      stop
c     Debug
      
      return
      end



      subroutine update_budgets(k,nbw,psi,psih,psib,
     &     psi_gg,psi_gp,psi_gs,psi_ge,
     &     psi_b,psi_b_gg,psi_b_gp,psi_b_gs,psi_b_ge,
     &     tpsi,tpsi_gg,tpsi_gp,tpsih,tpsib,sum_psi,sum_psih,sum_psib)
      implicit none
      include 'max.inc'
      include 'data.inc'

      integer i,k
      double precision nbw
      double precision psi(0:Nmax+1,1:Kmax)
      double precision psih(0:Nmax+1,1:Kmax)
      double precision psib(0:Nmax+1,1:Kmax)
      double precision psi_gg(0:Nmax+1,1:Kmax)
      double precision psi_gp(0:Nmax+1,1:Kmax)
      double precision psi_gs(0:Nmax+1,1:Kmax)
      double precision psi_ge(0:Nmax+1,1:Kmax)

      double precision tpsi(0:Nmax+1)
      double precision tpsih(0:Nmax+1)
      double precision tpsib(0:Nmax+1)
      double precision tpsi_gg(0:Nmax+1)
      double precision tpsi_gp(0:Nmax+1)
      double precision psi_b(0:Nmax+1)
      double precision psi_b_gg(0:Nmax+1)
      double precision psi_b_gp(0:Nmax+1)
      double precision psi_b_gs(0:Nmax+1)
      double precision psi_b_ge(0:Nmax+1)
      double precision sum_psi(0:Nmax+1)
      double precision sum_psih(0:Nmax+1)
      double precision sum_psib(0:Nmax+1)

c     Calcul des bilans par bande en mW/m3/cm-1
      do i=1,m
         psi_b(i)=psi_b(i)+1.0D+3*psi(i,k)
         psi_b_gg(i)=psi_b_gg(i)+1.0D+3*psi_gg(i,k)
         psi_b_gp(i)=psi_b_gp(i)+1.0D+3*psi_gp(i,k)
         psi_b_gs(i)=psi_b_gs(i)+1.0D+3*psi_gs(i,k)
         psi_b_ge(i)=psi_b_ge(i)+1.0D+3*psi_ge(i,k)
      enddo
      do i=0,m+1
         tpsi(i)=tpsi(i)+psi(i,k)*nbw ! mW/m
         tpsi_gg(i)=tpsi_gg(i)+psi_gg(i,k)*nbw ! mW/m
         tpsi_gp(i)=tpsi_gp(i)+psi_gp(i,k)*nbw ! mW/m
         tpsih(i)=tpsih(i)+psih(i,k)
         tpsib(i)=tpsib(i)+psib(i,k)
         sum_psi(i)=sum_psi(i)+dabs(psi(i,k))
         sum_psih(i)=sum_psih(i)+dabs(psih(i,k))
         sum_psib(i)=sum_psib(i)+dabs(psib(i,k))
      enddo
      
      return
      end


c     sensitivities...
      subroutine update_dner_dT(dner_dT,coeff,dner_dT_band)
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer i,j,p
      double precision coeff
      double precision dner_dT(0:Nmax+1,0:Nmax+1,0:Nmax+1)
      double precision dner_dT_band(0:Nmax+1,0:Nmax+1,0:Nmax+1)

      do p=0,m+1
         do i=0,m+1
            do j=0,m+1
               dner_dT_band(i,j,p)=dner_dT_band(i,j,p)+
     &              dner_dT(i,j,p)*coeff ! W/m/K
            enddo               ! j
         enddo                  ! i
      enddo                     ! p
      
      return
      end
c     ...sensitivities



c     sensitivities...
      subroutine update_dner_dx(dner_dx,coeff,ispecies,
     &     dner_dx_band)
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer i,j,p,ispecies
      double precision coeff
      double precision dner_dx(0:Nmax+1,0:Nmax+1,0:Nmax+1)
      double precision dner_dx_band(0:Nmax+1,0:Nmax+1,0:Nmax+1,1:Nsmx)

      do p=0,m+1
         do i=0,m+1
            do j=0,m+1
               dner_dx_band(i,j,p,ispecies)=
     &              dner_dx_band(i,j,p,ispecies)+
     &              dner_dx(i,j,p)*coeff ! W/m/[x]
            enddo               ! j
         enddo                  ! i
      enddo                     ! p
      
      return
      end
c     ...sensitivities



c     sensitivities...
      subroutine update_dksi_dx(Tcentre,band,nbw,
     &     dner_dx_band,ispecies,dksi_dx_band)
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer i,j,p,ispecies,band
      double precision Tcentre(0:Nmax+1)
      double precision nbw(1:Nbmx)
      double precision Bi_ref,Bj_ref,Planck
      double precision dner_dx_band(0:Nmax+1,0:Nmax+1,0:Nmax+1,1:Nsmx)
      double precision dksi_dx_band(0:Nmax+1,0:Nmax+1,0:Nmax+1,1:Nsmx)

      do i=0,m+1
         Bi_ref=Planck(Tcentre(i),lambda_lo(band),lambda_hi(band)) ! W/m/sr/m
         do j=0,m+1
            Bj_ref=Planck(Tcentre(j),lambda_lo(band),lambda_hi(band)) ! W/m/sr/m
            do p=0,m+1
               dksi_dx_band(i,j,p,ispecies)=
     &              dner_dx_band(i,j,p,ispecies)
     &              /(Bi_ref-Bj_ref)
     &              /nbw(band)  ! sr.m/(#/cm)
            enddo ! p
         enddo ! j
      enddo ! i
      
      return
      end
c     ...sensitivities



c     sensitivities...
      subroutine update_sum_dpsidT(dner_dT_band,sum_dpsidT)
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer i,j,p
      double precision dner_dT_band(0:Nmax+1,0:Nmax+1,0:Nmax+1)
      double precision sum_dpsidT(0:Nmax+1,0:Nmax+1,0:Nmax+1)

c     Sum of d(NER)/d(T)
      do p=0,m+1
         do i=0,m+1
            do j=0,m+1
               sum_dpsidT(i,j,p)=sum_dpsidT(i,j,p)+
     &              dner_dT_band(i,j,p) ! W/m/K
            enddo               ! j
         enddo                  ! i
      enddo                     ! p

      return
      end
c     ...sensitivities


c     sensitivities...
      subroutine update_dFnet_dT(nbw,dFnet_dT_band,dFnet_dT)
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer i,p
      double precision nbw
      double precision dFnet_dT_band(0:Nmax,0:Nmax+1)
      double precision dFnet_dT(0:Nmax,0:Nmax+1)
      
      do p=0,m+1
         do i=0,m
            dFnet_dT(i,p)=dFnet_dT(i,p)+dFnet_dT_band(i,p)*nbw
         enddo                  ! i
      enddo                     ! p

      return
      end
c     ...sensitivities


c     sensitivities...
      subroutine update_dbudget_dT(dbudget_dT_band,dbudget_dT)
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer i,p
      double precision dbudget_dT_band(0:Nmax+1,0:Nmax+1)
      double precision dbudget_dT(0:Nmax+1,0:Nmax+1)
      
      do p=0,m+1
         do i=0,m+1
            dbudget_dT(i,p)=dbudget_dT(i,p)+dbudget_dT_band(i,p)
         enddo                  ! i
      enddo                     ! p

      return
      end
c     ...sensitivities



c     sensitivities...
      subroutine update_dksi_dTg(Tcentre,band,nbw,
     &     dner_dT,ner_band,dksi_dTg)
      implicit none
      include 'max.inc'
      include 'data.inc'
      integer i,j,p,band
      double precision lambda
      double precision nbw(1:Nbmx)
      double precision Planck,dBdT
      double precision func_dTi_dTp
      double precision Bi_ref,Bj_ref
      double precision dBdTi_ref,dBdTj_ref
      double precision dTi_dTp,dTj_dTp
      double precision dDeltaB_dTp
      double precision Tcentre(0:Nmax+1)
      double precision dner_dT(0:Nmax+1,0:Nmax+1,0:Nmax+1)
      double precision ner_band(0:Nmax+1,0:Nmax+1)
      double precision dksi_dTg(0:Nmax+1,0:Nmax+1,0:Nmax+1,1:Nbmx)
c     --------------------------------------------------------------------------------------------------------
c     This routine will compute dksi(i,j)/dT(p) for a given narrowband interval 'band'
c
c     Inputs:
c       + Tcentre: array of temperature at the center of each gas layer:
c                       . Tcentre(0)=ground temperature
c                       . Tcentre(i)=central temperature of gas layer i, i=1,m
c                       . Tcentre(m+1)=temperature of space
c       + band: index of the narrowband interval [1,Nb]
c       + nbw: array of narrowband widths, in cm; nwb(1) is for minimum wavelength side of the spectrum
c       + dner_dT: matrix of dNER(i,j)/dT(p) for the given narrowband; is given in W/m/K
c       + ner_band: matrix of NER for the given narrowband; is given in W/m
c     
c     Outputs:
c       + dksi_dTp: matrix of dksi(i,j,band)/dT(p), in sr.m/cm/K
c     --------------------------------------------------------------------------------------------------------
      lambda=(lambda_lo(band)+lambda_hi(band))/2.0D+0
      do p=0,m+1
         do i=0,m+1
            Bi_ref=Planck(Tcentre(i),lambda_lo(band),lambda_hi(band)) ! W/m/sr/m
            dBdTi_ref=dBdT(Tcentre(i),lambda) ! W/m/sr/m/K
            dTi_dTp=func_dTi_dTp(i,p)
            do j=0,m+1
               Bj_ref=Planck(Tcentre(j),lambda_lo(band),lambda_hi(band)) ! W/m/sr/m
               dBdTj_ref=dBdT(Tcentre(j),lambda) ! W/m/sr/m/K
               dTj_dTp=func_dTi_dTp(j,p)
               if ((i.eq.j).or.(Bi_ref.eq.Bj_ref)) then
                  dksi_dTg(i,j,p,band)=0.0D+0
               else
                  dDeltaB_dTp=dBdTi_ref*dTi_dTp-dBdTj_ref*dTj_dTp ! W/m/sr/m/K
                  dksi_dTg(i,j,p,band)=((Bi_ref-Bj_ref)* ! W/m/sr/m
     &                 dner_dT(i,j,p)- ! *W/m/K
     &                 ner_band(i,j)*dDeltaB_dTp) ! =(W/m)/sr/m/K
     &                 /(Bi_ref-Bj_ref)**2 ! / (W/m/sr/m)
     &                 /nbw(band) ! / cm
c     [dksi_dTg]=[sr.m/cm/K]
               endif
            enddo               ! j
         enddo                  ! i
      enddo                     ! p

      return
      end
c     ...sensitivities



      subroutine file_size(file_name,size,b,k,m,g)
      implicit none
      integer b,k,m,g
      integer sizeb,strlen,kb,mb,gb
      double precision size
      character*100 command,file_name
      
      kb=1024 ! bytes
      mb=1024*kb ! bytes
      gb=1024*mb ! bytes
      b=0
      k=0
      m=0
      g=0

      command='du -b -D'
      command=command(1:strlen(command))//
     &     ' '//file_name(1:strlen(file_name))
      command=command(1:strlen(command))//
     &     ' > ./temporary/t'
      call system(command(1:strlen(command)))

      open(10,file='./temporary/t')
      read(10,*) sizeb
      close(10)
      
      call system('rm -f ./temporary/t')
      if (sizeb.lt.kb) then
         size=dble(sizeb) ! bytes
         b=1
      else if (size.lt.mb) then
         size=dble(sizeb)/dble(kb) ! kb
         k=1
      else if (size.lt.gb) then
         size=dble(sizeb)/dble(mb) ! Mb
         m=1
      else
         size=dble(size)/dble(gb) ! Gb
         g=1
      endif
     
      return
      end



      subroutine gzip_atmosdata()
      implicit none
      character*100 command

      command='cp ./data/atmos_data.txt ./temporary/atmos_data.txt'
      call system_command(command)
      command='gzip ./temporary/atmos_data.txt'
      call system_command(command)

c     Debug
c      write(*,*) 'ok'
c      stop
c     Debug

      return
      end
